2026.08.02
  - Debugger: normalize 16-bit segmented offsets for address display/lookup and
    avoid false "[illegal]" memory operand reports in AnalyzeInstruction()
    (cimarronm)
  - Fixed character rendering and mouse cursor display in DOS/V Japanese mode.
    (nanshiki)
  - Fixed build error of OSFREE release builds (maron2000)
  - Added floppy BPB sanity check, and rearranged existing floppy BPB check code
    (maron2000)
  - Fixed window resizing (OpenGL, SDL2) (misty7666)
  - Updated Nuked-OPL3-fast to v1.8-fast.3 (tgies)
  - Added support for nested subdirectories in Z drive (maron2000)
  - Added experimental "ethnet" command and protocol for NE2000 emulation. Instead
    of using the pcap promiscious mode, which doesn't work over Wi-fi, a client
    server setup can be configured to emulate a private lan between instances of
    DOSBox-X either on localhost or on the local area network. The ethnet command
    is deliberately built so that client and server set up is the same command
    structure as the "ipx" command used to set up an IPX network in DOSBox and
    DOSBox-X. (joncampbell123)
  - FAT driver performance improvements, at least for directory enumeration,
    file creation, reading, and writing (joncampbell123).
  - Added PC3270 and Olivetti machine types (firevaran).
  - Fixed fatDrive error paths so truncated boot-sector reads no longer look
    like successful mounts, and early returns now close diskfile handles
    instead of leaking them. (cimarronm)
  - INT 33h: In PC-98 mode, do not maintain a hide/show display count to match
    real mouse driver behavior (nanshiki)

2026.07.02
  - Prepare for release. This time release OSFREE first so that the normal
    version appears first on GitHub.
  - Correct MMX FPU exception behavior: #UD if EM bit set, else #NM if TS bit 
    set (joncampbell123)
  - Cleanup PMULLW, enforce missing Pentium III requirement for one 
    instruction, and add code to every MMX instruction to set FPU top of stack
    to zero as a) documented by Intel b) implemented by Bochs and PCBox already
    (joncampbell123)
  - Fixed PMULLW signedness issues. (bachimusprime)
  - MMX instructions set top of stack == 0 and all tags to available. 
    (joncampbell123)
  - EMMS no need to set FPU tags to valid, then set them to empty.
    (joncampbell123)
  - Move MMX register into FPU_Reg_80 where the X86 FPU emulation is storing 
    state so that the MMX/FPU overlap can emulate properly. This fixes FPU/MMX 
    bugs with Windows ME and Windows Media Player (joncampbell123)
  - FPU: make p_regs and regs_80 an anonymous union to reduce memory use and to
    make switching between dynamic and normal core easier (joncampbell123)
  - Fixed savestate format incompatibility between MSVC and MinGW builds.
    (AleWin32)
  - gui/sdl_mapper: Fixed startup crash with joysticks reporting >1 hat switch
    (BoykoNeov)
  - Extend MMX_reg to include FPU exponent field. (joncampbell123)
  - Fixed MMX instructions write to FPU registers and set the exponent field to
    all 1s as documented by Intel. (joncampbell123)
  - Undo CMPXCHG8B revision (joncampbell123)
  - Fixed FPU_Reg_80 size (cimarronm)
  - Added Nuked-CQM support to OPL emulation. (maron2000)
  - macOS: Build OSFREE nightly builds (maron2000)
  - D3D11: Fix Aspect ratio and Window size was not reflected when returning
    from fullscreen mode (maron2000)
  - Debugger: fix F11 (trace into next instruction) collision being swallowed 
    by Windows Terminal (AleWin32) 
  - Removed output option stubs that have been deprecated removed long ago. 
    (maron2000)
  - Don't signal video mem write for S3 MMIO (joncampbell123)
  - Revise mem handler (joncampbell123)
  - qcow2: Set logical (BIOS) CHS instead of physical (IDE) CHS when mounted
    with Drive numbers. (maron2000)
  - Debugger: fix F11 (trace into next instruction) collision being swallowed
    by Windows Terminal (AleWin32)
  - MSCDEX UpdateDrive subUnit param is never changed and does not need to be a 
    reference (joncampbell123)
  - IDE: Add boolean to mark whether CD-ROM emulation is drawing from MSCDEX.
    (joncampbell123)
  - IMGMOUNT::Unmount(): Add device spec parsing and cleanup drive letter/spec
    parsing in general. Device spec such as ":ide:1m" will allow mounting a CD-
    ROM image directly to IDE emulation without ever attaching it to a drive
    letter or MSCDEX emulation (joncampbell123)
  - FindCommand():
      Add remove parameter, so that it is possible in one step to read a cmd
      arg and remove it.
      Fix printf formatting for message.
      Add debug dump for CommandLine object.
  - Add CommandLine method to check if a command arg exists, IMGMOUNT should
    use that instead of calling FindCommand() just to get a string and then
    throw it away to check if it exists (joncampbell123)
  - Drive letter can be "*" for FAT driver, update (joncampbell123)
  - IMGMOUNT:
      Use tdr for drive letter/number, do not call FindCommand() again to re-
      read the drive letter/number
      Use new FindCommand/EraseCommand methods to simplify file parsing
      Use tdr and not temp_line for fstype auto and "*" drive (joncampbell123)
  - DOS_SetDefaultDrive() do not do anything if DOS kernel disabled 
    (joncampbell123)
  - MSCDEX: CDROM_AllocateInterface does not need to modify the path, and it
    never does, change path param to const char * which also allows the use of
    std::string().c_str() with it. Add device spec ISO mounting, though only
    the CD-ROM image loading and unloading at this time (joncampbell123)
  - IDE device spec mount, ISO only (joncampbell123)
  - IDE device spec CD-ROM swaplist with connection to Swap CD mapper shortcut
    (joncampbell123)
  - IDE ATAPI CDROM swaplist, if multiple CD images (joncampbell123)
  - IMGMOUNT -u with IDE device spec (joncampbell123)
  - IDE opt parse spec common function (joncampbell123)
  - Revise various dropdown menu (joncampbell123)
  - List all outputs, even ones not supported on the target platform, so that
    the reference config files can list them all. Add comment on what output
    code is expected to do for unsupported outputs (joncampbell123)
  - Make the "DOS kernel shutdown do not touch MCB" flag unnecessary by 
    allowing BOOT to provide the boot code as data to load later, after DOS
    kernel shutdown, and force CPU back into real mode after DOS kernel shutdown
    (joncampbell123)
  - CD-ROM image allocation should free existing pointer it is about to replace.
    (joncampbell123)
  - Show OSFREE in the title and help message to distinguish OSFREE builds.
    (maron2000)
  - List direct IDE mounts under the Drives menu (joncampbell123)
  - Fixed possible boot failure when booted from "Boot from disk image" menu.
    (maron2000)
  - Fixed dialog box didn't show when an ISO was mounted via dropdown menu.
    (maron2000)
  - Define IDE functions used elsewhere in the header file, cleanup
    (joncampbell123)
  - IDE: Move CD clearing into a method (joncampbell123)
  - IDE device mount --replace support (joncampbell123)
  - IDE menu unmount and swap commands. Update Eject handling to support :ide:
    device mounts (joncampbell123)
  - IDE: On attach or detach directly, update the IDE drive menu 
    (joncampbell123)
  - Fix IDEDrive menu item naming, add code to allow mounting an ISO image or
    images directly from the menu for IDE device mounts (joncampbell123)
  - printer.cpp: Fixed various printer emulation issues (maron2000)
     Fixed handling of variable_length command
     Fixed a typo in ESC S command
     Skip DBCS processing for bit graphic data
     Fixed advancing cell position of DBCS characters
  - BOOT: Store the SS:SP values in a var, have sdlmain.cpp set them when 
    booting the guest OS. For IBM PC booter games, set SS:SP = 0x30:0x100
    instead of 0x30:0x80. The smaller value cause Shamus to crash and was coded
    based on a misunderstanding of the IBM PC BIOS source code (joncampbell123)
  - COMMAND.COM emulation: After running an MS-DOS executable, set reg_al to
    the error code returned by the DOS program. This fixes Microsoft Flight
    Simulator 5.1 setup.com (joncampbell123)
  - COMMAND.COM emulation: Free memory on shutdown only if and only if 
    instructed by the shell start code that creates the initial shell, or the
    config shell. For any other case, trust that we were run as a DOS program
    and that INT 21h AH=4Ch will free the process memory normally.
    (joncampbell123)
  - Disabled formatting lockouts, which allows SubLogic Flight Simulator II to
    run (joncampbell123)
  - Disabled IBM PC geometry translation for PC-98 mode. PC-98 HDI images must
    not do geometry translation, it breaks things (joncampbell123)
  - INGMOUNT: If mounting a floppy to drive A or B, make sure the disk change
    signal is cleared so that INT 13h works as expected, same as DOSBox SVN,
    Staging, and any other fork others use (joncampbell123)
  - Fixed geometry detection of host folder converted drives (maron2000)
  - Added another heuristic to detect QCOW2 image geometry. (caiiiycuk)
  - FPU: Set exception flags in some FPU commands in double precision
  - Fixed a character encoding issue with 0xe0 on non-PC-98 systems. (misty7666)
  - SDL2: Remove deleted file (yuv_rgb.c). (maron2000)
    
2026.06.02
  - Feature: Add 'Send Alt+SysRq/PrtScr' menu item (AleWin32)
  - DOS file search bugfix: Prevent undefined stat_block usage on failed
    ht_stat() calls. Use a separate variable for special file attribute
    checks to avoid reusing stat_block when it contains garbage values.
    This fixes issues on latest Darwin kernels. (cimarronm)
  - Added function to config to load MS-DOS device drivers. The command is
    config -device <device driver path> -devparm <parameters>. For example,
    to load OAKCDROM.SYS into memory, you could type:

    config -device C:\DOS\OAKCDROM.SYS -devparm "/D:CD001"

    which is equivalent to the DEVICE line in CONFIG.SYS:

    DEVICE=C:\DOS\OAKCDROM.SYS /D:CD001

    The goal is that DOSBox-X would fully support, through INT 21h and
    other interfaces, real device drivers instead of hard coding specific
    driver emulation. INT 21h would use the actual device chain instead
    of a built-in list. Built-in device emulation could appear properly
    in the device chain instead of fake entries.

    There seems to be interest on the DOSBox-X discussion and issue trackers
    of getting DOSBox-X to provide or emulate the MS-DOS/Windows 95 IFS
    driver to get Windows 95 to boot from a disk image in the native DOSBox-X
    environment, perhaps this would help enable that.

    At this time (in development), only INIT is called. (joncampbell123)
  - External DOS device driver read/write: Optimize I/O by using larger
    read/write transfers (currently 16 based on how much memory is allocated
    for device driver I/O request and data). Until this change, the code
    used an extremely inefficient 1-byte read/write method to transfer
    to or from the device driver. (joncampbell123)
  - DOS execute bugfix: While ownership was properly listed in the MCB for
    the PSP segment, the environment block associated with the program was
    always listed in the MCB as belonging to the parent process. This has
    been addressed (joncampbell123)
  - Fix INT 21h AH=3Fh/40h READ/WRITE processing, when talking to an external
    MS-DOS device driver, so that the bytes actually processed by the driver
    are returned in AX to the DOS program, instead of giving the DOS program
    the impression that all were processed when they may not have been. (joncampbell123)
  - CD Audio: Fix track not advancing at end of playback (maron2000)
  - Fix geometry detection of qcow2 images (maron2000)
  - Fixed advanced scaler rendering artifacts when machine type is MDA,
    Hercules, CGA, EGA, Tandy, or PCjr, or when SVGA 15/16bpp SVGA modes
    are active. CGA/EGA with Advanced MAME 2x/3x and HQ2X scalers should
    render correctly now. (joncampbell123)
  - Added dosbox.conf [devices] section, which functions much like the
    DEVICE= lines in CONFIG.SYS to load MS-DOS device drivers at startup.
    Added support for RUN= lines to run commands like IMGMOUNT to help
    set up drive mounts and CD-ROM devices, or any other diagnostic
    purpose. While RUN= works just like the command shell, it is not
    intended to be a general command shell for running DOS games or
    applications that are unrelated to system startup. Added debugging
    options like ECHO which echo the command about to be run, and
    DEBUGBREAK which breaks into the debugger when starting the program
    or device driver. (joncampbell123)
  - Added code to device driver loading which will, where possible,
    attempt to load the device driver as low as possible and pack it into
    the DOS kernel below the start of the MCB chain to resemble how
    device drivers are loaded in MS-DOS. (joncampbell123)
  - Added debugger command "DOS DEVS" to list and enumerate the device
    drivers in the DOS kernel. Added code to BOOT --boothax msdos to
    track the location of the device driver list in the guest MS-DOS
    kernel so "DOS DEVS" can work there as well. (joncampbell123)
  - DOSBox-X shell will now free any memory it allocated and close files
    that were opened on shutdown. This is important so that the CONFIG
    shell (used for loading device drivers) does not leave behind
    any memory it allocated when transferring control to the main
    command shell. However, do NOT release memory and do NOT close files
    on shell shutdown if the reason for the shutdown is the BOOT command.
    By the time normal shutdown occurs, the BOOT command has already
    overwritten low memory (and the MCB chain) with the guest OS's boot
    code, therefore freeing shell memory in that cause would only cause
    a complaint about a corrupted MCB chain and emulator E_Exit() shutdown.
    (joncampbell123)
  - Fixed VHD, qcow2 image geometry calculation (maron2000)
  - Fix CONFIG vs DOS shell to ensure the welcome screen is printed first
    before anything else on the console during startup. This is to help
    keep any output from programs and device drivers on screen where
    the user can see it (joncampbell123)
  - Add basic support for MS-DOS block device drivers. If a block device
    driver succeeds, set up a disk image object and attach it to the
    FAT filesystem driver, and then a drive letter. At this time, this
    is enough for Microsoft RAMDRIVE.SYS to load and appear as a working
    drive letter in DOSBox-X (joncampbell123)
  - CD-ROM device emulation is no longer strictly tied to MSCDEX emulation.
    While devices are still initialized through MSCDEX emulation, it is now
    possible for other parts of emulation to own a reference to it without
    MSCDEX. This means it is now possible for CD-ROM emulation to work
    after booting a guest OS without reaching back through MSCDEX emulation,
    and MSCDEX emulation can now unload properly with the rest of the DOS
    kernel. (joncampbell123)
  - Fix bug where El Torito no emulation boot failed to notify the DOS
    kernel that the MCB chain is no longer valid, causing MCB chain corruption
    crashes. (joncampbell123)
  - Added checks to sector I/O code to fix potential buffer overrun issues.
    (orbisai0security)
  - Fixed logging of 'Packed file is corrupt' message detection (maron2000)
  - Fixed upper 32-bit of LBA was always cleared (maron2000)
  - Fix and revise MSCDEX and CD-ROM emulation to disentangle the two,
    so that MSCDEX no longer needs to remain in the background when BOOTed
    into a guest OS for IDE emulation to work. (joncampbell123)
  - CD-ROM emulation updated to use reference counting to improve sharing
    of the image between IDE, MSCDEX, and general CD-ROM emulation.
    IDE emulation can hold on to a reference instead of constantly asking
    MSCDEX for it. (joncampbell123)
  - Fix bug where mounting an invalid CUE file with no tracks caused DOSBox-X
    to crash. (joncampbell123)
  - MSCDEX and CD-ROM emulation: Cleanup and centralize creation of CD-ROM
    interface objects, including the creation of the fake "empty" special
    interface used to emulate an empty CD-ROM drive. (joncampbell123)
  - Revise MSCDEX emulation to separate the CD-ROM subunit and drive tracking
    from MSCDEX itself so that state can persist properly for a guest OS
    even when MSCDEX is shutdown during BOOT. (joncampbell123)
  - Add -replace option to IMGMOUNT to allow changing the ISO image assigned
    to a CD-ROM drive without changing or altering the drive letter already
    assigned. -replace is strictly limited to CD-ROM drives where the drive
    letter is already assigned to that drive letter. (joncampbell123)
  - Clean up the Drives menu for any drive letter assigned to a CD-ROM drive.
    Enable the "Mount a disk or CD image file" and "Mount multiple disk/CD images"
    even if the drive letter already has a CD-ROM drive attached, in which case
    the menu item just replaces it. Allow these menu items to work even when
    running a guest OS so that Windows 95 users can load any ISO image they
    want at any time, instead of having to pre-load all images they will need
    on a swap chain before BOOT. (joncampbell123)
  - Replace ISO mounting code from the menu item to call more directly into
    IMGMOUNT to avoid making a commad shell object which would probably interfere
    with the guest OS. (joncampbell123)
  - Enable the "Unmount drive" menu option under Drives for any drive attached
    to a CD-ROM drive while running a guest OS like Windows 95. When used in
    that scenario, it does not remove the drive letter, but instead acts like
    a command to eject the CD from the CD-ROM drive (swaps in the "empty"
    CD-ROM image). In the DOSBox-X environment "Unmount drive" will still
    unmount the drive and remove the drive letter as expected. (joncampbell123)
  - "Swap disk" menu item under "Drives" is now enabled even while running a
    guest OS like Windows 95, if the drive is associated with a CD-ROM drive.
    Using the command rotates through the CD-ROM drive swap chain only for
    that specific drive, instead of all drives as the Swap CD mapper shortcut
    would do. (joncampbell123)
  - IDE emulation: Skip the CD-ROM eject / unload / load delay if media change
    is swapping to the "empty" CD-ROM image object. (joncampbell123)
  - Program object (base class of built-in commands) will no longer attempt to
    do anything with PSP segments or command line strings in memory if invoked
    while DOS kernel is disabled (running a guest OS). (joncampbell123)
  - IDE ATAPI CD-ROM emulation: If the guest issues the START/STOP command
    to eject the CD-ROM drive, replace the CD-ROM image with the "empty" object
    to emulate a now-empty CD-ROM drive. (joncampbell123)
  - Enable "Swap disk" menu command for floppy drives even while running a
    guest OS, as long as a floppy drive was already mounted there. (joncampbell123)
  - BOOT: Fixed a regression of floppy image detection (maron2000)
  - Sound Blaster DSP command 0x10 (Direct DAC) and Disney Sound Source emulation
    will hold the last sample received from the guest application to avoid popping
    noises if games like In Extremis use those devices to play sound effects
    that have a DC bias way off center. (joncampbell123)
  - Added DC bias correction to the audio mixing code so that, if games like
    In Extremis finish a sound effect with the last held sample way off center,
    it doesn't cause all other audio to clip and distort, and it does not
    potentially cause all audio on the user's operating system (as modern OSes
    mix all audio across applications) to clip and distort, such as playing
    In Extremis while listening to a YouTube video. (joncampbell123)
  - Fixed bug in MMX instruction EMMS emulation that correctly marked all FPU
    registers as empty but also reset the FPU status and control words. This
    fixes the distorted 3D cube when running the Microsoft DirectX diagnostics
    program (dxdiag.exe) with software rendering. (joncampbell123)
  - FPU instructions now correctly throw exception 7 (Coprocessor not present)
    if the EM (emulation) and TS (task switch) bits in CR0 are set, as documented
    by Intel. Many OSes, including Microsoft Windows, require this fix in order
    to properly maintain FPU state while multitasking. Without this fix, the FPU
    state is never switched and all applications (and kernel drivers in Windows 98)
    end up corrupting each other's FPU state. This fixes glitching artifacts in
    "Attack of the Saucerman!" by Psygnosis when emulating a CPU type that supports
    MMX instructions. It also appears to fix the random 3D rendering errors
    (verticies spiking off into the distance at random) when running "The Sims" for
    Windows 95 by Maxis, although the game still seems to exit at random after
    a while and the opening FMV video locks up at some random point. As part of the
    same fix, MMX instructions will also trigger the exception given the same
    condition.
    This fix is only applicable to normal core (core=normal) (joncampbell123)
  - Option to disable TTF winperc limit (emendelson)
  - Fixed screenshot crash (and others) in protected-mode games with output=ttf
    (AleWin32)
  - Debugger: Add missing debugger commands in documentation (AleWin32)
  - Debugger: MEMFIND/MEMS fixes (most important: protected mode addressing)
    (AleWin32)
  - IMGMOUNT: Attach CD-ROM to IDE controller (maron2000)
  - Bump mt32emu to ver 2.8.0 (maron2000)
  - IMGMOUNT: Ensure not to attach a new drive to the IDE Controller when running
    a booted guest OS. (maron2000)
  - Fixed savestate load producing scrambled graphics (AleWin32)
  - Feature: Add detailed info when loading savestate mismatch (AleWin32)
  - Fixed wrong disassembly after LMSW in debugger (AleWin32)
  - output_ttf: Don't reset colors when already in TTF output mode (maron2000)
  - Replaced Nuked-OPL3 with Nuked-OPL3-fast (tgies)
  - Windows: Build OSFREE nightly builds (maron2000)

2026.05.02
  - DOSBox-X will now check both the current directory and the .config
    directory in your home directory for DOSBox-X logo PNG files.
    It is now possible to configure one set of PNG files as a default
    for all uses of DOSBox-X from your user account. (joncampbell123).
  - src/gui/render.cpp: Added missing ifdef conditional on C_METAL to enable
    building on macOS platforms without Metal support. (herrnst)
  - Fixed Metal support detection: add framework linker flags to configure
    check (maron2000)
  - Fixed window position not centered even when windowposition option is set
    to do so. (maron2000)
  - Fixed MSCDEX device name padding for short names (maron2000)
  - When DOS games use the Adlib FM chip to do "digitized speech", DOSBox-X
    does emulate that correctly, and it also correctly emulates how low
    the volume is on the sound card output. However to make it more
    audible, a new option "adlib pcm boost" has been added. If set,
    and the Adlib emulation detects that the guest application is
    playing PCM audio through it, the audio levels of the FM output
    will be amplified to make the digitized speech much more audible.
    (joncampbell123)
  - Fixed mapping of TTF to match with guest codepage when launched with
    output=ttf. (maron2000)
  - Limit window size of TTF output to 2/3rd of the screen in both
    dimensions so that the window is not TOO large on the user's screen.
    (joncampbell123)
  - Fix segfault in TTF output code caused by codepage mapping when the
    TTF output is not active. (joncampbell123)
  - Fixed clip_paste_bios option change was not reflected. Also, default is
    changed to "true" for Windows due to some characters fails to paste when
    set otherwise. (maron2000)
  - Replaced some deprecated functions in dosbox.h. (maron2000)
  - Fixed colors in the screenshot of macOS SDL1 build were wrong.(maron2000)
  - Fix savestate restore crash in POD_Load_DOS_Files during live file slot 
    teardown (catbalony)
  - Fixed mouse cursor display in DOS/V Japanese mode (nanshiki)
  - INT 13h AH=48h: Fixed LBA detection (maron2000)
  - Fixed read/write errors on last sectors of disk image (maron2000)
  - Int 13h: Added option to enable/disable 48-bit LBA support (maron2000)
  - Fix VHD file geometry detection (maron2000)
  - Fixed crash when printing out multipages to printer (Windows) (maron2000)
  - printer.cpp: Fix occasional missing page break after line wrap (maron2000)

2026.03.29
  - Add dosbox.conf option to control the duration of the beep when
    DOS CON and INT 10h are given the BEL character. (joncampbell123).
  - DOS CON device BEL (beep) handling: For IBM PC modes, call on
    INT 10h to make the beep, rather than duplicate code. Fix the
    DOS CON device so that it can also properly beep in PC-98 mode.
    (joncampbell123).
  - Fix bug where the "zero memory on DOS allocation" option was
    stuck on. Some games, like "Bad Cat" rely on memory contents
    peristing across DOS EXEC and memory allocation. (joncampbell123).
  - Fix Hercules palette selection related to herc blend. (joncampbell123).
  - DOS kernel: When executing an EXE file, the loader can now detect
    EXE files that were compressed using EXEPACK. Based on the new
    exepack dosbox.conf setting, it can decompress the EXE by itself,
    switch off the A20 gate, or do nothing. The purpose of this
    setting is to avoid EXEPACK "Packed File is Corrupt" errors that
    happen if the A20 gate is enabled and the EXE was loaded too low
    in memory. (joncampbell123).
  - Linux SDL1: Use XDG_SESSION_TYPE environment variable to detect
    whether or not the user is running DOSBox-X under X11 or Wayland,
    and if so, prevent the fbcon and svga drivers from initializing.
    There seems to be a problem where, if run under Wayland and the
    XWayland compatibility layer if not present, SDL1 uses the fbcon
    driver to take over the screen using vtcon switching and the classic
    fbdev driver interface. Don't do that! (joncampbell123).
  - INT 21h AH=4Ah resize memory: If memory resize fails because there
    is not enough room for the requested amount of memory, do not
    set ownership of the block to the program. This fixes memory
    allocation error in California Games II. The game at one point
    seems to miscalculate and ask for an excessively large amount
    of memory on resize, and then fail, which doesn't seem to affect
    the game. HOWEVER, prior to the bugfix, the memory block that
    was available was assigned ownership to the game anyway. Later
    on after helicopter takeoff, the game would attempt to allocate
    more memory, which would fail because of the erroneous assignment
    of ownership to free memory. (joncampbell123).
  - Add debug logging to not only indicate DOS kernel memory alloc,
    free, and resize, but also log when the memory operation fails.
    Perhaps someday I'll figure out what the memory management in
    California Games II is doing wrong that makes the helicopter part
    fail in DOSBox-X. (joncampbell123).
  - Code development now occurs across two primary branches: master
    for fully functional emulation, and main-osfree for versions of
    DOSBox-X where built-in MS-DOS OS emulation is disabled. The osfree
    branch can only boot a guest OS. main-osfree is for use in jurisdictions
    that enforce or wish to enforce OS level age verification, and
    therefore, may consider the MS-DOS emulation an OS that is subject
    to those laws. (joncampbell123).
  - El Torito CD-ROM floppy disk boot emulation is no longer as slow
    as an actual floppy drive. Your bootable CDs will boot much faster
    now. (joncampbell123).
  - DOSBox-X shell: If a DOS error happened while trying to execute a
    DOS program, read the error code and print an appropriate message
    on the console. So far only "Access Denied" has any specific error
    message there. (joncampbell123).
  - Skip all keyboard code page and layout loading if running in PC-98
    mode. PC-98 systems store the entire font in ROM with only very
    limited room for custom fonts, therefore, it makes no sense to load
    code pages in PC-98 mode. (joncampbell123).
  - Keyboard code page layout: Fix bug where an out of range start_pos
    can cause DOSBox-X to segfault. Range check and print an error
    message instead. (joncampbell123).
  - Keyboard code page layout: The UPX unpacker checks the stack pointer
    (like a COM program would) to determine if there is enough memory
    to decompress. If there is not, it executes INT 20h to exit to DOS.
    Problem is, the code page execution never makes a proper PSP segment
    for that to work, so, during execution, intercept INT 20h and safely
    redirect execution to exit properly when called. Set an error flag
    so the code can know if that happened and say so. (joncampbell123).
  - Keyboard code page layout: If executing the CPI/CPX file because UPX
    decompression is detected, allocate memory based on the size of the
    file plus reasonable stack space rather than assume about 128KB of
    RAM following a DOS allocation of less, which for lower memsizes,
    only causes a crash on startup. (joncampbell123).
  - Debug print to log what code page file is being loaded at startup (joncampbell123).
  - CPU Idle callback is now strictly limited to processing IRQs and one
    CPU instruction, instead of however many CPU instructions can run
    until the next scheduled emulator event. This fixes a bug where
    system calls that use the Idle callback (INT 21h, etc) can sometimes
    vary their delay time by emulator events, and if "scanline render on
    demand is enabled", can cause the Idle call to take a full 1ms interval
    of time. This fixes an issue where "scanline render on demand" caused
    some DOS games like Xargon to take 5 to 10 times longer to transition
    between title, main menu, gameplay, etc. (joncampbell123).
  - Debugger LOGL command now includes the PIC_FullIndex() emulator time
    in millseconds so that it can be used to determine time as well as
    CPU state for debugging (joncampbell123).
  - Add dosbox.conf option to control whether VBE emulation provides the
    protected mode interface or not (joncampbell123).
  - Add dosbox.conf option vbememsize and vbememsizekb to control how much
    video memory is reported through the VESA BIOS, which can be less than
    actual video memory (but must be at least 256KB). This option can help
    with some DOS programs that have problems with "too much" video memory
    in the system (joncampbell123).
  - Add INT 10h mode flag _REQUIRE_LFB. When set, INT 10h calls to set
    VESA BIOS modes will fail unless requesting to set the linear framebuffer
    version of the mode (joncampbell123).
  - S3 emulation will mark any more large enough to exceed bank switching
    limits in S3 hardware as _REQUIRE_LFB (joncampbell123).
  - I'm not sure why Adlib emulation defaults to 48KHz in most versions of
    DOSBox, but the hardware rate is 49716 and that should be the default
    (joncampbell123).
  - Fixed crash on starting debugger on MinGW builds (maron2000)
  - Adjusted the ChinaSea/Big5-2003 extended code point ranges for CP951 to
    0x9140–0xA3FE and 0xC6A1–0xFEFE (1abcd)
  - Replaced deprecated symbols to enable launching on old macOSs (maron2000)
  - Converted all bash-dependent shell files to POSIX-shell compliant
    (pandasoli)
  - Removed 7 duplicate Chinese character mappings from CP951 (Big5-UAO) (1abcd)
  - Added SoundBlaster microphone input support (Windows WASAPI)
    (meldro364-glitch)
  - Fixed segfault on launch of macOS builds (maron2000)
  - Added OS/2 support for tinyfiledialogs, browser and external programs and
    some more fixes. (josch1710)
  - Fixed savestate load "Memory size mismatch" error on MSVC build (rebb)
  - Fixed savestate loading crash related to dynamically allocated TempLine in
    VGA system (rebb)
  - Added Direct3D11 and Metal support (Experimental, SDL2 only) (maron2000) 
  - When leaving fullscreen, only force rebuilding the window for OpenGL mode.
    (rebb)
  - Clear modifier keys before savestate gets saved. (rebb)
  - Re-enabled WinMM joystick support (Windows SDL1) (maron2000)
  - Fixed colors option fails at launch on TTF mode (maron2000)
  - Optional switch to disable post exit delay in DX-CAPTURE (villesundell)
  - Fixed Emscripten builds for Dosbox x v2026.01.02 (grootpot)
  - Fixed long freeze during startup on linux (SmileTheory)
  - Fixed windowposition option at launch (maron2000)
  - Fixed detection of EXEPACK failures (maron2000)
  - Added OS/2 dimension handling to UpdateWindowDimensions (josch1710)
  - Fixed handling of volume label searches (Allofich)
  - Microphone input: Make Hands-Free profile (HFP) optional (maron2000)
  - macOS: Fixed build script typo that made loading freetype library fail
    (maron2000) 
  - Fixed FPU FILD emulation (asemarafa)
  - Removed range check in INT10_GetCursorPos causing text glitches (maron2000)
  - Added experimental VS2026 CI builds. Can be downloaded as 64-bit Visual
    Studio nightly builds. (maron2000)
  - macOS: Fixed garbled message when opening image file(s) from dropdown menu.
    (maron2000)
  - Fixed XCOPY argument parsing to correctly handle switches appended directly
    to file paths without whitespace. (maron2000)
  - Fixed some Yes/No character was remained hardcoded as Y/N for some languages
    specifiying other characters (e.g. German). (maron2000)
    
2026.01.02
  - VESA BIOS will remove 8-bit bank switching limit if the video memory
    is large enough to need more than 256 banks. Memory size will always
    be limited to no more than 64 banks (128 if smaller than 64KB
    granularity) only if S3 emulation is active. DOSBox Integrated Graphics
    machine type is exempt from bank switching limit, so, if you are running
    legacy code or Demoscene stuff against it that never clears the upper
    8 bits properly, it's not going to work unless you use smaller memsize
    settings. (joncampbell123).
  - Update BOOT command to support multiple disk images with swapping (maron2000).
  - Render scaler system has been modified so that render and frame caches
    are now dynamically allocated, instead of fixed buffers. Not only does
    this reduce memory wasted by over-large buffers, it also removes
    limitations on guest video mode resolution that previously capped the
    video mode to 1920x1440 or lower, and the advanced scalers (HQ2X,
    Advanced MAME, etc) to 800x600 or lower. (joncampbell123).
  - VGA output will now automatically disable doublescan mode whenever an
    advanced scaler, such as the "XBRZ" or the Advanced MAME scalers, are
    selected, so that the scalers can do their job properly on the low
    resolution graphics mode automatically. The user no longer has to
    manaully turn off doublescan mode for those scalers to work. (joncampbell123).
  - Added TV, Scanline, and RGB scaler variants appropriate for VGA
    200-line modes with doublescan enabled (renders to 400 lines). In fact
    supporting those scalers with 400-line VGA is arguably more visually
    accurate than applying them to 200 lines of graphics, because it
    better reflects the actual 400-line raster as it would be displayed
    on a VGA monitor. (joncampbell123).
  - Apparently at random, VGA render will call RENDER_DrawLine too much,
    causing buffer overruns at random, so, instead of directly assigning
    the scaler line handler, assign a function that checks the rendered
    line count and ensures that rendering stops at the correct line
    count. This should fix some random crashes or corruptions, especially
    on Linux with the OpenGL output which likes to allocate EXACTLY the
    amount of memory required for the frame. (joncampbell123).
  - A patch was submitted to DOSLIB DSXMENU to incorporate non-selectable
    informational lines of text. Incorporate the updated DSXMENU binaries
    into DOSBox-X (joncampbell123).
  - Wrote IPS patching tools IPSMAKE and IPSPATCH in DOSLIB, then incorporated
    them as builtin executables on drive Z: under Z:\PATCHING. You can
    now use IPS patch files to "ROM hack" your MS-DOS games. (joncampbell123)
  - Add map13/map14 CGA/HGC like interleaved rendering support for VGA
    256-color mode. There is a game engine in development that is willing to
    use such oddball modes. (joncampbell123)
  - Added SDL2_net to source tree (maron2000)
  - Fixed regression of FIFA96 CD label detection (maron2000)
  - Log OpenGL context version (rebb)
  - Force SDL window regeneration when exiting fullscreen (rebb)
  - Fixed file handle leak prevents save state file removal (srcdabada)


2025.12.01
  - Video debug overlay: For Tandy and PCjr emulation, add information on
    the screen that shows the line mask, display and cpu memory banks and
    the corresponding segment values, which may aid in debugging issues
    with games and reveal any remapping or page flipping (joncampbell123).
  - Tandy emulation: Add the string "Tandy" somewhere in the DOS kernel
    at startup if machine=tandy. The game "The Train: Escape to Normandy"
    scans from FFFF:0000 for the string "Tandy" which of course wraps
    around to the first 64KB of memory where the DOS kernel resides. If
    it does not see this string, it does not think it is running on a Tandy.
    Such a detection routine will obviously break if you're on a 286 based
    Tandy with HMA enabled, or you're running normal MS-DOS on a Tandy
    system. This change allows the game to run (joncampbell123).
  - Tseng ET4000 emulation: Mode 0x24 is unusual in that it is a 130x28
    text mode with a 13-pixel high character cell. The ET4000 VGA BIOS
    apparently has a specific font for that mode, so, incorporate that
    font into DOSBox-X and use it for mode 0x24 (joncampbell123).
  - Tseng ET4000 emulation: Fix modes 0x22/0x23/0x24 to match how the
    actual VGA BIOS programs them. This fixes problems where the 132x25
    mode was rendered only on the upper half of the screen (joncampbell123).
  - Fix Tseng ET3000/ET4000 emulation bug where CGA graphics modes
    were garbled. The main VGA emulation no longer uses M_CGA2/M_CGA4
    and the ET4000 emulation needs to behave the same to fix the
    graphics modes. Apply fix to ET3000 emulation as well. (joncampbell123).
  - Some extra code in shell processing was preventing drive change commands
    if the last character was a backslash i.e. "a:\" instead of "a:".
    Fixed. (joncampbell123).
  - INT 21h AH=4Bh EXEC: Real MS-DOS returns a nonzero value like 0x3E01.
    A buggy version of Magic Pockets fails to call INT 21 AH=4Dh to read
    the INTRO.EXE exit code and expects AL to just be nonzero to continue
    to the game. So to make it work properly (kind of), return a nonzero
    value. (joncampbell123).
  - Tandy machine type: Many registers are WRITE ONLY according to SX
    documentation, yet "Troubadours" likes to read/modify/write those
    registers in what appears to be hand-rolled manual modesetting code
    to set up 320x200 16-color mode, so, add code to respond to reads
    from those ports with zeros and print a debug message to the log
    about how DOS games are not supposed to read those registers. Make
    the hand-rolled modesetting work by returning 0x00, rather than 0xFF.
    The code will not set up the mode correctly if 0xFF is returned, but
    will if 0x00 is returned. A side effect of this is that, since one
    of the registers controls the RAM address used as video memory, this
    moves it down to 512KB from base memory as well, which of course
    easily corrupts the very end of the MCB chain unless you enable more
    than 640KB of RAM and ask DOSBox-X to emulate the full Tandy 768KB
    of conventional memory. Though the game still crashes very easily,
    and in the exact same manner in both DOSBox-X and DOSBox SVN, this
    fix does solve the problem where the game was only able to draw
    2 out of 4 scanlines on the screen. (joncampbell123).
  - Fix: Load GetDiskFreeSpaceExA at runtime to restore compatibility with
    Win95RTM (emxd)
  - Support for musl libc under Linux (repzilon)
  - Utilize SDL2's keyboard capture logic to inhibit window manager shortcuts
    (BenAckerley)
  - Fix OpenGL resize / crash issue related to SDL and the internal GUI (rebb)
  - Fix: missing floppy drive after harddisk boot (merubird)
  - Fix crash on launch in MinGW and UCRT 64-bit builds (maron2000)
  - Fix file open dialog encoding (maron2000)
  - Allow controlling K-CG via BIOS interrupt (OPNA2608)
  - Add debug feature memory find (Enmet)
  - Fix turbo to allow burst mode and toggle mode (jez9999)
  - Linters - fixup freedesktop metainfo and flatpak (rderooy)

2025.10.07
  - INT 21h AH=4Ah resize memory: Compact free blocks only at or after the
    segment being resized, as MS-DOS is documented to do (joncampbell123).
  - INT 21h AH=4Ah resize memory: Fix bug where, if asked to resize a previously
    freed memory block and the block is not the last block in the MCB chain,
    and the next block in the MCB chain is also free, the MCB management code
    would correctly compact free blocks but then allocate according to the
    old size of the freed MCB block, causing truncation of the MCB chain.
    Fix for MCB chain truncation caused by California Games II DOS memory
    management when running in Tandy graphics mode. (joncampbell123).
  - Add dosbox.conf option, disabled by default, where if the MCB memory
    chain is corrupted anywhere past the running program's memory block,
    and it does anything to cause allocation, a new free memory block is
    created to satisfy allocations instead of halting emulation. Some DOS
    programs are a bit sloppy in a way that can corrupt the MCB chain.
    When enabled, this behavior matches apparent MS-DOS behavior (joncampbell123).
  - Debugger: DOS MCBS command now also prints the segment immediately
    following the last MCB block (joncampbell123).
  - Tseng ET3000/ET4000: Update Status register 3DAh behavior when emulating
    Tseng chipsets to reflect Tseng datasheet, and VGAKIT SVGA detection code
    expectations. Bit 7 is expected, as documented by Tseng, to be the inverse
    of bit 3 (vertical retrace). Extended Start Register CRTC 33h must not
    allow setting the upper 4 bits because Tseng only documents the bottom
    four, and because VGAKIT requires it for Tseng detection (joncampbell123).
  - Fix bug that, for machine=hercules, prevented Hercules palette shortcut
    from changing colors when in graphics mode (joncampbell123).
  - Remove mixer and VGA capture test modes from integration device. Update
    integration device version number. Convert hardcoded magic constants used
    in IG into constants in iglib.h which is now shared explicitly with the
    iglib.h in DOSLIB. Add integration device interface to allow the guest
    to read and set the CPU cycle count of the emulator. (joncampbell123).
  - Fix INT 10h AH=0Eh bug where printing BEL triggered screen scroll up if
    cursor beyond the last line. Fix for the Elder Scrolls Arena installer.
    (joncampbell123).
  - FAT filesystem driver (for disk images): If Elder Scrolls Arena calls
    INT 21h to find files named *.65 (such as STATES.65) with an attribute mask
    of 0xA (VOLUME LABEL | HIDDEN), ignore the VOLUME LABEL bit and scan
    normally. The 0xA value is leftover from a divide operation used to make
    the file name and is technically a bug in the game, though that happens
    to work on real MS-DOS and the DOSBox/DOSBox-X local folder support code
    anyway. This fix allows Elder Scrolls Arena to run from a mounted disk
    image. (joncampbell123).
  - FAT filesystem driver (for disk images): If Elder Scrolls Arena calls
    INT 21h to find SAVEGAME.00 (yes, a specific name for some reason) with
    an attribute mask of 0x7C (which represents... um... what?), ignore the
    VOLUME LABEL bit so that players can load their saved games from the
    menu instead of being told that the saved game that is clearly there on
    the screen does not exist. What other weird random values of CX attribute
    mask does this game use? (joncampbell123).
  - PCI bus improvements : Allow device to see full size access (smunaut)
  - Fix build error of SDL1 version on ArchLinux (possibly gcc-15) (maron2000)
  - Enable building DOSBox-X on older macOS versions and add instructions
    (maron2000)
  - Add code page 951 in dialog box (1abcd)
  - Fix failure of create/opening a temporary file for piping (maron2000)
  - Create/open a temporary file to device_TMP for piping on Z: drive.
    (maron2000)
  - Convert message to UTF16 before calling messagebox function (Windows)
    (maron2000)
  - Added some new members to the MMX_reg union for big-endian platforms.
    (alarixnia)
  - Create directory if not exist before writing conf file. (maron2000)
  - Fixed language files were still locked after loading is completed.
    (maron2000)
  - Fixed freeze when codepage switched to 3846, 3848. (maron2000)
  - Fixed build error when internal debugger is disabled (maron2000)
  - Show loaded conf file in log in full path (maron2000)
  - Print syntax error if pipe has no command to pass output (maron2000)
  - Add permanent option for initial DOSBox-X shell (maron2000)
  - Fix errors when initializing fluidsynth (maron2000)
  - PC-98: Redraw the function keys after updating them (bobsayshilol)
  - Do not carriage return with a single LF('\n') (maron2000)
  - Fix mapper not rendering anything on SDL2/Windows (aybe)
  - Scale mapper according display resolution (aybe)
  - Added applicable changes from SVN. (Allofich)
    r4485: Enable writing to all planes when drawing pixels in EGA modes.
    r4487: Correct panning of VESA text modes.
    r4488: Correct comment about odd/even bit.
    r4490: Set MCB ownership when *blocks==total at end of DOS_ResizeMemory.
    r4492: Don't clear message queues of MPU-401 and compatibles on reset.
    r4493: Handle EOF character in batch files as actual end of file.
    r4494: Use 4-byte partial page mapping data.
  - Replaced deprecated functions to enable building with FFmpeg 8 (maron2000)
  - Fixed screen blanked when restoring minimized window in TTF mode (Windows
    SDL1) (maron2000) 
  - PC-98: Save Kanji CG access mode setting, restrict output accordingly
    (OPNA2608)
  - Added missing language options to Windows installers (maron2000)
  - Debugger: IV must not truncate addresses to 16-bit (cmsautter)
  - Debugger: Warn single-stepping may not work as expected with Dynamic core
    (maron2000)
  - MIDI: Show loaded Soundfont/ROM path only when required to. (maron2000)
  - SDL2: Updated SDL2 library to version 2.32.10 (maron2000) 
  - Apply aspect/scaling/clipping when using OpenGL shaders in windowed-mode
    (rebb)
  - Fixed file locking problem on Linux port (loops)
  - Fixed typo in Linux man page (-date-host-forced option) (maron2000)
  - Mention OPL in MIDI/OPL configuration dialog menu (maron2000)  

2025.05.03
  - Show TURBO status in title bar. (maron2000)
  - Fixed MinGW32 builds failed using gcc15, due to a conflict in __inline__ 
    macro. (lazka)
  - Revise EGA/VGA emulation to treat the CRTC CGA/Hercules
    CRTC bit remapping as bits to mask out, instead of defining
    the upper limit of the memory mask. This makes the CGA mode
    Engine page flipping test work. I initially had reservations
    about whether or not real hardware did this, but, it would
    make sense for hardware to do it that way. (joncampbell123)
  - Updated libpng to version 1.6.47 (maron2000)
  - Updated XCOPY to version 1.9a (maron2000)
  - Updated SDL2 library to version 2.32.4 (maron2000)
  - Fixed a build/install error due to using wildcards in Makefile.am, which is
    not supported in GNU Automake. (maron2000)
  - macOS: Install SDL2_net in CI workflow to enable internal modem support on
    Release and Nightly SDL2 builds. (maron2000)
  - Fixed buffer size to allocate missing byte for string terminator for 
    savestate filename to prevent buffer overflow (arifogel)
  - Fixed settings of yellow color in COLOR command (maron2000)
  - Fixed COLOR command to match behavior on Windows (maron2000)
  - Fixed INT21h AH=0a cursor position moved by bell due to keyboard buffer full
    (maron2000)
  - Fixed INT21h AH=01 echo behavior (maron2000)
  - Replaced SetPixel with DIB Section Direct Memory Access for faster printing
    (DwayneSelsig)
  - Fixed creation of overlay special files (zyebytevt)
  - PC-98 mode: Add INT 18h function AH=10h to control cursor blink.
    Emulate documented side effect in that this call also hides the
    cursor. The PC-98 port of Lemmings will no longer show a blinking
    black box in the lower left corner. (joncampbell123)
  - Fixed Host key (F11, F12) handling in Codepage 932 (Japanese Shift-JIS).
    (maron2000)
  - Bumped ESFMu to ver 1.2.6 (maron2000)
  - Fixed regression of adding a dot to CD labels when longer than 8 characters,
    required for games such as Descent 2 CD installer (maron2000)
  - Added Modeswitch toggle option (DieSkaarj)
  - Fixed glitch of DBCS character at the end of a line (maron2000)
  - Fixed dialog for showing error of loading language files (maron2000)
  - Removed two and 226 duplicate Chinese character mappings from code
    pages 950 and 951, respectively, ensuring more accurate Big5 and
    Big5-UAO character mappings for Chinese IME users. (1abcd)
  - Enabled changing drives mounted prior to switching to securemode (maron2000)
  - Enabled some messages to be translated in the translation files (maron2000)
  - Fixed fullscreen mode occasionally switched to windowed mode (maron2000)
  - Updated French translation (FredBezies)
  - Fixed blank screen when output=ttf on PC-98 mode (maron2000)
  - Fixed crash when switching from fullscreen to window mode in TTF output
    (maron2000)
  - Fixed mounting zip files with white space in their names failed (maron2000)
  - Fixed crash on reboot when output=ttf (maron2000)
  - Fixed blank BIOS screen when output=ttf (maron2000)
  - Fixed direct input of half-width kana (maron2000)
  - Fixed PC-98 INT 1Fh, AH=90h source and destination address (drachen6jp)
  - Fixed unnecessary trailing backslash in path name (maron2000)
  - Fixed SSE MOVSS, MOVHPS, UNPCKLPS, UNPCKHPS, and PSADBW as well as
    MMX PMULLW, PSUBUSB, and PSUBUSW, instruction implementations (fuel-pcbox)

2025.02.01
  - Added new experimental dosbox.conf option that turns off the
    A20 gate automatically if loading a COM/EXE file to a memory
    location below 64KB. Option is off by default. This is intended
    for the startup routines of programs that assume 8086 wraparound
    to prevent them from crashing (joncampbell123).
  - Bump tinyfiledialogs to v3.19.1 (maron2000)
  - Fix VGA render-on-demand bug that causes all screen updates to
    stop working if something changes video state without changing
    any other attribute (width, height, frame rate, etc.). In
    PC-98 mode this bug could be triggered by leaving the text
    layer open while switching off the graphics layer when the
    graphics layer is in 256-color PEGC mode. Fix for KOARMADA.EXE
    when exiting back to the DOS prompt. (joncampbell123).
  - In PC-98 mode, add I/O port 43Bh which guest applications can
    then read to determine whether the 15MB "memory hole" is open.
    The guest can use this bit to determine whether the PEGC 256-color
    framebuffer is available at that location, or whether that is
    just plain system memory. Added for homebrew PC-9821 project
    KOARMADA.EXE which uses that bit to determine how to talk to
    the framebuffer. (joncampbell123).
  - Fix keyboard ISR in PC-98 mode to assume there is data waiting
    from the keyboard I/O ports (then check the status for more).
    The reason is that CWSDPMI.EXE for PC-98 has a keyboard ISR
    of it's own that reads the scan code first (which clears the
    "data available" bit) before then passing control to the
    real-mode keyboard ISR. If our keyboard ISR first checks for
    status in that case it will never see any keyboard data and
    keyboard input will never register to the guest while running
    under CWSDPMI (joncampbell123).
  - Fix BIOS POST location (F000:FFF0) JMP instruction in PC-98 mode
    so that the segment value of the JMP instruction matches a
    specific value that the DJGPP C runtime checks for to detect
    PC-98. (joncampbell123). 
  - Stop serving IBM PC-specific CWSDPMI.EXE in NEC PC-98 mode.
    It happens to work unless any interrupt or exception happens.
    Instead, provide an alternate common version of CWSDPMI.EXE
    that was patched to support PC-98 machines when machine=pc98
    (joncampbell123).
  - Add support for ucrt64 builds (maron2000)
  - DOS CTRL+C handling: Remove NULL vector check because built-in
    COMMAND.COM long ago was fixed to provide a CTRL+C vector. Fix
    code to use a different value for the C++ exception so that it
    cannot be confused for any other common signal in the emulator
    (joncampbell123).
  - Remove DOSBox Integration Device VGA "self capture",
    which was never used much anyway, as part of cleanup (joncampbell123).
  - x86 paging: Remove unused non-"full TLB" code. (joncampbell123).
  - Use mmap() to allocate system memory if available. This is
    for future work that may involve something that requires
    page-aligned allocation, such as KVM support in Linux (joncampbell123).
  - VGA cleanup, organization (joncampbell123).
  - Fixed regression of specifying DBCS fontx file was ignored. (maron2000)
  - Fixed mistakes in adding double quotes to filenames to pass to IMGMOUNT
    command, and syntax errors in showing a message dialog box. (maron2000)
  - Fixed bug where bios memSize was not set when using TTF. (maitchison)
  - Fixed CMS was always disabled regardless of config settings. (xrip)
  - Switch off TTF mode in text modes not working in TTF mode. (maron2000)
  - Gravis Ultrasound: Add dosbox.conf option that when enabled,
    prints a warning to the log file every time the guest pokes
    data into GUS RAM beyond the 1MB supported by the card,
    in order to better identify errant Demoscene code and/or
    any bugs in new tracker code currently in development. (joncampbell123)
  - VGA: Fix buffer overrun that can occur with 4bpp planar
    16-color modes if the guest writes beyond the first 2MB
    of video RAM. The planar support code also copies the 3rd
    bitplane to a font RAM array used in EGA/VGA text mode.
    This font RAM array is only 512KB, therefore in planar
    memory space, writes beyond (2MB/4) = 512KB cause corruption
    of emulator state and possibly crashes. Solve the issue
    therefore by not copying to font RAM beyond 512KB. (joncampbell123)
  - VESA BIOS support: Fix VGA draw and bank switching code
    to ensure that the guest cannot write outside video RAM
    limits, and fix VBE bank switching code to consider 4bpp
    planar SVGA modes properly. (joncampbell123)
  - VESA BIOS support: Fix scan line and page calculations related
    to 4bpp planar 16-color SVGA modes. (joncampbell123)
  - VESA BIOS support: Fix 24bpp RGB bugs related to VBE calls
    that control scan line length and display panning/scrolling.
    Now VBETEST can test 24bpp panning without potentially giving
    the user an epileptic seizure, and there are no more overlong
    scanlines. (joncampbell123)
  - VESA BIOS support: Correct mode information for SVGA text modes (joncampbell123)
  - VESA BIOS support: Like real Pentium-era hardware, do not
    list 4bpp planar 16-color modes as having a linear framebuffer.
    Most SVGA cards only support planar VGA memory within the
    standard VGA A0000-BFFFFh region and do not support the same
    up in the linear framebuffer area. (joncampbell123)
  - Save state support: Let the option to control whether or not
    compression is applied, apply to the ZIP compression. If you
    turn off compression, the ZIP file uses "store" mode instead,
    otherwise compresses as normal. (joncampbell123)
  - It turns out that for whatever reason, the savestate code was
    compressing the state twice. Once by itself, and then again when
    writing to the ZIP archive. Furthermore, storing the original
    length at the end of the compressed data using size_t is a big
    problem. Remove the extra compression/decompression and let the
    ZIP file support do the compression. Save states from now on
    will be marked as "No compression" for at least some backwards
    compatibility. (joncampbell123)
  - Volume label cleanup and fixes. Do not pad labels with white spaces. (maron2000)
  - Some NEC PC-98 games that support MIDI through MPU-401 like to use
    Roland GS-specific SysEx messages to control master volume and
    reset the MIDI synth, instead of standard messages. These games
    were known in DOSBox-X to have problems with MIDI stuck notes and
    hanging notes for this reason. Added code to recognize Roland GS
    reset SysEx and reissue it as standard MIDI reset, to resolve that.
    Added code to Fluidsynth MIDI support to recognize the Roland GS
    master volume SysEx commands and apply it to the output, which
    allows these games to "fade out" the MIDI properly. PC-98 games
    should no longer have hanging/stuck MIDI notes (joncampbell123).
  - Fix VESA BIOS modelist mistake that marked all "high definition"
    modes as modes to round bytes per line up to a power of 2 (joncampbell123)
  - Fix memory size register determination for S3 Virge/VX (clbianco)
  - Fixed a Y2038 bug by replacing Int32x32To64 with regular multiplication.
    (CookiePLMonster)
  - Fixed pasting Bell code (0x07) from clipboard was ignored. (maron2000)
  - Fixed a segfault crash when pasting the content of clipboard is empty 
    or consists of invalid characters only. (maron2000)
  - Fixed crash when trying to access MOUNTed empty physical CD/Floppy
    drives. (maron2000)

2025.01.01
  - Fix bug that prevented the Configuration GUI from saving to dosbox.conf
    the last Windows 3.1 theme you applied using the dropdown menu.
    (joncampbell123).
  - Add option to apply vmemdelay to SVGA and linear framebuffer
    modes (such as VESA BIOS modes), which reduces emulator performance
    for those modes, but allows you to emulate slower SVGA cards.
    Due to how some machine types are emulated, this option also enables
    vmemdelay to affect the PC-98 linear framebuffer, Tandy & PCjr
    video modes, as well as MDA/Hercules. (joncampbell123).
  - Add workaround to CPU reset logic that allows it to work correctly
    even with dynamic core. Previously, if the guest reset the system,
    the emulator would crash with an error message about an uncaught
    C++ exception because C++ exception handling doesn't work with
    dynamically generated code. (joncampbell123).
  - Correct CPUID family/model/brand values for cputype=pentium_iii.
    Add CPUID level 2, which returns "processor configuration
    descriptors", and return documented Pentium III values. Apparently
    Windows XP really REALLY cares about these configuration
    descriptors and will hang in-kernel in an infinite loop at bootup
    without these apparently really important values. This change
    makes it possible to boot Windows XP with Pentium III emulation.
    (joncampbell123).
  - Allow values of memsize to represent 4GB or more of RAM. Up to
    1TB, if Pentium PSE extensions are enabled, the memalias setting
    is 40, and "enable pse=pse40" in the conf file. Memalias maximum
    is now 40, instead of 32. Add code to provide that memory above
    the 4GB address mark when PSE is in use by the guest OS. Added
    dosbox.conf option to specify a memory file. When specified, all
    guest memory is memory-mapped from a file on disk, rather than
    allocated from host memory or host swap file. To avoid consuming
    too much RAM on the host, a memory file is REQUIRED to emulate
    memory at or above 4GB. For best performance with the memory file,
    make sure the filesystem you place it on supports sparse files,
    including Linux ext4 and Windows NTFS. (joncampbell123).
  - Fix EGA machine type to determine whether CGA RGBI or EGA RrGgBb
    display is active by vsync polarity, instead of the length of
    htotal. Several online references state that vsync is negative
    for 350-line modes, including 350-line to an MDA monitor. This
    also allows the "enhanced" EGA 320x200 modes in Rambo III to display
    colors correctly. (joncampbell123).
  - Dynamic x86 core: Reflect STI instruction to normal core so that
    the 1-instruction delay is correctly emulated. This makes it
    possible to run Windows XP or Server 2003 with dynamic core and
    SYSENTER/SYSEXIT emulation without random BSODs (joncampbell123).
  - Fix default code page. Instead of assuming 437 at all times, use
    437 for all IBM PC compatible modes and 932 for PC-98 emulation.
    (joncampbell123).
  - Normal core: Fix STI emulation to enforce the 1-instruction delay
    by forcing the normal core to execute another instruction right
    away without providing any opportunity for interrupt processing.
    This does not break Peret Em Heru, Keen games, and it seems to fix
    the random BSOD issues with Windows XP and Windows Server 2003
    when emulating a Pentium II that supports SYSENTER/SYSEXIT. I'm
    not clear on why this fix prevents them from crashing, but there
    you go. (joncampbell123).
  - Keyboard emulation: Fix PCjr key delay to match IBM documentation
    stating how long it takes to transmit one scan code, which is
    obviously much slower than normal to accomodate the slow CPU and
    the optical nature of the transmission. This is needed in order
    for emulation to correctly send Fn+key combinations. At normal
    key delay, the guest will miss scan codes and function keys will
    not be reliable. (joncampbell123).
  - Keyboard emulation: The 83-keyboard scan codes work differently on
    the PCjr keyboard because half of them are only accessible by holding
    the Fn key. The keyboard only sends the base key scan code and the Fn
    key scan code and the BIOS is expected to convert that to the normal
    83-key scan codes expected by DOS software. The problem is some games
    like "Agent USA" for PCjr are written to directly handle scan codes
    through IRQ 1 (the fact that PCjr handles keyboard via NMI and reflects
    to INT 9 is ignored here). Fix this by sending scan codes that emulate
    holding Fn and pressing the appropriate key. Agent USA expects the
    user to press F1 by holding Fn and pressing "1". (joncampbell123).
  - Revise VGA doublescan mode, vs bit 7 of the Max scanline register, to
    correct how VGA doublescans 200-line modes. Revise EGA/VGA text code
    to divide line by 2 in rendering to match double scanned scanlines,
    so that the "graphical" text of "After the War" can render properly
    for machine=vgaonly. (joncampbell123).
  - INT 10: If machine=ega, check the EGA switches on INT 10h modeset.
    Some games force the EGA BIOS to use CGA 200-line text modes by
    modifying those bits and then setting the mode ("After the War").
    (joncampbell123).
  - INT 10: Fix "load font" functions to correctly recompute video
    display end for machine=vgaonly and machine=ega. (joncampbell123).
  - INT 10: Like any other 200-line 16-color graphics mode, 200-line
    VGA text mode needs to program the AC and VGA palette using the
    CGA RGBI-type palette, not the EGA 64-color type palette. (joncampbell123).
  - CPU: Disallow clearing PE bit from LMSW by default, always.
    You can still allow it through dosbox.conf. It turns out that
    x86 CPUs never allowed you to clear it that way, even from the
    Pentium up, even though Intel documentation beyond the 386 never
    mentions it again. This fixes problems with DOS extenders and
    VCPI, particularly DOS4GW which for some reason with VCPI likes
    to try to clear the PE bit when switching to VM86 even though
    it clearly understands it's not supposed to be able to clear it.
    (joncampbell123).
  - VCPI: It turns out the VCPI server GDT selectors are expected to
    be 32-bit, because the protected mode VCPI entry point is expected
    to be called as if 32-bit far pointer. Correct VCPI entry point
    to return using RETF, not IRETD, which solves crashing issues with
    DOS extenders. For the first time, DOS extenders are working with
    the DOSBox-X built-in implementation of VCPI and most DOS games
    run fine now with it. (joncampbell123).
  - VCPI: Add code to INT 2Fh handler regarding Windows startup/shutdown
    messages to fill in DS:SI. If EMM386 and VCPI emulation is active
    and running the DOS machine in virtual 8086 mode, give Windows the
    proper callback procedure to allow Windows to switch off VCPI vm86
    mode on startup and turn it back on during shutdown. (joncampbell123).
  - BIOS "POST" screen: Change BIOS logo to PNG format. To avoid having
    to render a PNG in roughly 10 different video modes, add code to
    VGA draw code to allow a BIOS logo "overlay" to be rendered
    independent of the video mode. Depending on machine type load one
    of four PNG files from disk or from inside DOSBox-X itself.
    PNG requirements: 224x224 or smaller, bit depth of 8bpp or less,
    color palette (not grayscale), no alpha channel, and must not be
    interlaced. For best compatibility, use less than 64 colors, or
    perhaps just 16 colors. Much like the Windows 95 LOGO.SYS, you can
    change the logo to your taste by placing specifically named PNG
    files in the same directory as your dosbox.conf or current working
    directory. Have fun. Note that this addition requires that you
    compile DOSBox-X with libpng enabled. (joncampbell123).
  - Added dosbox.conf option to specify BIOS logo file. (joncampbell123).
  - Added dosbox.conf option to specify a text message, up to 3 lines,
    at the bottom of the screen during BIOS POST screen. (joncampbell123).
  - Fix color glitches in EGA, Tandy, Hercules mode on macOS SDL2 build 
    (output=opengl)(maron2000)
  - Add int33 mickey threshold option (Fixes Ultima Underworld) (jpernst)
  - Fix configure.ac (disable-screenshot option) (maron2000) 
  - Fixed codepage switching when loading language file in Traditional
    Chinese (maron2000)
  - Fixed display of some Chinese characters (Traditional Chinese)(maron2000)
  - Fixed garbled text and menubar on reset (maron2000)
  - Fixed codepage switching when a language file was loaded (maron2000)
  - sdlmain: Fixed crashing if no config files are found. (skitt)

2024.12.04
  - Arrange memory device allocation so that it is possible to allocate
    up to about 3900MB of memory instead of 3500MB. (joncampbell123).
  - Fix S3 LFB PCI base alignment error if system memory pushes it
    to a higher address (joncampbell123).
  - Fix EGA 640x350 4-color mode (when EGA memory size is 64KB) to
    display correctly. Prior to this fix, 640x350 4-color only worked
    properly if the INT 10h Video Parameter Table was enabled. (joncampbell123).
  - Fix S3 VGA memory size reported through register CR36 to cap at 4MB
    and set the value correctly. This fixes a known issue where setting
    vmemsize to 8MB caused Windows 98 to report memory size as 2.5MB. (joncampbell123).
  - Fixed a problem when VZ Editor is resident in PC-98 mode. (nanshiki).
  - INT 10: SVGA mode 0x6A does not exist on plain VGA hardware. (joncampbell123).
  - INT 10: Fix mode 0x6A (800x600 4-color SVGA) to use a correct dot
    clock so that the refresh rate is >= 60Hz instead of 37Hz, and make
    sure mode 0x6A is a 100% clone of VESA BIOS MODE 0x102. (joncampbell123).
  - Fix MMX/SSE instruction decoding, correct some mistakes in MMX emulation. (joncampbell123).
  - IMGMAKE: Add -partofs option to allow control of where the partition
    begins in the image (joncampbell123).
  - IMGMAKE: Add -align option so that the FAT filesystem can be arranged
    for more optimal I/O on devices with larger sectors, such as modern
    4096-byte/sector drives. (joncampbell123).
  - IMGMAKE: Add -label option so that the generated FAT filesystem has the
    specified volume label. (joncampbell123).
  - MDA emulation: Fix non-blink attributes 0xF0 and 0xF8 to correctly render
    bright green background. (joncampbell123).
  - Fixed crash when a CD image was loaded to an "empty" drive (maron2000)
  - Log loaded .conf file (maron2000)
  - Supress redundant screen reports in log (maron2000)
  - Fixed mouse capture locking by middle button (maron2000) 
  - Fixed toggling the menu option "Autolock mouse" did nothing (maron2000)
  - Fixed build failure with libc++ 19 (DimitryAndric)
  - Fixed fullscreen mode not responding when launched in TTF mode 
    in Windows (maron2000)
  - Fixed crashes when changing floppies mounted by drive numbers on
    a booted guest OS (maron2000)
  - Fixed launching host programs with white spaces in path (Windows)
    (maron2000)
  - Convert paths from relative to absolute when launching host programs
    in a mounted drive (Windows) (maron2000) 
  - Added an option not to pause after host program execution is 
    completed (maron2000)
  - Fixed corrupted display when loading language files at launch
    (maron2000)
  - Fixed Z Drive path expansion to be case insensitive (maron2000)

2024.10.01
  - Allow the ".inst" extension for CUE sheets. (Allofich)
  - Add SET /FIRST, a DOSBox-X extension, that takes the specified
    variable if it exists and moves it to the front of the environment
    block. (joncampbell123).
  - SET command processing has been cleaned up and streamlined.
    Added /ERASE command line switch to clear the environment
    block (DOSBox-X extension). (joncampbell123).
  - VESA BIOS: Add new option to adjust reported linear framebuffer
    address by a specific number of pixels. This is needed by
    "Out of Control" by Contract which for whatever reason,
    will always draw to the LFB base minus 128 bytes. This option
    makes it possible to correct the demo graphics. (joncampbell123).
  - Gravis Ultrasound: Officially, registers 0x0-0xF, the voice
    control registers, are documented to have a 0x0-0xF write and
    0x80-0x8F read alias. Unofficially, according to the behavior
    of 1997 demo "Out of Control" by Contract, all GUS registers
    have a N and (N+0x80) alias, or at least register 0x4C, and
    you can read them back from either index. Or else the demo
    fails to detect the GUS. So add this alias, but only if
    enabled in dosbox.conf. Real hardware testing is required to
    know if the actual GUS behaves this way and which versions.
    (joncampbell123).
  - Move the INT 3 default vector to well within the initial 16
    bytes of the DOS kernel, away from the List of Lists and SFT.
    The previous placement caused certain versions of Windows 3.2
    (yes, the Chinese version) to crash on startup. (joncampbell123).
  - When using the running program to name screenshots and such,
    filter out all invalid characters so that Windows users can
    take snapshots even if junk characters are there (joncampbell123).
  - DOS FAT driver: If INT 13h reports disk change, adapt floppy
    disk geometry to new disk image according to media byte. This
    allows DS_BLISS to present it's 720K fake floppy even if the
    user initially mounted a 1.44MB floppy to drive A: (joncampbell123).
  - INT 10 mode list: Add "pitch" parameter. If nonzero, the value
    (in pixels) is how to program the pixels per scanline when
    setting the mode.
  - VESAMOED: Add -pitch option to control the pitch (pixels per
    scanline). The intent is to work around DOS games that assume
    nonstandard pixels per scanline by allowing the VESA BIOS mode
    to use a different one. For example, Line Wars II has an S3
    acceleration mode that uses 800x600, but for whatever reason,
    assumes the video mode is 1024 pixels per scanline, and will
    render garbled graphics if that is not the case. (joncampbell123).
  - S3 emulation: Follow S3 Trio64 documentation and mask the Linear
    Window Position bits according to the size of the memory. You
    can only place it on a multiple of the memory size. This silences
    warnings caused by Line Wars II which appears to modify only the
    upper byte but not the lower when modifying this register, which
    then leaves 0xA0 in the lower half. That lower half would be
    ignored for 1MB or larger video memory sizes. (joncampbell123).
  - S3 XGA emulation: Add XGA acceleration for 4bpp packed 16-color
    SVGA modes. A CAD package has S3 support drivers that use the
    16-color 4bpp packed modes and expects XGA acceleration to work.
    (joncampbell123).
  - Add "-o int13" option to IMGMOUNT to direct the FAT driver to do
    all disk I/O through INT 13h instead of directly. This is intended
    for certain demoscene productions that apparently like to make
    files appear out of thin air by intercepting INT 13h floppy disk
    I/O and then asking MS-DOS to run something from it. Hack for
    "DS_BLISS" demo. (joncampbell123).
  - Fixed crash when a language file is loaded on a Windows host with
    US keyboard (maron2000)
  - Added Added sharp-bilinear Direct3D shader (RibShark)
  - Pass output dimensions to Direct3D shaders (RibShark)
  - Fixed BPB of floppy images made by IMGMAKE command (maron2000)
  - Fixed timestamp of volume label changed by LABEL command (maron2000)
  - Fixed pathname issues when mounting differencial VHD images (maxpat78)
  - Corrected relative/absolute track offset in subchannel data for
    CD-ROM images (RibShark).
  - Fixed particular dead keys were not working to input characters
    with diacritics (maron2000).
  - Enabled "Edit and Continue" option for debug builds of Visual Studio
    Intel builds (aybe).
  - Updated libchdr to latest (treloret).
  - Fixed icon in Gnome dock bar (FredBezies).
  - add option "[dos] automount drive directories" for Windows builds,
    this will mount existing drive directories from C to Y drive (aybe).
  - fix off-center and off-screen window after entering the
    configuration tool while using TTF output mode (aybe).
  - add menu item for centering window "Video/Center window" (aybe).
  - Fixed update-version-number script to patch all *.iss files, not 
    just the specific one it did before, to ensure future releases have
    correct version numbers. (joncampbell123).
  - Updated Nuked-OPL3 code to nukeykt/Nuked-OPL3@cfedb09 (StevenSYS) 
  - Updated SDL2 library to 2.30.4 (maron2000)
  - Fixed TTF mode didn't change to graphic mode when machine = Hercules
    (maron2000)
  - Configuration tool: (aybe)
    - more Windows 3.1 look'n'feel (themes w/ host dark mode detection)
    - enhance main window layout, it is now visible in its entirety
    - fix layout issues, off by one in rectangle drawing functions
    - fix 'list iterators incompatible' when pressing the Tab key
    - properties/help: sorted alphabetically, mouse wheel scrollable
    - remove few rendundant labels, adjust names of some others
    - retain 'show advanced options' state throughout session
  - SVN r4483: Fix compilation in Visual Studio 2008 (Allofich)
  - DOSBox Staging: Decouple CMS and OPL emulations (Allofich)
  - Fixed reading NEC specific character font data.(nanshiki)

2024.07.01
  - Correct Hercules InColor memory emulation. Read and write planar
    behavior was incorrect due to a misunderstanding of available
    documentation. (joncampbell123).
  - Hercules/MDA and InColor integration broke the Hercules blend mode
    render, fix the render so that adjacent lit pixels are brighter
    again. (joncampbell123).
  - Fix "VRD" debugger command bug that didn't properly render out the
    rest of the VGA display frame. (joncampbell123).
  - Fixed debugger mapper shortcut bug where entering the debugger
    completes the 1 ms "tick" early, effectively jumping emulator time
    up to start of the next ms. This might explain the mysterious cases
    where a program always fails to work unless you are debugging it.
    (joncampbell123).
  - Added debugger command "VRT" which resumes running the guest until
    vertical retrace. Added for programmers who wish to write something
    to screen and then see it show up. (joncampbell123).
  - Fix IMGMOUNT, when mounting FAT disk images, to provide the DPB the
    actual media id byte instead of assuming 0xF8 or 0xF0. INT AH=1Ch
    should now report the proper media id byte for any floppy format,
    instead of always reporting 0xF0 (1.44MB floppy). (joncampbell123).
  - Allow BOOT to load and execute the boot sector of a guest OS even if
    memory size is too small (in IBM PC emulation, less than 32KB of RAM).
    MS-DOS 1.x of course will crash if you try that because of the
    assumptions made in the boot sector, but it's there if you are feeling
    adventurous or are in an experimental mood (joncampbell123).
  - If memsize is 4KB, place the COMMAND.COM PSP segment in the private
    UMB area instead of the normal MCB allocation chain (joncampbell123).
  - DOS kernel will always allocate kernel memory from private UMB area
    if memory size < 16KB, in order to continue to work (joncampbell123).
  - DOS kernel will allocate from segment 0x60 instead of 0x70 if the
    memory size is less than 64KB. (joncampbell123).
  - files= and fcbs= default value now automatically scales according to
    available conventional memory (640KB or lower) in order for memsize 64KB
    or lower to free up or memory and run properly. (joncampbell123).
  - dosbox.conf files= and fcbs= settings have been changed to allow
    "0" as a value to mean choose a reasonable default. (joncampbell123).
  - Fix bug where DOS kernel crashes on startup because of the initial
    stack pointer set by BIOS startup that points past available memory
    when memsize is 64KB or less. (joncampbell123).
  - If minimum mcb free is not set and memory size is less than 256KB,
    automatically set minimum mcb free to minimum mcb segment, in order
    to release more available memory within the limited space (joncampbell123).
  - Do not enable XMS emulation if system memory size is 1MB or less. (joncampbell123)
  - DOS drive cache: When listing a directory, defer the filename sort until
    the entire list is built. This improves directory listing performance
    in directories with many files. (joncampbell123).
  - INT 10h, if instructed, will now use the video parameter table to set
    standard VGA modes instead of internal logic. (joncampbell123).
  - Removed erroneous VGA display compensation code for certain EGA/VGA
    registers that really only caused incorrect display of the EGA 640x350
    4-color mode. (joncampbell123).
  - Corrected EGA and VGA video parameter tables by copying the parameters
    from actual IBM EGA VGA ROM BIOS images. They should be 100% correct
    now. (joncampbell123).
  - Corrected register values and video rendering of machine=EGA 640x350
    mode when emulating 64KB of RAM. This should fix rendering and display
    issues with EGA 640x350 4-color emulation. Also corrected INT 10h
    character printing functions to filter the color attribute value for
    640x350 4-color mode so the DOS prompt does not have alternating
    colors, in the same manner the real IBM EGA BIOS does. (joncampbell123).
  - Fix BIOS screen to use CGA 640x200 2-color mode if machine=ega with
    less than 128KB of video ram, or machine=ega200, instead of showing
    a garbled 640x350 display. (joncampbell123).
  - Fix memory buffer overrun with machine=ega that can occur with
    640x350 mode and less than 256KB of video RAM. (joncampbell123).
  - The DOSBox clipboard API (via INT 2Fh) is now disabled by default, because
    some programs use it's presence to detect whether they are running under
    Windows. This fixes a program where Norton Desktop 1.0 does not use it's
    "graphical" text UI elements because it thinks it's running within a
    Windows DOS box. (joncampbell123).
  - Remove unnecessary and useless Win32 fcntl() on some memory typecast
    to int which is causing a segfault whenever a ZIP file is mounted
    as a drive with an overlay filesystem atop it. (joncampbell123)
  - Update caption control feature to use equivalent APIs on Mac OS. (joncampbell123)
  - Add dosbox.conf and menu option to control whether the DOSBox-X window
    can be seen in screen captures in Windows 7/8/10/11. Windows 11 "Recall"
    is very concerning and users might not want their DOS gaming to be
    part of it's memory. (joncampbell123).
  - Correct EGA switch readback from port 3C2h to reflect a value of 0x8
    instead of 0x9 when machine=ega200 (joncampbell123).
  - Correct BIOS data area value that holds the "EGA switches" to reflect
    200-line EGA "emulation" when machine=ega200. Value 0x08 instead of 0x09
    (joncampbell123).
  - Correct mode parameters for CGA 640x200 2-color mode when using
    machine=ega200 so that it displays correctly. (joncampbell123)
  - DOS kernel: Remove fixed hacks for SFT and dynamically allocate the
    second SFT table for the last N - 5 file handles. Add code to zero
    SFT table memory to ensure that random data doesn't cause issues.
    Windows 3.1 is still perfectly fine with it, so the SFT table update
    and cleanup is complete. (joncampbell123).
  - DOS kernel: Move the magic "CON" strings into the first SFT and
    mimic the 5 default open file handles that every DOS process starts
    with: CON CON CON AUX PRN. Windows 3.1 is still happy with it, which
    is good. (joncampbell123).
  - DOS kernel: Put the CON driver somewhere else because allowing it
    to overlap the SFT is messy. Fix SFT generation to match the way that
    MS-DOS 5.0 does it where the first table is always 5 entries and the
    second table is always N - 5 entries. Cleanup the DOS memory allocation
    a bit. So far, Windows 3.1 doesn't have a problem with it. (joncampbell123).
  - DOS kernel: Interrupt handler IRET was accidentally placed within
    the SFT table, move it up to resolve the conflict. (joncampbell123).
  - Local DOS drive support: On Windows, if the guest is attempting to
    create a hidden file, make sure to call the right APIs to create a
    hidden file on the host. Not only is this needed to create a hidden
    file, but if the guest tries to create a hidden file and the file
    already exists as a hidden file, the file creation needs to succeed.
    Fix for "Facts of Life" by Witan because the demo creates a hidden
    WITAN.92 every time it is run (joncampbell123).
  - XMS: Add dosbox.conf option to XMS driver to switch on flat real mode
    when a) the XMS driver initializes and/or b) when the XMS driver is
    called on to move/copy memory. (joncampbell123).
  - INT 21h: If a DOS program frees a memory block, and then resizes the
    freed memory block, reassign ownership of that block to the program
    as if allocated. This is apparently canonical MS-DOS behavior. Added
    dosbox.conf option to control whether resizing a freed block silently
    assigns ownership (default setting) or whether it returns an error.
    DOS resize memory function for the most part DID assign ownership but
    not in the case where the size of the MCB was exactly the size requested
    to resize to. (joncampbell123).
  - Sound Blaster: Fix bug where "force autoinit" prevented Sound Blaster
    playback from working at all, fix for "Jump" by Public NMI (joncampbell123).
  - Debugger UI now shows PIC_FullIndex() and whether or not the CPU is
    in the HLT state. Single stepping does not do anything when the CPU is
    in the HLT state, so at least let the user know (joncampbell123).
  - Keyboard controller (IBM PC): Cancel the IRQ signal upon reading I/O
    port 60h. The reason for the IRQ, the pending data, was just read, so
    now there is no point in keeping the IRQ signal up. This fixes Escape
    key problems with "Cronologia" by Cascada that causes part 3 "Time"
    to immediately exit and continue to the credits. Part 1 and 2 are not
    affected by the pending IRQ because those parts mask IRQ 1 and poll
    the keyboard controller directly. (joncampbell123).
  - Fix complexity test code to determine when Odd/Even mode is enabled
    in all cases and to resolve a problem with garbled scrolling text
    in the "Vectorballs" part of "Unreal" (joncampbell123).
  - M_EGA display mode now applies CRTC BYTE/WORD/DWORD shift to display
    start address, same as M_VGA, to ensure correct display when demos
    and games set the CRTC to non-BYTE modes. This fixes page flipping
    flickering during the "Vectorballs" part of "Unreal" by Future Crew.
    (joncampbell123).
  - Update Configuration GUI to use radio buttons for selection, meaning the
    circular buttons that resemble those in Windows, not the check boxes.
    The GUI toolkit had them all along, the Configuration GUI was using
    check boxes for that for some reason. (joncampbell123).
  - Linux ALSA MIDI output: Any attempt to send RESET or other Fx commands
    to the ALSA library causes a segfault in the ALSA library. Revise the
    code to send without crashing. (joncampbell123).
  - Linux ALSA MIDI output: Add code to list and enumerate the MIDI sequencer
    devices available so the user can use it to determine what magic numbers
    to put into the midiconfig setting, especially if the user wants to send
    MIDI to an external synthesizer. (joncampbell123).
  - Suddenly Mac OS 14 and XCode consider the "id" and "int" datatypes
    different and assigning or returning one to the other is now a compiler
    error. Add typecast to enable compile on latest XCode. (joncampbell123)
  - INT 33 mouse emulation: Add dosbox.conf options to force a specific
    coordinate system for the DOS game with respect to host/guest mouse
    cursor integration (getting the DOS cursor to match the host cursor
    within the window). Add dosbox.conf option where additional adjustments
    are available. The maximum x/y and max-adjust options are ideal for
    Lemmings 2, which uses INT 33h in a way that confuses the automatic
    range detection code used to synchronize cursor position and therefore
    needs this option, and the first Lemmings as well. (joncampbell123).
  - PIT timer: Fix restart_counter(), the delay computation was completely
    backwards. This is particularly important where it concerns programs
    that use the PIT to detect the rate at which the Pentium time stamp
    (RDTSC) advances as the previous code caused wildly inaccurate measurements
    and bad timing (GRUB bootloader, the Microsoft CD-ROM boot "press a key
    to boot from CD" message). (joncampbell123).
  - IDE: Make sure to set feature/error register to 0x01 when the guest
    soft or hard resets the IDE devices through the controller. The Linux
    kernel uses a soft/hard reset on startup to detect PATA devices and
    if it does not see the correct value after reset, it will either ignore
    the device or complain about diagnostic failure and cautiously talk to
    the primary IDE hard drive while ignoring any ATAPI CD-ROM emulation.
    This allows the Linux kernel to boot and see the CD-ROM drive. (joncampbell123).
  - IDE: Do not clear registers unnecessarily when finishing IDENTIFY DEVICE.
  - The BOOT command now supports El Torito "no emulation" booting from a
    CD-ROM drive, which is needed to boot install CDs for Windows XP, Linux,
    etc. or Linux-based live CDs. Note that at this time, BOOT only supports
    "no emulation" and IMGMOUNT only supports "floppy emulation" (joncampbell123).
  - INT 13h extensions: If a read was interrupted by an error, update the
    block transfer count so the caller knows (joncampbell123).
  - DOS: Move version parsing farther up, so that the initial DOS version
    can affect memory layout and tables as needed. (joncampbell123)
  - DOS DPB and FAT driver: If the DOS version is 4.0 or higher, write a
    DOS 4.0+ compatible DPB structure (as DOSBox-X already has been doing
    since forking from DOSBox). If the DOS version is lower than 4.0,
    write an MS-DOS 3.30 compatible DPB structure. This allows Popful Mail
    to run without getting into an infinite loop scanning the DPB linked list
    when [dos] section ver=3 30 (MS-DOS 3.30), aside from the fact that the
    game will also run without this change if you set ver=4 0 since the game
    appears to be aware of the change in structure between MS-DOS 3.30 and
    MS-DOS 4.0, though for whatever reason the game refuses to run on
    MS-DOS 5.0 or higher. (joncampbell123).
  - IDE: Silently ignore SET FEATURES command 0x03. Any negative response
    to feature 0x03 causes the Linux kernel to reject the IDE device.
    (joncampbell123)
  - Add support for PIT timer 0 mode 4. Linux kernel 6.1.29 compiled in
    "tickless" mode uses mode 4 instead of mode 0 as a delay timeout. Prior
    to this fix, the Linux kernel would switch into tickless mode and then
    nothing would happen because IRQ 0 would never fire again. See also Linux
    kernel source code, drivers/clocksource/i8253.c function pit_set_oneshot()
    to see what I mean. (joncampbell123)
  - Windows 95 S3 driver behavior suggests that S3 16-color VESA modes
    0x202 to 0x208 are NOT planar modes, but packed modes. Change modes to
    M_PACKED4 and update modelist building to allow that range even if the
    dosbox.conf is configured not to list 4bpp packed VESA modes. This fixes
    Windows 95 S3 driver 16-color modes 800x600, 1024x768, 1280x1024.
    Noted: Windows 95 is the last version of Windows to support 4bpp packed.
           Windows 98 and higher refuses to support it and the Display settings
           will not allow you to select any 16-color mode other than the stock
           VGA 640x480 16-color planar mode. (joncampbell123)
  - Add --load-seg option to BOOT in case any PC-98 game boot floppy expects
    to be loaded somewhere other than the default. PC-98 game "Private School
    Adventure" will crash if loaded to segment 0x1FC0 but runs fine if booted
    with --load-seg 0x0FC0 instead. (joncampbell123)
  - Add dosbox.conf option to direct the EMS page frame segment, in a limited
    fashion, though only effective for PC-98 mode. PC-98 segment is still
    0xD000 by default, but apparently there are games that require the EMS
    page frame to exist at 0xC000. For these games, you can now set under the
    [dos] section "ems frame=C000". (joncampbell123)
  - Restored libslirp support for 32-bit MinGW CI builds which was temporarily
    dropped in 2024.03.01 release. Also since MinGW plans to gradually phase
    out 32-bit support, added code to manually build on our own. (maron2000)
  - Fixed build errors of Windows installers. Windows Vista support for standard
    installer is dropped to fix this issue. Vista users can either use the XP
    installer or portable builds instead. (maron2000) 
  - Fixed compile error of speexdsp/fftwrap.c on gcc-14 (maron2000)
  - PC-98: Fixed US keyboard support for tilde (Shift+grave) key (maron2000)
  - Fixed DOSBox-X freezed when codepages regarding EGA18.CPX were set (maron2000)
  - Fixed CUE sheets of GOG games were rejected. Still requires "-t iso" or 
    "-t cdrom" option for uncommon file extensions except ".CUE". (maron2000)
  - Added loongarch64 support (donmor)
  - Disable FP exceptions in a portable way (xry111, donmor)
  - Added "*.ccd" in file open dialog (maron2000)
  - Added CI builds for ARM mac (maron2000)
  - Bump tinyfiledialogs to ver 3.17.4 (maron2000)
  - Obtain geometry info of non-standard sized floppy from BPB (maron2000)
  - PC-98: Implemented int 18h ah=47h,48h,49h (nanshiki)
  - Added breakpoint type "Freeze memory" (Enmet)
  - Implemented seeking in MSCDEX
    (Imported from dosbox-staging/dosbox-staging#3516 authored by weirddan455)
  - Fixed built-in COPY command failed to obtain free space when reported DOS 
    version is set to 7.1 (maron2000)
  - Fixed some file extensions in the filter list were ignored in the file open
    dialogs (maron2000)
  - Fixed mounting a non-FAT VHD image (maxpat78)
  - Fixed VHD geometry detection (maxpat78)
  - Fixed issue that IMGSWAP command did not work for CD drives. (maron2000)
  - Fixed loaded language file unexpectedly changes on launch. (maron2000)
  - Fixed reported size issues in builtin DIR command (maxpat78)
  - Added missing language file in Windows standard & XP installers. (maron2000)
  - Fixed a bug in IME character display on macOS Sonoma (nanshiki)
  - Fixed build errors of SDL1 code when built with gcc-14 (maron2000)
  - Fixed static link errors of libslirp >= 4.8.0 (maron2000)
  - PC-98: Added MEM command for PC-98 mode (maron2000)

2024.03.01
  - If an empty CD-ROM drive is attached to IDE emulation, return "Medium Not
    Present" instead of a read error, when asked to read. (joncampbell123).
  - Add "empty drive" CD-ROM image type "IMGMOUNT e: empty -t iso" as a way
    to emulate an empty CD-ROM drive with no disc in the drive. (joncampbell123).
  - Add "empty drive" floppy image type "IMGMOUNT 0 empty -t floppy -fs none"
    as a way to emulate a floppy drive with no disk in the drive. (joncampbell123).
  - Video debug overlay: Fix mouse integration misalignment when the video
    debug overlay is enabled while Windows is running (joncampbell123).
  - Video debug overlay: Fix segfault when enabled with 15/16bpp SVGA modes.
    (joncampbell123).
  - Video debug overlay: Fix bug where video debug failed to appear in SVGA
    15/16/24/32bpp display modes because of a design where the VGA drawing
    code points directly at video RAM except when drawing the hardware cursor.
    One symptom was that the video debug info on the side failed to appear at
    all, unless running in Windows and only within the vertical range of the
    mouse cursor. (joncampbell123).
  - Video debug overlay: Do not bother showing the Attribute Controller palette
    in 15/16/24/32bpp SVGA modes because it doesn't matter there and is not
    involved with how anything is displayed. (joncampbell123).
  - Video debug overlay: Fix debug info text to appear for 15/16/24/32bpp SVGA
    modes. (joncampbell123).
  - BOOT --bios no longer triggers a system reset VM event, but instead just
    jumps to the new BIOS image after DOS kernel shutdown. This is needed for
    hardware and resources to stay as they were when running the BIOS i.e.
    keeping any IDE devices configured within the DOS kernel intact so that the
    BIOS can find and use them. Prior to this change, all hardware was fully
    reset and unmapped prior to running the BIOS which made IDE emulation
    unusable with BIOS images. (joncampbell123).
  - BOOT --bios no longer immediately loads the new BIOS into memory, but instead
    loads and stores the image to a temporary buffer. The ROM image does not
    actually get mapped in until the DOS kernel and everything else has had a
    chance to shut down fully. (joncampbell123).
  - Fix BOOT --bios not to try to load PC-98 ITF firmware unless actually running
    in PC-98 mode (joncampbell123).
  - Write PC-98 keyboard translation table (non-shifted) in ROM BIOS and set the
    keyboard translation table pointer in the BIOS data area for "Nut Berry".
    This Nut Berry game also assumes lookup and translation tables exist at
    specific locations in the ROM BIOS, so put those tables there. The shift
    state table in BIOS has also been added, though at the moment, the tables
    are incomplete. (joncampbell123).
  - MegaZeux from the MS-DOS days had a 256-color tweakmode that worked on some
    popular SVGA chipsets of its time though on others it does nothing but halve
    the display resolution of text mode. The basic idea is that it makes the VGA
    card latch two 4-bit outputs of the VGA text mode into one 8-bit value, thus,
    256 colors possible. Add support for this. However I am not sure whether this
    tweakmode is supported by S3 chipsets, so it is OFF by default and you will
    need to add "enable supermegazeux tweakmode=true" to the [video] section of
    your dosbox.conf to enable it. (joncampbell123).
  - Undo the "no partition offset" change. DOOM II for PC-9821 requires it to work
    else the page flipping fails and sprites and rendering flickers as you play.
    (joncampbell123).
  - Allow text layer to appear in PC-98 256-color mode. Even though I was unable
    to enable it on real hardware, "Shamat, The Holy Circlet" requires having
    the text layer visible on top of 640x400 256-color mode for the introductory
    scrolling text to appear on screen. So for now, just allow it. (joncampbell123).
  - The reason some PC-9821 games have been giving bad PITCH values (double the
    correct value) to the GDC in 256-color mode has been determined. They read
    port 9A0h to determine if the GDC is running at 5MHz or not. That port 9A0h
    index was not implemented and therefore gave the game the impression it was
    running at 5MHz when it was not, therefore the doubled PITCH value. This fix
    corrects the squeezed 256-color mode and allows it to appear properly.
    (joncampbell123).
  - IMGMOUNT: If the file extension is HDI, assume a hard disk image even if the
    image file is small enough to qualify as a floppy disk image. There is an
    HDI image of PC-98 game "D.O. Doki Doki Disk 8" that is 2.2MB, small enough
    to be mistaken as a 2.88MB IBM PC floppy disk and therefore fail to mount
    as an HDI image, this change fixes it. (joncampbell123, maron2000).
  - Emulate PEGC PC-98 linear framebuffer at both 0xF00000-0xF7FFFF (at 15MB
    memory mark) but also make it appear at top of memory below BIOS (normally
    at 0xFFF00000-0xFFF7FFFF). Some 32-bit PC-9821 CD-ROM MS-DOS games assume
    the top of memory alias and will fail to show anything on screen without
    it (unless, alternatively, the memalias setting is set to emulate 24 address
    lines like a 386SX). Now to figure out why these same games are programming
    a GDC PITCH value that's double what it should be... (joncampbell123).
  - PC-98 GDC scan offset no longer pays attention to scan offset of data
    partition in 256-color mode. Required to help fix broken 256-color graphics
    for some PC-98 CD-ROM games. (joncampbell123).
  - Refuse to enable ISA 15MB-16MB memory hole if memalias is set to 24 bits or
    less. Not only is it redundant to do that but it also causes the BIOS to
    immediately crash on startup. (joncampbell123).
  - IDE ATAPI CD-ROM emulation: In PC-98 mode when emulating a NEC CD-ROM drive,
    also limit sector reads to one CD-ROM sector per DRQ because the MS-DOS driver
    assumes that behavior. The driver will stall and error out if it requests a
    multi-sector read and the drive does NOT limit transfers to one sector at a
    time per IDE data transfer. This is in line with my experience writing the
    DOSLIB IDE testing program and laptops from the 1990s with IDE ATAPI CD-ROM
    drives, so it's understandable. (joncampbell123).
  - The reason the CD-ROM driver in PC-98 game HDI images refused to talk to our
    IDE CD-ROM emulation is... (drumroll) we didn't report ourself as an NEC
    CD-ROM drive when given the MMC INQUIRY command. Yes, really. The OAK CD-ROM
    driver in these HDI images really does care whether or the drive is an NEC
    brand drive. What a stupid reason not to talk to a CD-ROM drive. Add code to
    default to "NEC" "CD-ROM DRIVE" as the INQUIRY result if running in PC-98 mode.
    (joncampbell123).
  - Add basic rudimentary support for CloneCD (*.ccd *.img) images. It might not
    work with more complex arrangements but it is enough for most CD-ROM PC-98
    games so far. (joncampbell123).
  - libpng supports the pHYs PNG chunk which describes the pixel aspect ratio of
    the PNG image. libpng 1.6 has it, use it. Programs that support the information
    like FFMPEG will then display the PNG image with the correct aspect ratio.
    (joncampbell123). [https://github.com/joncampbell123/dosbox-x/issues/4754]
  - PC-98 mode: There is a 302KHz timer behind I/O ports 5Ch/5Eh that some MS-DOS
    drivers depend on for timing, particularly a popular IDE CD-ROM device driver
    in many PC-98 game HDI images. This change allows the driver to time out after
    about 5-10 seconds instead of an infinite hang. (joncampbell123)
  - Fix INT 10h to keep hardware CRTC I/O port synchronized with BIOS DATA area
    copy so that other parts of INT 10h called by SetVideoMode do not accidentally
    talk to the wrong I/O ports. This fixes corrupted INT 10 Mode F display
    (640x350 monochrome graphics mode). (joncampbell123).
  - Add DOS Int21 0x5D 0x00 - remote server call
    Inspired by FeeDOS inthndlr.c
    With this change it is possible use a plain dosbox-x to install and run
    Windows for Workgroups V3.11 as an IPX server on the pcap ne2000 interface
    offering a host directory for read and persistent write access to an
    MSDOS machine running a WfW 3.11 IPX network client.
    Please don't forget mounting with -nocachedir
    (Issue #4162)(Yogi-baer)
  - Fix missing keystroke SDLK_LESS on DE keyboard on Raspbian OS (Yogi-baer)
  - Fix crash when loading a language file without existing menu item "ttf_extcharset" (Yogi-baer)
  - Change ISA memory hole 512kb option from boolean to true/false/auto. (joncampbell123)
  - Add ISA memory hole 15mb option, make it true/false/auto.
    Auto means off for IBM compatible mode and on for PC-9821 compatible mode.
    This should allow some DOS games that depend on the linear framebuffer
    to work properly even if memsize=16 or higher. (joncampbell123)
  - MIDI: set minimum sysex delay when enabled (mistydemeo)
  - International support in LABEL, COPY, DEL builtin commands (maxpat)
  - Fix palette setting bugs due to SETCOLOR fix in 2023.10.06 release. (maron2000)
      Graphical glitches in Ultima VI(#4507), Chessmaster 3000(#4510), Wizardry VII(#4534) 
      Crash Sid Meyer's Civilization I (#4511)     
      TTF color settings regarding 'colors' option (#4579, #3318) and some more
  - Fix crash when mounting floppy/ISO images with no extension (maron2000)
  - Fix Intel macOS CI builds crashed on startup due to missing dylibs
    (Issue #4438)(maron2000) 
  - Fix TTF mode didn't switch to graphics mode on certain types of machines
    such as tandy/pcjr.(Issue #4559)(maron2000)
  - Fix crash on switching to fullscreen when output=opengl (Intel macOS) (maron2000)
  - Update DXCapture shell command to support /O for OPL capture (AranVink)
  - Fix floppy images lock bug (maxpat78)
  - Fix type of return value at bool MountFat() (jg1uaa)
  - Fix VHD geometry bugs by performing MBR analysis (maxpat78)
  - Change maximum number of joystick buttons allowed by the mapper (mattcaron)
  - Enable Win9x support on a Pentium3 PC (crazii)
  - Add PC98 image extensions in file open dialogs (maron2000)
  - Fix input in configuration tool (SDL2) (maron2000)
  - Reduce warnings by replacing sOffset (use offsetof) (jg1uaa)
  - Fix LFN functions (nanshiki, SmileTheory)
     Fixed a bug in which 2 extra bytes were copied to the buffer (ax=714eh,714fh).
     Fixed wrong value of date/time etc. in file information (ax=714eh,714fh,71a6h).
     Fixed date/time conversion to be correct (ax=71a7h)
     Report correct file size on win32 when file is open (ax=71a6h).
  - Fix C++11 uncompliant codes (midi_alsa.h, gamelink.cpp) (maron2000)
  - Consider function key display in MORE command (PC-98) (maron2000)
  - Add support for J-3100 video mode 75h (nanshiki)
  - Reflect drawing status bit of GDC status I/O port (PC-98) (nanshiki)
  - Re-enable top line dimming when focus is lost in fullscreen (TTF mode) (maron2000)
  - Fix PC98 mouse counter value range to unsigned value (0-255) (nanshiki)
  - Added function for int DCh cl=10h ah=0Ah to 0Eh (nanshiki)
  - Added escape sequences (ESC[0J ESC[1J ESC[0K ESC[1K ESC[2K ESC[nL) (nanshiki)
  - Fixed behavior of Kanji character output at the right edge of screen (nanshiki)
  - Fixed Media ID was being written to an incorrect location in DPB (nanshiki)
  - Refined version info (maron2000)
  - Added PC-98 NEC mouse functions in INT33h (nanshiki)
  - Bump Nuked-OPL3 code to commit 730f8c2 (13 Nov. 2023) (maron2000)
  - Enabled OPL pass-through code (oplmode=hardware)(dbjh)
  - Fixed crash on startup due to SDLnet library linked externally (macOS) (maron2000)
  - Changed PC-98 floppy boot behavior when Drive 2 is mounted before Drive 1(maron2000)
  - Added Human68k ver.1.0&2.0 floppy disk support (maron2000)
  - Fixed attribute copy behavior of FreeDOS XCOPY.exe to match genuine DOS (maron2000)
  - Added Russian translation (Lartenik)
  - Fixed COPY/XCOPY command fails to recognize 2GB+ free disk space (maron2000)
  - Enable FONTX2 files in PC-98 mode (nanshiki)
  - Fix codepage switching when loading lang files (maron2000)
  - Add missing quotation marks in vcxproj (bredbored)
  - Fixed BPB detection of PC-98 floppies (maron2000)
  - Changed sequence to boot with drive numbers when booting from image (maron2000) 
  - Added force JIS (JP106) keyboard layout option in PC-98 mode (maron2000)
  - PC-98: Enable mounting partitions with non-genuine IPL entry names (maron2000)
  - Added support for XDF disk format (maron2000)
  - Added ESFM emulation (ESFMu v1.2 core) (Kagamiin)
  - Added support for ESS "ESFM" sound synthesis (oplemu=esfmu, oplmode=esfm) (Kagamiin)
  - Added experimental/WIP support for the ESS ES1688 sblaster type (sbtype=ess1688) (Kagamiin)
  - Delete obsolete information regarding "INTRO SPECIAL" option (maron2000)
   
2023.10.06
  - Add "VRD" debugger command to force redraw of the VGA screen. (joncampbell123)
  - Add VGA debug set commands to force a video start address and another
    to clear all debug settings. (joncampbell123)
  - Add "PITSYNC" option to VFRCRATE command. "VFRCRATE PITSYNC ON"
    directs the system timer interrupt to synchronize tick rate with
    vertical refresh rate of VGA emulation if the game or demo set
    the timer tick rate to a value close enough to vertical refresh.
    This is intended for games or demos that use the system timer for
    a vsync interrupt. (joncampbell123)
  - IMGMAKE: Fix bug where if -bat was specified, the generated .bat
    file would attempt to mount the .bat file, not the disk image. (joncampbell123)
  - IMGMAKE: If -nofs and -bat was specified, the generated .bat file
    will refer to "IMGMAKE 2" instead of "IMGMAKE C" (joncampbell123)
  - DOS FAT driver: When the guest sends in a new BIOS Parameter Block,
    recalculate the disk locations and FAT type properly instead of
    assuming that FORMAT.COM is using the same format already present. (joncampbell123)
  - DOS FAT driver: If the partition is unformatted and looks as if
    freshly written by FDISK, then instead of failing to mount, mount
    the partition instead as an unformatted partition and fail file
    I/O until a BPB is set and the partition formatted by FORMAT.COM.
    This matches MS-DOS behavior and it makes it possible to mount an
    image, FDISK it, restart, FORMAT.COM the unformatted partition,
    and end up with a working drive letter (just like MS-DOS). So far
    verified against MS-DOS 6.22 and Windows 98 versions of FDISK,
    FORMAT, SYS, and SCANDISK. (joncampbell123)
  - DOS FAT driver: Add options -o sectoff and -o sectlen to make it
    possible to manually specify the start and length of a partition.
    Future code will use this internally as well. (joncampbell123)
  - IMGMOUNT: Allow *: as a drive letter to mean automatically pick a
    drive letter. (joncampbell123)
  - Fix debugger to use toupper(), but only for ASCII range ncurses
    keycodes. (joncampbell123)
  - Timer PIT: If the guest writes the counter value while the counter
    gate is off, make sure the counter read back is the same value
    written regardless of gate status. Prior code returned the stale
    latched value of the counter as it was prior to shutting off the
    gate and writing the counter, causing timing issues. (joncampbell123)
  - Fix restoring minimized window on TTF output (Issue #4248) (maron2000)
  - Fix macos crash on launch when output=surface or auto (SDL2) (maron2000)
  - Update in-tree SDL2 library to ver 2.28.2 (maron2000)
  - Updated build tool for MinGW lowend builds required for the updated SDL2
    library. As a result, MinGW lowend builds are now able to enable debugger
    features. (maron2000)
  - Debugger RUN and RUNWATCH commands were broken, fix. Make sure debugger
    shortcut triggers execution to stop whether in RUN or RUNWATCH mode.
  - Fix SETCOLORS command didn't change color when output=ttf.(Issue #4503)
    Also fixed the values reported were wrong. (maron2000)
  - BIOS CMOS date/time functions will now idle the CPU 4 times after reading
    or setting the clock to allow interrupts, CPU time, and RTC clock ticks
    to proceed normally. This fixes "Pizza Tycoon" and allows it to continue
    past the initial logo. (joncampbell123)
  - Fix segfault when mounting hard disk images with no file extension
    (joncampbell123).

2023.09.01
  - Disable by default message confirmation after snapshot and AVI video
    capture, but leave the option there for those who want to enable it (joncampbell123).
  - Remove "LOG: Logging output has been disabled." output when -nolog
    is specified on the command line (joncampbell123).
  - Fix stuck Ins key problems by fixing a typo in src/ints/bios_keyboard.cpp.
    The code is supposed to clear the "Ins key down" flag, but instead cleared
    all bits EXCEPT "Ins key down" (joncampbell123).
  - NE2000 macaddr default is now "random", which instructs the NE2000
    hardware at startup to pick a random MAC address. (joncampbell123).
  - IPX: If NE2000 and IPX are enabled, and an IPX tunneling connection is
    active, and the user boots a guest OS, switch on a mode where all IPX
    packets going to and coming from the guest are re-routed through the
    IPX tunnel instead of to the NE2000 ethernet backend. This feature
    makes it possible to play IPX-based games in a guest OS like MS-DOS
    and Windows 95. (joncampbell123).
  - IPX: Add extension to server to allow clients to register their own
    MAC address instead of using the default MAC address given by their
    IP address and port number. The extension is designed so that if DOSBox-X
    is a client to another DOSBox fork's IPX tunneling server, it will
    be ignored and DOSBox-X will get the usual MAC address instead. This
    extension is required for guest OSes to be able to use the IPX protocol
    through the NE2000 card given upcoming code changes as they normally
    use the network card MAC address when picking an IPX address because
    the IPX interface is not available once booted into a guest OS. (joncampbell123).
  - IPX client: If both IPX and NE2000 emulation are enabled, IPX emulation
    will use the NE2000 card's MAC address instead. It will use the IPX
    server DOSBox-X extension to try. If it doesn't work, then the normal
    MAC address assignment is accepted without complaint. (joncampbell123).
  - NE2000: Add "nothing" backend. It receives nothing and send packets go
    nowhere. If no other backend is available, this backend is a fallback
    so that at least the NE2000 emulation can work. The other purpose of
    a nothing callback is to give NE2000 something to talk to for those
    who wish to use the upcoming IPX packet redirection to link DOS and
    Windows games over the IPX client or server connection to other
    instances of DOSBox. (joncampbell123)
  - Added record function to capture NE2000 network traffic to a
    pcap/Wireshark file in the capture directory. (joncampbell123)
  - Fixed bug where guest VM reset causes the CMOS to stop ticking for
    exactly the amount of time it was running before reset. (joncampbell123)
  - Added alarm interrupt function to RTC CMOS emulation (joncampbell123)
  - Reverted DOS to using the BIOS_DATA tick count for time and the cached
    copy of date it keeps internally, rather than always calling INT 1Ah.
    It turns out that is how DOS actually behaves, which is also why it is
    possible for the DOS and CMOS RTC to diverge. Fix CMOS emulation to
    allow get/set time and to run in emulation time, not real time, though
    the clock starts from the host time. (joncampbell123)
  - Fixed VHD disk image calculation of footer position and, thus, of newly
    allocated block position. (maxpat78)
  - Enhanced Dynamic and Differencing VHD support #4273 (maxpat78)
  - Imported IBM Music Feature Card support from DOSBox Staging. (Allofich)
  - Fix IMGMAKE large size image error on MinGW builds (maron2000) 
  - Set usescancodes=true when non-US keyboards are detected. (Linux / MacOS 
    builds) (maron2000)
  - Fix day of week detection (INT 21h function 0x2Ah). (maron2000)
  - Refine KEYB and CHCP command (maron2000)
  - Use segment descriptor's big flag (if present) when disassembling code in
    the debugger code view (cimarronm)
  - Add decoding of rdmsr/wrmsr instructions to disassembler (cimarronm)
  - Fix disassembly for far jmp/call decoding (cimarronm)
  - Fix memory limits on expand-down segment descriptors (cimarronm)
  - Bump tinyfiledialog to ver 3.13.3 (maron2000)
  - Fix mouse column limit on text mode (issue #4353) (maron2000)
  - Fix Blocek launching failure (issue #4385) (maron2000)
  - Bump in-tree FreeType library to ver 2.13.1 (maron2000)
  - Enable debugger function for MinGW builds (maron2000)

2023.05.01
  - IMGMAKE will choose LBA partition types for 2GB or larger disk
    images, but the user can also use -chs and -lba options to override
    that choice. The CHS or LBA partition types do matter because it
    affects which version of INT 13h is used by Windows 98/ME to boot up
    and, if drive C: is in compatibility mode, at all times. (joncampbell123)
  - PC-98 256-color mode will also trigger the auto mode of "render on
    demand" for performance reasons because per-scanline raster effects
    are very unlikely in that case, as will MDA and Hercules machine
    types. (joncampbell123)
  - When the DOS IDLE API is enabled (by default), limit STI+HLT to
    occur on INT 28h only once after any call to read the CON device
    or call to BIOS INT 16h to read the keyboard. This fixes stalls
    and sluggish input problems with programs that like to call INT 28h
    often like the Pacific C compiler PPD IDE interface. (joncampbell123).
  - Hercules InColor machine type: Fixed attribute and RAMFONT handling
    of 48K RAMFONT mode and added planar text rendering. (joncampbell123).
  - Write BIOS data area fields for number of rows, char height, etc.
    for MCGA machine type in addition to EGA/VGA machine types because
    IBM technical references suggest it's there for MCGA as well.
    This also resolves an issue where with the MCGA machine type, INT 10h
    failed to print any text to screen whatsoever. (joncampbell123).
  - Render on demand (Staging calls it "lazy rendering") now defaults
    to "auto" and allows an "auto" setting. The auto setting will
    turn it off for standard VGA modes and will turn it on for SVGA
    modes where per scanline raster effects are very unlikely to
    occur. This may provide a performance boost for DOS games in SVGA
    modes and the Windows desktop (joncampbell123).
  - CGA 320x200 4-color mode is now rendered using the M_EGA render
    code for EGA/VGA machine types to better reflect real hardware.
    (joncampbell123).
  - Fix bug where setting doublescan=false for anything other than
    the VGA machine type would break CGA graphics modes.
    (joncampbell123).
  - Fix video debug overlay calculations of source video mode for
    CGA graphics modes. (joncampbell123).
  - CGA 640x200 2-color mode and MCGA 640x480 2-color mode are no
    longer rendered as M_CGA2 for EGA/VGA machine types. The reason
    is that at the hardware level they are really just IBM standard
    tweaked versions of the EGA/VGA 16-color modes with additional
    bits for the interleave emulation and can be properly emulated
    with the M_EGA renderer. M_CGA2 is still used for the CGA and
    MCGA machine types for those modes. The DCGA DOS/V mode has been
    carefully made into its own render mode instead of part of the
    M_CGA2 case. (joncampbell123).
  - Fixed refcount -1 error and abort when multiple floppies are
    attached to a floppy drive and the "Swap floppy" mapper shortcut
    is used at least once (joncampbell123).
  - Hercules palette selection now provides a "dark gray" color
    mapping to match the green, amber, or gray palette selection of
    the user (joncampbell123)
  - Fix Hercules vs MDA attribute handling of "dark gray" background
    color when hardware blink is disabled. (joncampbell123)
  - Added RAMFONT emulation to Hercules Plus machine type, fixed code
    to allow Hercules Plus text mode to draw farther than the first 4KB
    of RAM if RAMFONT enabled. (joncampbell123)
  - DOS kernel: Fix programming mistake that allocated perhaps a bit
    too much DOS kernel memory for the "List of Lists" info block.
    Fix the sizes of the info block and other structures to make sure
    specific kernel structures are placed at fixed addresses because
    later Microsoft software for MS-DOS checks those values.
    (joncampbell123)
  - Serial port: Add multiplier: setting as requested to enable
    faster than 115200 baud rates. (joncampbell123)
  - Fix mistakes in CPUID emulation that threw a #UD exception for
    specific cases where EAX was not recognized by particular CPU
    types. (joncampbell123)
  - Fix RTC clock emulation to correctly signal IRQ8 interrupt for
    both periodic tick and update-ended events. Prior to this fix,
    only periodic tick events were reported even if the bit was set
    to enable update-ended. (joncampbell123)
  - Fix serial and AUX PS/2 mouse emulation to not send relative
    motion unless mouse captured, to make it consistent with the
    BIOS PS/2 mouse emulation (joncampbell123)
  - FAT driver: Major performance boost is possible by eliminating
    unnecessary code that re-reads the entire directory when looking
    up or changing one particular directory entry. (joncampbell123).
  - CMOS registers: Fix code to allow getting and setting time,
    fix year vs century registers to work properly. (joncampbell123).
  - BIOS INT 1Ah: Fix functions to get and set time and date
    instead of faking on read and ignoring set. Use the CMOS
    registers. (joncampbell123).
  - DOS INT 21h: Fix date and time functions to call the BIOS for
    time instead of trying to fake it only at the DOS level. This
    includes allowing INT 21h to change the date/time using the
    BIOS. (joncampbell123).
  - DOS shell: Make TIME actually use INT 21h to set time instead of
    directly modifying the BIOS timer tick count in the BDA.
    (joncampbell123).
  - Increased PIC event queue size, there are corner cases especially
    with Windows XP that can occasionally overrun the queue.
    (joncampbell123).
  - Updated IBM PC keyboard emulation to correctly encode Pause and
    Print Screen key scan codes when shift, alt, and ctrl are held
    down. This makes it possible to type "Alt+SysRq" for programs
    that expect it, including SoftICE. (joncampbell123).
  - NE2000 emulation: Looking at recent Bochs source code, ne2k.cc
    appears to have downgraded the "IMR write, reserved bit set"
    message from BX_PANIC to BX_ERROR. Update the same in DOSBox-X
    so that Windows 2000 no longer crashes the emulator with E_Exit()
    when probing the NE2000 hardware. (joncampbell123).
  - INT 33h mouse services: Add "Get General Driver Information"
    function for Microsoft Word 5.5 (joncampbell123).
  - INT 33h mouse services: Render cursorType == 2 (graphics cursor)
    as if text cursorType == 0 if the current mode is text mode.
    Microsoft Word 5.5 always calls functions to set text AND graphics
    cursor regardless of whether the actual mode is graphics or not.
    This fix allows the cursor to show correctly as the block cursor
    it wanted in text mode instead of a moving hardware blinking cursor.
    (joncampbell123).
  - Fixed S3 XGA emulation bitmap rendering to correctly handle
    8/16/32-bit pixel transfer I/O and update comments to reflect
    the 32-bit byte aligned transfer mode of the Trio chipset.
    This fixes incorrectly drawn radio buttons and 16x16 icons
    in Windows NT 3.5, Windows NT 3.51, Windows NT 4.0, and
    Windows 2000. (joncampbell123).
  - Fixed keyboard emulation so that upon the keyboard reset command
    FFh, the keyboard does the reset process and THEN sends back
    bytes 0xAA (power on/reset OK) and 0x00 (interface self-test).
    This resolves the issue where Windows NT 3.1 pauses at startup and
    does not resume booting until you press a key on the keyboard.
    This also resolves the issue where Windows NT 3.5 keyboard and
    mouse input stops working completely if you press a key on the
    keyboard. (joncampbell123).
  - Add Hercules InColor emulation of MDA vs CGA attribute select,
    and make sure it obeys the blink setting (joncampbell123)
  - Change Hercules/MDA text output to render 9 pixels per char
    if the char9 setting is on, to match the 9x14 character cell
    that those cards emit to the screen. The user can always turn
    it back off to get the 8x14 text they're probably accustomed
    to in other DOSBox forks. (joncampbell123)
  - Render output fixed to never double pixels vertically on render
    if the machine type is emulating VGA and the Doublescan option
    is enabled, in order to help resolve SVGA text mode issues
    reported by ThomasKjoernes (joncampbell123)
  - Add InColor CRTC registers and add code to emulate the planar
    bitplane operations. Microsoft Flight Simulator 3.0 renders
    correctly now. (joncampbell123)
  - Update Hercules InColor code to render the same 64-color EGA
    palette as machine=ega. (joncampbell123)
  - Correct machine=hercules text rendering flaw that prevented
    the bright attribute (bit 3/7) from working, making all text
    output the same normal brightness. (joncampbell123)
  - Add expected data structures and signatures to VGA ROM BIOS at
    C000:0000 if machine type selects ATI emulation (joncampbell123).
  - Add ATI machine types, which at this time, is just a placeholder
    for development to go in that direction over time for those
    machine types. (joncampbell123)
  - Added "machine=hercules_plus" and "machine=hercules_incolor" as
    stubs to be developed on going forward to emulate the HGC+ and
    InColor cards. Note that InColor will require the MCH_HERC case
    to generate 64-color EGA-like output going forward even if the
    documented startup state still emulates the MDA-like monochrome
    attributes. (joncampbell123)
  - SDL2: Stop checking for compiler flags that make it an error to
    declare variables after statements in a function or any other
    terrible sins that would offend old C89 standard compilers.
    DOSBox-X is never going to compile for a C standard that old.
    Furthermore this check is preventing compilation on ARM-based
    Macbooks for some reason, though not Intel based Macbooks.

2023.03.31
  - "mount -t overlay" will now print a message on the console to
    let you know if the act of mounting the overlay replaced a
    previous overlay mount. Overlay mounts cannot be stacked in
    DOSBox-X (and probably most DOSBox forks that support overlays)
    and the user should understand that. (joncampbell123).
  - Remove kludges from DOS path resolution to handle drive paths
    that refer to drive @ (at sign). Note that in ASCII the at sign
    is one code below capital "A". Windows 95 FORMAT.COM due to
    another issue was asking for "@:\WINBOOT.SYS" and sometimes
    causing a segfault in DOS path resolution due to an uninitialized
    drive index. The fix for the other issue removes the need for this
    kludge. In it's place a message will be logged to your log file if
    anything attempts to access files on drive "@:" because it likely
    means a failure to determine the drive index properly. (joncampbell123).
  - In addition to reporting the "boot drive" via INT 21h AX=3305h, also
    write boot drive in the "List of Lists" structure. Windows 95
    FORMAT.COM reads the boot drive from the LoL and does not do any
    error checking if that value is out of range (such as if it was
    never set and the byte value is zero). Failure to set this field
    will result in FORMAT.COM attempting to access "@:\WINBOOT.SYS"
    and "@:\IO.SYS" and failing. (joncampbell123).
  - Add dosbox.conf option to set a fixed RTDSC tick rate to use at
    all times during emulation instead of the CPU cycle count
    (joncampbell123).
  - Fix RDTSC to maintain a monotonic increasing count even if the
    CPU cycles count changes, and better handle timestamp writes
    through WRMSR (joncampbell123).
  - FAT filesystem driver: Instead of searching from cluster 0 every
    time a new cluster is to be allocated, keep track of the search
    to help reduce slowdowns on fairly large filesystems when many
    files are copied onto it (joncampbell123)
  - Page Up/Down vs Roll Down/Up was in the wrong order, switch order
    to correct it. (joncampbell123)
  - Fix 'pc98 force ibm keyboard layout' was always forced to be 'true'
    for left & right bracket keys on US keyboards. (maron2000)  
  - Fix dynamic_nodhfpu FPU stack bugs, the same bugs that once plagued
    dynrec. dynamic_x86 never seemed to have the same problem because
    in reality the DH FPU case was normally used, to hit this bug you
    had to use core=dynamic_nodhfpu. Also fix dynamic x86 DH FPU code
    never to restore from DH case if the DH FPU code was never enabled,
    which periodically caused FPU state to disappear. (joncampbell123).
  - Add dosbox.conf option to control the MSCDEX.EXE device name when
    emulating a CD-ROM drive (joncampbell123).
  - Wengier coded this nice text-only DOSBox-X logo for the TTF output.
    Fix border alignment issues and make the text logo the default and
    only option for MDA and Hercules machine types at boot.
    (joncampbell123).
  - Add -print-ticks command line option, which enables code to print
    both SDL_GetTicks() and emulator time once a second to the console
    and the log file. This may help in tracking down bugs related to
    long term laptop suspend or suspension of the process in general.
    (joncampbell123).
  - PC-98: Ignore INT 18h AH=0Ch (enable text layer) in 256-color mode.
    Real hardware doesn't seem to let you turn on the text layer in
    256-color mode, though I am not certain if this is a restriction
    imposed by the BIOS or by the hardware. This fixes possible cases
    where Sim City 2000 in 256-color mode reveals garbage text data at
    the bottom of the screen if it is there when it starts. This doesn't
    fix the issue where Sim City 2000 cannot set 640x480 256-color mode
    properly unless your display is already set to 31Khz hsync because that
    is evidently a bug in the game, not DOSBox-X. (joncampbell123).
  - PC-98 256-color mode: Fix "Active Display Words" value set by INT 18h
    to 40, not 80, for graphics layer. This has no apparent effect on
    games but it does fix the sometimes erroneous graphics layer width
    in the video debug display. Neko Project II source code seems to
    indicate the 31KHz hsync mode is programmed that way even if 256-color
    mode. This should not break anything since the GDC doesn't let you
    read back the "SYNC" reset parameters anyway--this isn't VGA hardware,
    after all. (joncampbell123).
  - IPX emulation was broken because it set up the virtual file, IRQ
    and interrupt handler way too early, which the BIOS startup would
    then overwrite with the default BIOS IRQ handler. IPX emulation
    should work now, at least multiplayer DOOM. (joncampbell123)
  - Added debug menu and dosbox.conf option to show debug information
    at the bottom of the screen when enabled. This debug information
    reflects the video state at the start of active display. It can be
    used to see in real time the state of the palette, display offset,
    display stride, and other useful information. It is rendered into
    the frame on purpose so that it appears as part of the picture
    when you take a screenshot or record a video to AVI or MTS for
    later review. (joncampbell123)
  - Dynamic core: Fix serious bug in dynrec dynamic core where calls
    to handle x86 FPU instructions erroneously passed the entire
    FPU status word instead of passing only the FPU stack pointer.
    The result of this error was that floating point was erratic,
    buggy, and often caused memory corruption in DOSBox-X eventually
    leading to a crash. It should now be possible to properly run
    DOS games on dynrec based systems, including ARM-based M1 Macbooks,
    that use the FPU. (joncampbell123)
  - Debugger: When entering debugger interface, force dynamic core
    to flush it's state so that the debugger can show the correct
    state to the user when they use the "FPU" command to see it.
     (joncampbell123).
  - VGA emulation: Automatically ignore odd/even mode if "Chain 4"
    mode is enabled in the sequencer (normally enabled only for
    256-color mode). Some games accidentally set odd/even mode
    in 256-color mode and yet apparently worked just fine on real
    hardware. Without this change, such games will display distorted
    graphics. It makes logical sense "Chain 4" would take priority
    over odd/even mode. Note: If a game uses 256-color unchained mode
    AND foolishly enables odd/even mode, then the resulting distorted
    graphics are probably accurate to what would happen on real
    hardware, but then programmers would have caught their mistake
    and fixed it so that is very unlikely to occur. This helps to fix
    "Seal: Magic Eye" although some remaining visual artifacts in the
    game can only be resolved by setting machine=svga_et4000
     (joncampbell123).
  - Set usescancodes=true when non-US keyboards are detected
     (Windows builds) (maron2000)
  - For long double without using x86 FPU, the code still calls the
    fstcw instruction and can enable FPU exceptions that crash the
    emulator, therefore mask off all exception bits to stop that.
    (joncampbell123)
  - Added code to mouse emulation to control how often the mouse
    reports events through the interrupt. Added dosbox.conf option
    to allow the user to force a report rate, which can be used to
    force a lower than normal report rate for games that cannot
    properly handle higher ones. Allow PS/2 mouse emulation, if
    rate not set by user, to control report rate. (joncampbell123).
  - Add code to COMMAND.COM to flush keyboard input before running
    the command given by the user, and flush again when the command
    returns. Added option to dosbox.conf to enable/disable this
    function (joncampbell123)
  - Fix bug where Tandy mode ignored the "allow more than 640kb"
    setting.
  - Fix INT13h AH=02 broken conditional branch which prevents
    installer of game "Inherit the Earth: Quest for the Orb"
    to obtain free space of hard drive (maron2000)
  - qcow2 image support: Make image able to be mounted by
    drive letters (experimental) (maron2000)
  - VHD image support: Make file name check for .vhd extension
    to be case insensitive (maron2000)
  - VHD image support: Fix auto-detection of geometry (maron2000)
  - Sound Blaster: Added code to periodically check the user's
    settings regarding recording source selection and listening.
    This should allow the user to change those settings on the
    fly. (joncampbell123).
  - Sound Blaster: Added options to control whether the generated
    recording source is audible through the speakers, and what
    generated audio to send to the client. Options are: silence,
    hiss, and a 1KHz test tone. (joncampbell123).
  - Sound Blaster: If the DSP is recording rather than playing,
    then send audio to the guest at the recording sample rate
    containing some form of generated audio. Default is silence.
    This ALSO satisfies the Creative driver CTSB16.SYS when it
    does the DMA test at startup. (joncampbell123).
  - Sound Blaster: Fixed code to properly recognize when the
    guest wants to record audio, including through SB16
    commands. Prior to this fix, all SB16 Bxh-Cxh commands
    were handled as if playback even if the command would
    instead trigger recording. (joncampbell123).
  - Sound Blaster: Add missing update of "last DMA callback"
    timestamp that is needed for when the guest pauses DMA
    during playback or recording. (joncampbell123).
  - VHD image support: If the VHD image is not a fixed type,
    say so in the log (previously it said nothing) and say
    what kind of image was mounted (joncampbell123).
  - Added INT 13h AH=44h Extended Verify to satisfy any disk
    utilities that might use it. The function doesn't really
    do anything except return success (joncampbell123).
  - Fix CPU stack management to use CPU mode agnostic method
    using mem_readw instead of real_readw. However the real
    mode version is used if real or virtual 8086 mode because
    of comments in an older commit that mention UNLZEXE that
    depends on real mode stack pointer rollover. This fixes
    a bug related to protected mode APM (Advanced Power
    Management) emulation that prevented the Linux kernel
    from booting (joncampbell123).
  - Add support for INT 2F function 1680h "Idle" and DOS
    idle (INT 28h), add code to reduce DOSBox-X CPU load
    during emulation when the idle function is called,
    add dosbox.conf enable/disable (default enable) to
    control this behavior (Github user "finalpatch")
  - Graphical fixes and dialog support for Haiku OS (amol-)
  - Allow jp106 keyboard layout in DOS/V mode, automatically
    choose when keyboard layout is auto on Windows with
    Japanese keyboard, fix jp106 input in SDL1 builds running
    on Japanese Windows with English keyboard (nanshiki)
  - Sync dh fpu state with normal fpu when dynamic core
    calls normal core to handle self modifying code. Add
    additional code to other cases. (Github user "finalpatch")
  - Fix incorrect handling of upper 4 bits of character attributes
    in video mode 72h in DOS/V mode (nanshiki)
  - Fix BIOS signature at 0xFFFFF to reflect actual value
    of Tandy machines so "Ninja" works correctly in
    Tandy mode (rderooy)
    See also: [https://www.vogons.org/viewtopic.php?f=32&t=92129]
  - Change default mixer rate to 48KHz instead of the
    long standard 44.1KHz. Most modern sound cards on
    modern OSes render at 48KHz anyway and resample
    either in hardware or software and most configurations
    render at 48KHz. Perhaps somewhat improved audio quality
    could be had by rendering at what most sound cards are
    doing these days anyway. As usual, audiophiles are free
    to set the mixer rate to 96KHz if supported by their
    sound card. (joncampbell123)
  - Fix PIT 0 timer interrupt handling not to attempt
    periodic event and error adjustment unless the game
    is using periodic modes 2 or 3. This fixes PIT timing
    bug and possible emulator hang when exiting games
    like "Days of Thunder" that leave PIT 0 in mode 0 or
    1 on exit for some reason. (joncampbell123)
  - Fix Sound Blaster DMA rate limits to better reflect
    actual hardware. SB16 limits to 45454Hz just as
    Pro and earlier do. These limits were added before
    the proper measurements were coded and tested on
    real hardware. (joncampbell123)
  - Fix S3 cursor emulation to support both X11 and
    Windows hardware mouse cursor modes available
    on S3 Virge, Trio, and possibly other cards
    (John Tsiombikas)
  - Add EGA/VGA emulation code to keep track at runtime
    whether planar features are in use. If they are not,
    then handle EGA/VGA video memory access using a
    simplified version for a bit of a performance boost
    in response to complaints about poor VGA emulation
    performance. (joncampbell123)
  - VGA palette DAC update: Instead of recalculating
    the palette map every time a color is written through
    port 3C9h, set a flag. Defer palette map update to
    when the next scan line is rendered, in order to
    improve performance. (joncampbell123)
  - Add option to enable or disable the "memory I/O
    optimization" option, meaning the code that was
    added to assign simplified VGA memory I/O handling
    when the DOS game is not using any bit planar raster
    op and more complicated features of the EGA/VGA
    hardware. (joncampbell123)
  - Added VGA render on demand mode to VGA emulation.
    When enabled, VGA emulation does not render scanlines
    until vertical retrace or when certain registers are
    written that change the display (attribute controller,
    VGA palette, etc.). It is added to dosbox.conf as
    "scanline render on demand" and is false by default
    because it can provide a performance boost for DOS games
    but it also tends to break timing-dependent Demoscene
    effects. The idea is that some emulator performance
    improvement may be possible by not interrupting the
    CPU loop per scanline for the same reason that DOSBox
    SVN has traditionally only rendered the VGA display
    in quarters instead of per scanline. (joncampbell123).
  - Remove experimental "alt VGA" rendering code. It was
    never completed and it is probably starting to
    bitrot (joncampbell123).
  - Fix EGA/VGA version of CGA 4-color graphics renderer
    code to consider all four bitplanes when combining
    each pair into a 2-bit value. When bitplanes 2+3 are
    enabled and writeable, the 4-color mode becomes a
    sort of 2-plane 2 bits per pixel 16-color mode. Fix
    for machine=ega and "Leather Goddess of Phobos 2",
    a game that sets up EGA 640x200 16-color mode then
    suddenly switches on the 2bpp CGA mode as a way to
    do 16-color dithered graphics. (joncampbell123).
  - Fix installers for Dynamix games not working.
    (Allofich & halcyon00)
  - Fix crash related to swapping between disk
    images. (Allofich)
  - SVN r4482: Correct CMS sound pitch. (Allofich)

2022.12.26
  - Allow more than 640KB of conventional memory,
    regardless of "allow more than 640kb" option, for
    Tandy machine type. The setting is capped to 768KB
    to reflect Tandy systems with that upgrade, which
    is said to allow a full 640KB for DOS and 128KB for
    video RAM without any conflict from the MCB chain.
    Adjust Tandy video emulation for 768KB case. This
    fixes "Might and Magic III Isles of Terra" crashes
    in Tandy mode and Tandy graphics because the game
    does not correctly handle the memory configuration
    when less RAM is involved. (joncampbell123).
  - Fix code page CPI/CPX loader to allocate 128KB of
    memory instead of 84KB. The code allocates a 64KB
    stack for the executable code within. The 84KB
    allocation permitted the initial stack pointer to
    exist beyond available conventional memory if
    conventional memory size was below about 156KB and
    cause a crash. This is a quick fix, a long term fix
    would be to instead set the initial stack pointer
    to some offset below 0xFFFE based on available memory,
    just as the .COM executable loader was modified to do
    some time back to enable proper execution when
    memsize < 64KB. (joncampbell123)
  - Do not load country/font information at startup
    if the code page to load is the same as the default
    code page. (joncampbell123)
  - Fix Tab/Shift+Tab in Configuration GUI regarding
    setting text fields that have a ... button to select
    from an enumeration. Those buttons are no longer a
    trap for tab enumeration. (joncampbell123)
  - Fix Mac OS SDL1 keyboard support code to properly
    fill in unicode character values in relation to
    IME checks. This fixes a problem where it was
    impossible to type anything in the configuration GUI
    in SDL1 Mac OS builds. (joncampbell123)
  - Mark VBE mode 0x212 as "do not list" so that it does
    not appear in normal VBE mode enumeration, while
    keeping it valid for the Windows 3.1 driver which
    assumes the mode is there at that number without
    enumeration. By not listing the mode, drivers like
    VBEMP and DOS application code will not attempt to
    use it. There is already another mode number for
    640x480 24bpp anyway. (joncampbell123)
  - Fix VBE mode 0x212, which is 640x480 24bpp packed
    mode but with a per scanline stride of 2048 bytes
    per pixel set aside for the Windows 3.1 driver and
    the "640x480 (1Meg) 16 million colors" setting,
    so that the VBE "Get Mode Info" call reflects the
    proper per-scanline stride instead of the ideal one.
    This should fix complaints about VBEMP and 640x480
    24-bit color mode. Given how minimal the use of the
    mode is by the Windows 3.1 driver, the 2048 byte
    mode does not permit setting scan line length or
    display start i.e. panning is not permitted.
    (joncampbell123).
  - Fix Pentium Pro emulation to support microcode
    related MSRs so that Windows 98 does not crash
    on startup when cputype=ppro_slow. (joncampbell123).
  - Added SMV debugger command. This is the linear
    (virtual) equivalent of the SM "Set Memory"
    command. (joncampbell123).
    (https://github.com/joncampbell123/dosbox-x/issues/3826)
  - Fix debugger help command to list both C / D commands
    and the DV/DP commands. (joncampbell123)
  - Add VGA FONTDUMP debugger command for those
    who might want to take custom fonts in text
    mode and do something with them outside the
    emulator. "VGA FONTDUMP" followed by a filename
    which must have the extension .BIN (for a raw
    64KB dump of font RAM) or .BMP (for a formatted
    dump as a monochrome bitmap file). (joncampbell123).
  - Disabled code to randomly return GDC drawing
    status active. The implementation was causing
    severe performance issues. The code has not
    been removed because it could be optimized and
    fixed and could even follow the state of GDC
    drawing. (joncampbell123)
  - VGA 6-bit DAC mode expand to full 8-bit range,
    instead of simple shifting (joncampbell123).
  - Fix 8254 PIT emulation (joncampbell123)
  - Add dosbox.conf option "cpuid string" to allow
    CPUID to return custom ID strings instead of just
    "GenuineIntel". Have fun! (joncampbell123)
  - Fixed build to properly compile against internal
    SDL/SDL2 library even if an external version is
    available (joncampbell123)
  - Fixed some violations of the one definition rule.
    (Jookia)
  - Use pkg-config to find OpenGL (Jookia)
  - Updated Flatpak SDK and dependencies (Jookia)
  - PC-98 Implement AVSDRV.SYS PCM function (int D9h)
    (nanshiki)
  - PC-98 Support 6x8 Katakana font with int 18h ah=14h
    (nanshiki)
  - PC-98 Fix Audio Q-Channel info in MSCDEX (nanshiki)
  - Fixed FFMPEG 5 compatibility (Jookia)
  - Fix FFMPEG crash if FFMPEG fails to write header
    for some reason. (joncampbell123)
  - Fix setcap on systems with split /usr (Jookia)
  - Fix building with --disable-core-inline (Jookia)
  - Fix building not finding fluidsynth (Jookia)
  - Fix some NetBSD build issues
    (Jookia, with patch from Nia)
  - Fix minor graphical issues in mapper GUI (aybe)
  - Removed --disable-core-inline (Jookia)
  - Swap SDL2 XInput axes by default for a better
    out of the box experience (aybe)
  - SDL1 XInput is now enabled by default for
    a better out of the box experience (aybe)
  - add set of cga shaders from dosbox staging (aybe)
  - Updated mt32emu code to latest(2.7.0).(maron2000)
    Also, added config option "mt32.engage.channel1"
     (Refer to https://github.com/munt/munt for details)
  - Fix missing line in printouts (Issue #3569)
    (maron2000)
  - Adjust Int 11 return value to better match real
    BIOSes. (Allofich)
  - Limit the "always return bit 6 of port 61h as set
    for PC" change to only apply to early PC types
    (MDA, CGA or Hercules). (Allofich)
  - Integrated SVN commits (Allofich)
    - r4476: Preserve last error code when no error
    occurs.
    - r4477, r4478: Drive system improvements.
    - r4479: Correct handling of invalid encodings of
    the BOUND instruction.
    - r4480: Some confirmed DOS behaviors and minor
    cleanup.
    - r4481: Push registers for most DOS function calls;
    prevents a bug in UNLZEXE from causing a crash, and
    maybe helps other buggy programs and unusual cases.
    Use real addressing to support stack pointer wraparound.
  - Fix Opl3! Duo and Opl2 Audio board audio playback on 
    unix (stengun)
  - Fix Japanese input related issues (nanshiki)
  - Fix START command only ever opens first file
    (NebularNerd, darac-10, aybe)
  - Win32 logging console (aybe)
    - add 'Debug/Clear logging console' menu entry
    - ensure main window stays above it when shown
  - Fix overflow in mapper info on SDL2 builds (aybe)
  - Enable OpenGL output in MinGW builds again (maron2000)
  - Fixed to display IME marked text in SDL2 version on 
    macOS (nanshiki)
  - Fix allocation of IDE slots when mounting images by 
    IMGMOUNT (maron2000)
  - Increase of sprintf buffer size in Program::WriteOut()
    (caiiiycuk)
  - Fix unexpected behavior of swapping multiple CD images
    (maron2000)
  - Fixed build on NetBSD and FreeBSD (Jookia)
  - Updated FFMPEG video capture to use newer API,
    fix memory leaks, and fix use-after-free bug that
    may have been responsible for occasional crashes
    when using the function. (joncampbell123)

2022.09.0 (0.84.3)
  - Added 86PCM support for PC-98 emulation. (nanshiki)
  - Added German language translation. (Link-Mario)
  - Added code page 867 (compatible with Hebrew DOS
    WordPerfect) and 868 (Urdu) for the guest-to-host
    code page conversions. (Wengier)
  - Improved ANSI.SYS detection for the welcome banner
    and CLS command. The command "INTRO WELCOME" will
    re-display the welcome banner without running the
    commands in AUTOEXEC.BAT. (Wengier)
  - Improved IME support on macOS SDL2 build. (Wengier)
  - Improved detection for the Chinese/Japanese/Korean
    keyboard layouts on Windows platform. (Wengier)
  - Improved Windows installer for selecting languages
    for the DOS emulator. (Wengier)
  - Improved config option "file access tries" for the
    Linux and macOS platforms. (Wengier)
  - Fixed SafeDisc 2 check for Red Alert 2 by renaming
    the IDE CD-ROM device. (rderooy & psyraven)
  - Fixed problem when inputting characters with call
    INT21/AH=3Fh in PC-98 mode. (nanshiki)
  - Fixed hang on zip-mounted drives and minor bug on
    the DOS file-read code. (tbr)
  - Fixed file copying problem with Windows 9x install
    at the end of the DOS-based Setup. (Wengier)
  - Fixed command like "IF NOT EXIST D:\NUL ..." not
    working if the drive does not exist. (Wengier)
  - Fixed that pasting text from clipboard via mouse
    may not work properly in some cases. (Wengier)
  - Fixed the mouse scrolling wheel not working with
    CTMOUSE 2.1's "CTMOUSE /O" in guest DOS. (Wengier)
  - Fixed window transparency setting not working in
    macOS SDL1 build. (Wengier)
  - Fixed macOS small display issue with the in-tree
    SDL2 library by applying SDL updates. (Wengier)
  - Fixed menu option "Always on top" to work with the
    in-tree SDL2 library on macOS. (Wengier)
  - Fixed the terminal mess-up issue with -display2
    option on Linux and macOS platforms. (Wengier)
  - Fixed OpenGL output options not working in Windows
    ARM32/ARM64 builds. (Wengier)

2022.08.0 (0.84.2)
  - Fill in PC-98 BIOS data area byte value indicating
    CPU type (whether 8086, 286, 386 or higher)
    (Wengier), fill it in at startup (joncampbell123).
  - CHOICE now supports breaking and errors on end of
    file or pipe instead of freezing DOSBox-X. (Jookia)
  - Fixed debugger commands parsing numbers wrong. (Jookia)
  - Fixed DIR crashing on volumes with more than
    999,999,999,999 bytes of free space. (Jookia)
  - Switched to year.month.patch versioning (Jookia)
  - Fix NE2000 panicking if packets are queued too fast.
    (kcgen, Jookia)
  - Fix ISO image format detection to support pure
    UDF formatted images, meaning that the image
    lacks any ISO 9660 features and contains only
    UDF. (joncampbell123).
  - Added support for UDF filesystem to ISO image
    handling. It is enabled by default if emulating
    MS-DOS 7.10 (aka Windows 98) or higher.
    (joncampbell123).
  - Added code to detect Rock Ridge according to the
    System Use Sharing Protocol standard, and to
    read the SUSP entries correctly for the alternate
    name, if enabled. (joncampbell123)
  - Updated ISO MSCDEX drive emulation to scan the
    available volumes in the ISO image rather than
    assume the first volume, which makes Joilet
    support possible if long filenames are enabled
    and the DOS version is 7.0 or higher. (joncampbell123).
  - Add IMGMOUNT -o option for ISO filesystem support
    to enable/disable Joliet extensions, which is a
    Microsoft extension to ISO 9660 where long names
    encoded using Unicode UCS-16 exist as a supplementary
    volume in the ISO image and are used by Windows 95
    and higher to support long filenames on CD-ROM.
    Added support for reading the Joliet volume and
    providing them for both the 8.3 and long filename
    APIs in DOS. (joncampbell123).
  - Add IMGMOUNT -o option for ISO filesystem support
    to enable/disable Rock Ridge long filename support.
    The option is -o rr=1 to enable and -o rr=0 to
    disable. (joncampbell123).
  - Fixed 8.3 name generations on ISO drives with Rock
    Ridge extension. The ISO drives can be refreshed
    via RESCAN command like other drives. (Wengier)
  - SDL_Net support is available for HX-DOS builds,
    similar to other builds. Packet driver is needed
    for network capability in DOS. (Wengier)
  - Fixed line endings when copying to shared clipboard
    (e.g. CLIP$) in non-Windows platforms. (Wengier)
  - Fixed problems with SDL1 Windows builds in which
    the user had to type the Fullscreen mapper shortcut
    twice. It seems a SDL1 library function that is
    used to indicate ignoring or adding a class of
    events also liked to flush the event queue. This
    is called on mode change. This caused lost
    keystrokes, leaving the mapper the impression that
    those keys were still held down. (joncampbell123).
  - Fixed PC-98 mode MS-DOS 7/Windows 9x boot disk's
    80386 CPU check. (Wengier)
  - Added support for auto-converting non-image drives
    (such as mounted local drives) to disk images, so
     that they will be visible when booting into guest
    systems. A config option "convertdrivefat" (in
    [dosbox] section) is added to toggle this setting,
    or you can toggle via BOOT command's -convertfat
    (or -convertfatro option for read-only access) and
    -noconvertfat options. There're also config options
    "convert fat free space" (in [dosbox] section) and
    "drive z convert fat" (in [dos] section) to control
    free space (in MB; 0 means read-only) and whether
    to also convert virtual drive Z:. Much of the code
    is imported from DOSBox Pure, with added support
    for PC-98 HDI and code page conversions. (Wengier)
  - Added menu option "Save to disk image" (under drive
    letter in "Drive" menu) to save a mounted non-FAT
    drive to selected disk image (IMG/HDI). (Wengier)
  - Added the "Limit disk transfer speed" menu group
    (under "DOS") to toggle the hard & floppy disk data
    rate function. Also moved "Quick launch program..."
    menu from "DOS" menu to "Main" menu. (Wengier)
  - Added code pages 856 (Hebrew) and 859 (Latin 9) for
    the guest-to-host code page conversions. (Wengier)
  - Added config option to allow create of temporary
    devices for piping operations when a temporary DOS
    path is not available. (Wengier)
  - Added support for ATAPI raw sector reading with
    READ CD command. (schellingb)
  - Report bad sectors recorded in raw CD images as
    ATAPI read errors. (schellingb)
  - You can use CONFIG -set langcp=... to change the
    current language along with the embedded code page,
    or CHCP nnn:... to specify a language file as well,
    e.g. "CHCP 932:" or "CHCP 932:ja_JP" for Japanese
    code page and language file. Also improved -langcp
    option for SBCS code pages, and Windows installer
    will additionally set keyboard layouts for the
    selected languages. (Wengier)
  - Changed menu option "Restart DOSBox-X with language
    file..." to "Load language file..." for loading
    language files without rebooting DOSBox-X, unless
    a guest system is currently running. (Wengier)
  - Imported the more recent MBR code from FreeDOS to
    avoid the "boot menu" as in older code. (Wengier)
  - When changing TTF font, DOSBox-X will try to show
    the number of missing characters in the new TTF
    font (if any). (Wengier)
  - Fixed color becoming darker after changing TTF font
    multiples times in TTF output. (Wengier)
  - Fixed display of individual/total file sizes with
    DIR command when they are very large. (Wengier)
  - Fixed non-US code page conversions for mounted FAT
    drives. (Wengier)
  - Fixed incorrect message displays in Configuration
    Tool and Mapper Editor when booting into guest
    systems with language files. (Wengier)
  - Fixed possible "Path not found" bug when switching
    to code page 950 from another code page. (Wengier)
  - Fixed creating directories may not work properly
    for overlay drives on Windows systems. (Wengier)
  - Fixed -set and -get options of CONFIG command when
    there are spaces in property names, without having
    to prepend the section names. For example, command
    CONFIG -get "synchronize time" is supported just
    as CONFIG -get "dosbox synchronize time". Similar
    for -SET option when launching DOSBox-X. (Wengier)
0.84.1
  - Added dosbox(-x).conf option to enable workaround
    for errant DOS programs that set the TF (trap flag)
    and then crash. Added code to DOS kernel INT 01h
    handler to clear TF flag if instructed to by the
    dosbox(-x).conf setting which can prevent such
    errant programs from crashing. Needed for 1996 demo
    "Dyslexia" by Threesome. (joncampbell123)
  - Fix RETF instruction handling to only modify the
    low 16 bits of ESP in real mode, even if the
    immediate value for RETF is a large value like
    FFFEh (fix for Finster by Mad Scientists). Prior
    to this fix, it was possible to increment the
    upper 32 bits of ESP from real mode using a
    normal 16-bit RETF with a very large immediate
    value. This fix removes the need for the ENTER
    masking dosbox(-x).conf option entirely and allows
    Finster to run without it. (joncampbell123).
  - Added dosbox(-x).conf option to control whether the
    ENTER instruction masks the stack pointer to 64KB
    if the stack segment is 16-bit, which is off by
    default because real Intel processors do not do
    that. (joncampbell123).
  - Added dosbox(-x).conf option that can instruct EGA/
    VGA emulation to ignore the display blanking bit in
    the sequencer registers. Some games appear to have
    bugs in their VGA programming code that can
    accidentally set that bit and therefore show
    nothing on screen. Fix for 1996 game "Finster" by
    Mad Scientists. The game appears to make this
    programming mistake on any fork of DOSBox
    including DOSBox-X, and is reported to also make
    the same mistake on other emulators like 86box.
    However most forks of DOSBox have a matching bug
    in their VGA emulation that allows the blanked
    display to appear normally regardless of that
    register bit unless run with machine=vgaonly.
    It's unclear if there is anything about DOSBox
    or DOSBox-X emulation that causes the game to
    misprogram the registers. (joncampbell123).
  - If guest uses ENTER instruction from 16-bit code
    with 66h (32-bit operand) prefix, and the CPU is
    in real mode or the stack segment is 16-bit, mask
    stack pointer with 0xFFFF. This fixes 1996 game
    "Finster" by Mad Scientists (joncampbell123).
  - DOSBox-X will now search for resource files such as
    fonts and translations in the resource directory (
    C:/DOSBox-X in Windows, /usr/(local/)share/dosbox-x
    in Linux, and dosbox-x.app/Contents/Resources in
    macOS) in addition to other locations. (Wengier)
  - Updated DOSBox-X's integration device to version
    1.0.1, adding API calls such as DOSBox-X's version
    number and platform, and some DOS-related status
    such as DOS version number. (Wengier)
  - Improve the HX-DOS build package, including the
    TTF output support and accessory files. (Wengier)
  - Use long double for internal event scheduling
    if available, to improve accuracy (joncampbell123).
  - Fix remaining SDL2 Windows problems by adding
    missing break statement above window event
    handler. (joncampbell123).
  - Move "Always on top" menu option from "Video" to
    "Main" menu, also enabled for Windows/macOS SDL2
    builds when possible. (Wengier)
  - Add workarounds for SDL2 builds to avoid problems
    with window resize, menu update, and restore
    events that sometimes caused the emulator to hang
    on startup in Windows. (joncampbell123).
  - Add "Set transparency..." and "Set text in title
    bar..." menu options under "Video" to change window
    transparency and title bar text. (Wengier)
  - Add special properties to CONFIG command including
    "system" and "version". (Wengier)
  - Fix DOS 8.3 filename generations when there are
    special characters in the filenames. (Wengier)
  - Fix creation of disk images with spaces using the
    "Create blank disk image..." menu option. (Wengier)
  - Fix IMGMAKE to provide executable code in MS-DOS
    partition or floppy disk boot sector following
    the BPB, that prints "This is not a bootable disk"
    instead of leaving zeros that lead the CPU astray
    and possibly hang the system in the event anything
    tries to boot the partition (joncampbell123).
  - Fix emulator segfault on invalid encoding of
    BOUND instruction (joncampbell123).
  - Address auto-centering on mode change complaints
    by making the "-" setting of windowposition the
    default. (joncampbell123).
  - Added MinGW-lowend SDL2 build, which is compatible
    with Windows XP. Also updated the build selection
    page for Windows installers. (Wengier)
  - Fix windows transparency during TTF output switch
    in Windows SDL2 builds. (Wengier)
  - Fix SDL2 Windows builds to flag a resize as not
    user initiated only if the presence of the menu
    bar changes. This fixes a problem where SDL2
    builds did not acknowledge window resize events
    at all. (joncampbell123).
  - Fix FluidSynth weird sound issue in 32-bit Visual
    Studio SDL2 build. (Wengier)
  - Fluidsynth: Fix uninitialized conditional object
    init in Windows builds (joncampbell123).
  - Linux/X11: Add an X11 error handler function to
    handle the occasional X11 error that can happen
    within the SDL2 library if certain events, like
    window resize, occur too frequently. The custom
    error handler logs the error but does not abort
    the emulator like the default one would.
    (joncampbell123).
  - Fix SDL2 builds with output=surface not to render
    if the window at any point is too small. Resizing
    the window below the minimum supported by the
    DOS screen will not longer trigger segfaults or
    assertion failures. Issue #3348. (joncampbell123).
  - Fix IME not working on Windows when -langcp option
    is used to load a language with DBCS codepage, or
    in 32-bit MinGW lowend SDL1 build. (Wengier)
  - Fixed INT 10h failing to fully clear Tandy video
    memory when entering 16-color graphics modes.
    (joncampbell123).
  - Fixed missing/NULL INT 1Fh interrupt vector with
    CGA/PCjr/Tandy machine types. DOS games that print
    to screen using INT 10h in graphics modes can now
    print extended (>=128) character codes correctly.
    This fixes "BushBuck: A Treasure Hunt" and enables
    it's rather odd Tandy detection routine to work
    with machine=tandy. (joncampbell123).
  - Disney Sound Source: Fix problems between Disney
    sound source and parallel port emulation. Fix the
    code to enable Disney Sound System emulation either
    by disney=true (DOSBox SVN compatible) or
    parallel1=disney (The DOSBox-X way). (joncampbell123).
  - DOS SHELL: Change shell command parsing to make
    unusual combinations of command plus trailing
    command possible such as ECHO. ECHO; ECHO: ECHO[
    ECHO] ECHO\ ECHO/ ECHO" ECHO+ (issue #3503).
    (joncampbell123).
  - DIR command supports more sorting methods including
    "DIR /OGD", "DIR /OGE", and "DIR /OGS". (Wengier)
  - Support for BDF and PCF bitmap fonts for DOS/V
    functions, such as the free WenQuanYi bitmap font
    (bundled for displaying CJK characters). (Wengier)
  - EGA: Add machine type to emulate 200-line (CGA
    compatible) EGA display mode, machine=ega200.
    All text modes have 8x8 character cells, use CGA
    compatible video timing, and the 640x350 modes
    are not available. Fix EGA display offset register
    usage to properly work with alphanumeric text
    mode when "word mode" is turned off. This fixes
    IBM demonstration program "Fantasy Land".
    (joncampbell123).
  - IDE: Remove extra state from IDE controller that
    is managed by the drive. The ATA-1 standard seems
    to say that status and drive/head registers on
    read back always come from the ATA device.
    (joncampbell123).
  - IDE: If ATA device is busy, all IDE registers
    return the status register and BSY bit according
    to ATA-1 standard (joncampbell123).
  - IDE ATAPI CD-ROM: Add ATAPI command BEh READ CD.
    This command is like the 28h/A8h READ command but
    specific to the CD/CD-ROM format and allows reading
    the various sector types including data sectors and
    CD audio. Windows NT 4.0 requires this, or else it
    treats the CD-ROM drive like a non-working device.
    (joncampbell123).
0.84.0
  - CMOS century register now aliased to register
    32h and 37h to appease Windows 2000, which assumes
    the century is stored there and will complain
    about invalid date/time otherwise (joncampbell123).
  - Treat IDE command E7h (FLUSH CACHE) as a no-op
    so that the common use of it from Windows 2000
    doesn't spam your log file (joncampbell123).
  - BIOS: At post, if DOS kernel was active and the
    DOS Shell was still running, initiate a proper
    system reset event. Some software, including the
    WINNT.EXE install program for Windows NT, like to
    restart the system by JMPing to the BIOS POST
    entry point. Prior to this fix, doing that from a
    DOS program caused instability with mounted images
    and the DOS shell due to recursion. (joncampbell123).
  - Fix FPU implementation for aarch64 cores (cimarronm)
  - Fixed INT 10h and DAC palette mapping to resolve
    incorrect colors with Hercules graphics mode when
    a game calls INT 10h to set video mode after setting
    it up. This resolves the incorrect blue on black
    color map for Grand Prix by Accolade (joncampbell123).
  - Add recursive mkdir_p() directory creation so that
    overlay filesystem support can correctly create
    a subdirectory of any depth, instead of only one
    level deep from an existing directory on disk.
    (joncampbell123)
  - Add dosbox(-x).conf option "isapnpport" to control
    whether the ISA Plug & Play I/O port is presented
    to the guest. Setting is "true", "false", or "auto".
    "auto" means to enable if PnP BIOS is enabled.
    Previously this port was always present even if
    the PnP BIOS was not. Some operating systems,
    including Windows NT/2000/XP, will enumerate ISA
    Plug & Play hardware by themselves whether or not
    the PnP BIOS is present. (joncampbell123)
  - Fix FPU operations using the top of stack on
    32-bit VS builds (cimarronm)
  - Add IDE ATAPI command MECHANISM STATUS for
    Windows NT 4.0 because that system seems
    to want to know if your CD-ROM drive is a
    CD changer (joncampbell123)
  - IDE Plug & Play resource descriptor changed to use
    2-byte structure for listing IRQ resource instead of
    3 bytes. This (for some reason) fixes problems with
    the IDE driver in Windows NT 4.0, Windows 2000, and
    Windows XP and allows them to boot properly.
    (joncampbell123)
  - INT 13h extensions function 48h is supposed to
    return physical geometry, not the logical geometry
    normally returned by function 08h. This means for
    IDE devices, to return the geometry the IDE controller
    is using. (joncampbell123)
  - Enhanced the Mapper Editor interface. The Mapper UI
    has been greatly improved. (aybe)
  - Add IDE ATAPI command MECHANISM STATUS for Windows
    NT 4.0 because that system seems to want to know if
    your CD-ROM drive is a CD changer. (joncampbell123)
  - Fix IDE devices to start up with the drive ready
    bit set for OSes that expect it when probing IDE
    devices. This allows the Linux kernel to see IDE
    ATA drives emulated by DOSBox-X. (joncampbell123)
  - Fix IDE ATAPI emulation to correctly handle CD
    READ across one or more DRQ block transfers. Use
    block size given by guest in consideration of DRQ
    block size, which allows ATAPI CD-ROM emulation to
    work properly with the Linux kernel. (joncampbell123)
  - Add debug command to show PC-98 color palettes.
    Corrected typo. (joncampbell123)
  - Add support for PC-98 monochrome graphics mode.
    (joncampbell123)
  - IDE emulation now handles implementation events per
    IDE device instead of per IDE controller, which
    may resolve IDE controller issues with some guests.
    (joncampbell123)
  - Added PC-98 GDC drawing commands, which is
    based on Neko Project II source code (nanshiki)
  - Added PC-98 LIO BIOS interface, which is based on
    Neko Project II source code (nanshiki)
  - INT 21h AH=31h Terminate And Stay Resident: If the
    program called INT 21h to free its own PSP segment,
    reassign the block back to the program as allocated
    and then resize as expected. Needed for PC-98 game
    "Yu No" in which PLAY6.EXE, one of the resident
    drivers used for music, does just that. (joncampbell123)
  - Add a hack to enable read access to port 0xa460 on PC-98 which 
    returns Sound ID to detect the sound board available.
    Note that the current hack returns Sound ID of PC-9801-86 board
    regardless of the board selected to emulate. (maron2000)
  - Adds WINCHECK to list of programs which should not
    return a valid installation check for WinOldAp
    (AX=1700h/int2fh) so it doesn't mistakenly believe
    Windows is running (cimarronm)
  - Add minimal support for IDE SET FEATURES command EFh.
    (joncampbell123)
  - Fix CMPXCHG8B to change only the ZF flag, instead of
    changing ZF with other flags in an undefined state
    afterwards. This fixes problems with the Windows 2000
    kernel booting up and cputype=pentium (though I am
    unable to get past the INACCESSIBLE_BOOT_DEVICE error).
    (joncampbell123)
  - Updates XADD instruction to set appropriate flags
    (cimarronm)
  - Updates to FPU to handle opcode size prefix (66h)
    on FSTENV/FLDENV/FSAVE/FRSTOR instructions (cimarronm)
  - Update FLD constant FPU instructions to more
    accurately match FPU implementations (cimarronm)
  - Fixed dynamic_dynrec being displayed as dynamic_x86
    in menu, and PREFETCH instruction breakage in the
    dynamic core. (Jookia)
  - Fixed crash if no dynamic cores available (Jookia)
  - Fixed TTF mode breaking a guest not running the
    DOS kernel. (Jookia)
  - Fix DBCS table initialization on reset and
    restart (cimarronm)
  - Fixed some guest systems may not work as expected
    in non-TTF outputs. (Wengier)
  - Fixed IME input not working in MinGW builds, and
    FluidSynth in MinGW-lowend builds. (Wengier)
  - Fixed resizable OpenGL Voodoo window not working
    properly on Windows in previous version. (Wengier)
  - Fixed commands "CHOICE /N /C:123" and "MIXER /GUI"
    not working properly in previous version. (Wengier)
  - Integrated commits from mainline (Allofich)
    - Disable leading directory validity check in
    DOS_FindDevice.
0.83.25
  - XGA: Do not register XGA I/O ports unless emulating
    S3 chipset (such as machine=svga_s3) (joncampbell123)
  - Menu options "Force scaler" and "Print text screen"
    can now be assigned to keyboard shortcuts from the
    Mapper Editor. (Wengier)
  - Allowed to boot from Toshiba DOS image file for the
    Toshiba J-3100 emulation. (nanshiki)
  - Default S3 machine types now support XGA/SXGA VText
    in DOS/V, in addition to svga_et4000. (nanshiki)
  - Added "j3100backcolor" and "j300textcolor" config
    options (in [dosv] section) to specify background
    and text colors in J-3100 mode. (nanshiki)
  - Added config option "aspect_ratio" (in [render]
    section) which when set will force the specified
    aspect ratio (e.g. 16:9 or 3:2) in the aspect ratio
    correction mode (i.e. aspect=true). A menu group
    "Aspect ratio" is added to "Video" menu for users
    to select or set an aspect ratio, including an
    original ratio option. (Wengier)
  - Added config option "show recorded filename" (in
    [dosbox] section) which when set to true (default)
    will show message boxes with recorded filenames
    when making audio or video captures. (Wengier)
  - Added config option "allow quit after warning" (in
    [dosbox] section) which when set to false DOSBox-X
    will disallow the quit option after displaying a
    warning message. (Wengier)
  - Added config option "turbo last second" (in [cpu]
    section) which allows to stop the Turbo function
    after specified number of seconds. (Wengier)
  - Updated FLAC, MP3, and WAV decoder libraries to the
    latest versions (v0.12.38, v0.6.32, and v0.13.6)
    respectively; per David Reid). (Wengier)
  - Added support for upper case characters (A-Z) for
    AUTOTYPE command. (kcgen)
  - Added /T option for CHOICE command to set a default
    choice as in DOS, e.g. CHOICE /T:Y,3 (Wengier)
  - Added Korean language option in Windows installer.
    Also, language option page will be shown regardless
    of the output option selected. (Wengier)
  - Add stub INT 10h handler at F000:F065 if
    machine=vgaonly and using a VGA ROM BIOS image.
    The IBM VGA ROM BIOS image points INT 42h at that
    fixed address and calls it for any function it does
    not understand. (joncampbell123)
  - Set int33 event status bit 8 when passing absolute
    mouse coordinates, which is useful in emulation or
    virtualization environments where the mouse may be
    integrated with the host cursor. (javispedro)
  - Added support for Pentium Pro hinting NOPs and
    related multi-byte NOPs. (Jookia)
  - Updated HX DOS Extender to latest version 2.19 for
    HX-DOS builds. (Wengier)
  - DOSBox-X returns 1 instead of 0 when E_Exit occurs
    or unit tests fail. (Wengier)
  - Fixed built-in IPX and Modem emulation unavailable
    in MinGW builds. (Wengier)
  - Fixed -machine command-line option (as listed by
    "INTRO USAGE" command) not working. (Wengier)
  - Fixed lockup in classic Jumpman. (maron2000)
  - Fixed color in some modes under x86-64 macOS SDL2
    builds. (myon98)
  - Fixed extra INT 10h call during BIOS screen. The
    extra call caused crashes when combined with a ROM
    image of the stock IBM VGA BIOS. (joncampbell123)
  - Fixed fscale FPU operation and updated FPU status
    word. Also fixed FPU stack value log messages on
    x86-based builds. (cimarronm)
  - Fixed bug that OpenGL Voodoo window may not appear
    correctly if the DOSBox-X window was previously in
    full-screen mode in some builds. DOSBox-X will now
    ensure a switch to window mode (or maximized window
    mode) in this case. Also fixed some menu options
    including rebooting DOSBox-X while Voodoo emulation
    is currently active. (Wengier)
  - Fixed crash when switching to dynamic_rec core from
    menu when dynamic_x86 is also available. Also fixed
    the dynamic_rec core may not be displayed correctly
    in the menu when a language file is used. (Wengier)
  - Fixed Windows resource information. (Wengier)
  - Fixed a buffer overflow when launching a program.
    (Jookia)
  - Fixed bug where DOS IOCTL would call device control
    channel on devices which did not advertise support
    for IOCTL. (cimarronm)
  - Clean up of DOS device and attribute flag usage
    (cimarronm)
  - Integrated commits from mainline (Allofich)
    - Use real pointer with font data for reading
    characters. Also ignore page number for modes with
    only one page.
0.83.24
  - Release notes for this version:
    https://dosbox-x.com/release-0.83.24.html
  - PC-98: Search for FONT.ROM in resources directory
    in addition to the working directory. (bsdf)
  - Add S3 Vision964 and Vision968, based on existing
    support for the Vision864/868 chips (rderooy).
  - APM BIOS: When the guest calls the APM BIOS to go
    into suspend or standby mode, emulate a suspended
    or standby mode. Spacebar resumes the guest machine.
    Blank the display (if VGA/SVGA machine type) upon
    suspend/standby and unblank upon leaving it.
    (joncampbell123)
  - APM BIOS: Add dosbox-x.conf option to control
    whether the power button triggers a suspend or
    standby event. (joncampbell123)
  - APM BIOS: Add power button mapper event, tie
    power button to APM BIOS, return power button as
    APM suspend event, add code to APM BIOS to handle
    suspend and resume events. Windows 98 no longer
    complains about the inability to suspend or go to
    standby. (joncampbell123)
  - APM BIOS: Limit debug logging of APM BIOS function
    AH=05h (CPU IDLE) because Windows 98 likes to call
    that function way too often. Once a millisecond, in
    fact! The log spam makes it difficult to see
    anything important scroll by while debugging.
    (joncampbell123).
  - Revise S3 Trio64 XGA line drawing code to
    add comments, and obey the "skip last pixel" bit
    so that the Windows drivers can better draw polygon
    line segments. This fixes broken XOR polylines in
    Windows 3.1 and Microsoft Word 2.0. (joncampbell123)
  - Add S3 ViRGE accelerated XGA line drawing function.
    Windows 3.1 through Windows 98 can now draw lines
    with hardware acceleration. (joncampbell123)
  - Merge code to help preserve long filename when
    older program writes/overwrites the 8.3 filename.
  - Change "fpu" config setting to an enumeration
    that still accepts true and false, but now also
    accepts auto, 287, and 387. It is now possible to
    specify fpu=287 and cputype=386 to emulate a 386
    paired with a 287 chip as is said to be how early
    386 Compaq systems were wired, for example.
    (joncampbell123)
  - 3Dfx Voodoo window is now resizable (inc. maximized
    window) when using OpenGL mode, in addition to the
    software mode. (MartyShepard, kekko, Wengier)
  - Menu options "CJK: Switch between DBCS/SBCS modes",
    CJK: Auto-detect box-drawing characters", and "Reset
    color scheme" (in "Video" -> "TTF options") are now
    assignable in Mapper Editor. (Wengier)
  - The "colors" config setting now allows a leading
    "+" character to stay the specified color scheme when
    switching from another output. (Wengier)
  - SETCOLOR command allows a syntax like "SETCOLOR 1 +"
    to return the specified color number to the preset
    value (as specified by "colors" setting). (Wengier)
  - When using TTF output, DOSBox-X will dim the topmost
    line when the window is inactive in full-screen or
    menuless mode as in vDosPlus. (emendelson)
  - IMGMOUNT command now accepts wildcards, such as
    "IMGMOUNT A disk*.img" to mount image files matching
    the given pattern. (Wengier)
  - Added CuteMouse wheel mouse extension so that DOS
    programs such as DOS Navigator 2 can make use of it.
    It is enabled when mouse wheel movement conversion is
    currently disabled. (FeralChild & Wengier)
  - Implemented basic support for VMware mouse protocol
    so that when used together with e.g. the VMware mouse
    driver for Windows 3.x, the mouse will be seamlessly
    integrated with the host system, and can enter/exit
    the DOSBox-X window without having to capture/release
    the mouse. Config option "vmware" is added (in [dos]
    section) which allows to disable VMware mouse guest
    integration. (FeralChild, Wengier, joncampbell123)
  - When country number is not specified and cannot be
    obtained from system, DOSBox-X will try to map the
    keyboard layout to country number. The country list
    is also extended. (Wengier & FeralChild)
  - Added "-nolog" command-line option to disable logging
    output completely, and "Disable logging output" menu
    option in "Debug" menu to toggle this. (Wengier)
  - Updated EGA?.CPX and KEYBOARD.SYS/KEYBRD?.SYS to the
    latest version from FreeDOS. The CPX files now appear
    in CPI directory of Z drive, which can be replaced by
    files provided by the user. (FeralChild & Wengier)
  - Fix lockup when printing in dBase IV. (Wengier)
  - Fix crash/restart when running Wing Commander with
    EMS memory enabled. (grapeli)
  - Fix possible buffer overflow issue that may happen
    in certain conditions. (maron2000)
  - Fix NewWadTool 1.3 unable to play music by ensuring
    that periodic timer interrupt is triggered on every
    cmos_timerevent. (cimarronm)
  - Fix handling of some DOS file I/O device drivers that
    expect a pre-filled input-buffer on READ function and
    also do not like to be called for every single byte
    in that buffer may not work correctly. (leecher1337)
  - Fix FPU emulation to use 8087 FENI/FDISI behavior
    when cputype=8086 or cputype=80186. (joncampbell123)
  - Fix FPU emulation to correctly emulate 80287 -/+inf
    compare behavior even if compiled for x86 targets
    where C_FPU_X86 uses the host FPU. (joncampbell123)
  - Fix audio speech stuttering issue in SpaceQuest 4
    v1.3 using Sound Blaster. (grapeli & rderooy)
  - Fix issue with Lemmings palette swapping not working
    properly. (maron2000 & grapeli)
  - Updated MT32emu to version 2.6.1. (maron2000)
    (Refer to https://github.com/munt/munt for details)
  - Updated DOSMID to version 0.9.6. (Wengier)
  - Integrated commits from mainline (Allofich)
    - Indicate in BIOS memory when keyboard ACK received.
    Fixes Soko-ban Revenge.
    - Fix execution of small COM programs on PCjr machine
    type.
0.83.23
  - Fixed XGA accelerated rendering for ViRGE emulation
    and 24 bits/pixel display modes. Since Windows drivers
    insist on 24bpp, this is necessary for
    "Truecolor (24-bit)" to display and render correctly.
  - dosbox-x.conf option "vesa vbe 1.2 modes are 32bpp" is
    now "true", "false" or "auto", where "auto" determines
    this setting based on which S3 chipset is being
    emulated. It seems the Windows drivers for ViRGE
    chipsets require 24bpp for truecolor modes, in fact,
    they do not even offer 32bpp as an option. Since
    the Windows 3.1/95/98 drivers use VESA BIOS calls to
    set video modes, this implies that the VESA BIOS on
    ViRGE cards are also making the base modes 24bpp rather
    than 32bpp. Note that the Windows drivers for older S3
    chipsets are perfectly happy to use 32bpp unless you
    select "16.7 million colors (1 Meg)" in Windows 3.1,
    which is the only option in those drivers to offer
    24bpp. To avoid grief with DOSBox-X users, "auto"
    is the default setting.
  - Added basic S3 ViRGE XGA acceleration. It's enough for
    90% of the GDI functions in Windows 3.1 so far.
  - Fixed S3 rectangle XGA accelerated pattern blit, when
    using display memory as the pattern mask source, to
    follow S3 Trio32/Trio64 documentation, instead of the
    DOSBox SVN educated guess, to resolve some edge cases
    where the wrong color is chosen to draw filled rectangles
    in Windows 3.1. This fixes the "basement" in Microsoft
    Creative Writer so that clicking around no longer leaves
    white boxes on the screen.
  - Extend 256-color foreground/background color behavior
    from S3 86c928 to Vision864 and Vision868 as Windows
    95 behavior suggests they handle the hardware cursor
    the same way in 256-color mode.
  - Extend "divide cursor X position by bytes per pixel"
    behavior from S3 86c928 to Vision864 and Vision868
    emulation as well, based on Windows 3.1 video driver
    behavior.
  - Gravis Ultrasound: Most I/O registers except port 3x4
    are intended for 8-bit I/O. If 16-bit I/O occurs to
    such registers, handle as two 8-bit I/O cycles. I
    found something in the Demoscene (1997 demo "Atlantis,
    Deep Like A Sea") that uses a 16-bit I/O write to write
    current channel and register select in one write.
    Prior to this fix, there was no music other than quiet
    popping noises in DOSBox-X.
  - Sound Blaster: Fixed DSP command 0x48 (Set DSP block
    transfer size) to accept block size as BYTES as
    standardized by Creative and convert to SAMPLES
    internally. This fixes stuttering voices in Freddy
    Pharkas when sbtype=sb16. (joncampbell123)
  - Avoid crashes due to assertion failure when media 
    keys are pressed (maron2000)
  - Fix CD audio playback failure (cue + mp3) when
    trying to play from pregap sectors. (maron2000)
  - Change default value of mt32.rate to 48kHz to match
    default value of mt32.analog option. (maron2000)
  - Fix a buffer overflow issue in dos.cpp (maron2000)
0.83.22
  - Added Pentium 3 Processor Serial Number emulation.
    Serial number can be set from dosbox-x.conf or not
    set, in which case it will act as if disabled by the
    BIOS. (joncampbell123).
  - Added Pentium III cputype, added SSE register set,
    added SSE instructions to debugger disassembler,
    added some initial SSE instructions. (joncampbell123)
  - Added some MSRs expected by Linux, Windows, and
    tools like CPU-Z to make them happy. (joncampbell123)
  - Added FXSAVE/FXRSTOR which makes Linux happy with
    Pentium III emulation. (joncampbell123)
  - Allow WRMSR to set time stamp counter, as it is known
    though undocumented a standard since the Pentium
    (joncampbell123).
  - Added debugger command to show global and per-voice
    status of the Gravis Ultrasound emulation. May come
    in handy for programmers who wish to write their own
    GUS routines, and for Trixter who brought up the
    subject of determining whether a program plays music
    with the GUS or treats it like a dumb sound card.
    (joncampbell123).
  - Added debugger command to show SSE register file, and
    to set SSE register contents. (joncampbell123)
  - Added debugger command to show MMX register file, and
    to set MMX register contents. (joncampbell123)
  - Added support for expressions within parenthesis in
    debugger expression handling. (joncampbell123)
  - Added & (AND), ^ (XOR), and | (OR) operators, and
    << and >> bit shift operators to debugger expression
    handling. (joncampbell123)
  - Added multiply (*) and divide (/) operators to debugger
    expression handling. Order of operations applies, so
    given mixed addition and multiplication, the multiply
    is done first then the result is added. Also added
    support for the modulo (%) operator to the debugger
    expression handling. (joncampbell123)
  - Revised debugger expression handling to correctly
    parse arithmetic operators with order of operations
    in mind. Prior to this fix, consecutive subtraction
    would cause seemingly illogical results, for example
    "10-1-1-1" would yield "9" instead of "7" because
    subtraction was handled in the wrong order. This fix
    also makes mixed addition and subtraction possible.
    NOTICE: Remember that all numbers going in and
    coming out of the expression handler are hexadecimal,
    NOT decimal! (joncampbell123)
  - Fixed simple expression handling in the debugger.
    Revised hexadecimal vs register parsing so that
    hexadecimal numbers that happen to start with
    the name of certain CPU flag registers does not
    cause confusing results. Prior to this fix,
    hexadecimal numbers like "dfe" or "af0" were
    impossible to enter without leading zeros or
    quotes because the parser would confuse the
    first digits with the DF and AF bits of the FLAGS
    register. (joncampbell123)
  - Added menu options "AMD Athlon 600MHz" and "Pentium
    III 866MHz EB" within the group "Emulate CPU speed"
    (under "CPU") for CPU speeds to emulate. (Wengier)
  - Added support for archive, hidden, system attributes
    on mounted local and overlay drives for non-Windows
    platforms by using special file(s). (Wengier)
  - Added config option "special operation file prefix"
    (in [dos] section) to specify an alternative file
    prefix for DOSBox-X's special operations on mounted
    local and overlay drives. (Wengier)
  - Added code page 3021 for the MIK character set used
    by the Bulgarian language (as in FreeDOS). (Wengier)
  - Added language file for the Brazilian Portuguese,
    available from Windows installer. (altiereslima)
  - For piping (|), DOSBox-X will now also try C: drive
    as a temporary piping path if current directory is
    read-only and the environment variable %TEMP% (or
    %TMP%) is not set. (Wengier)
  - For clipboard copy, CR+LF will now be used instead
    of LF on Windows for better compatibility. (Wengier)
  - Disk images are automatically mounted as read-only
    (instead of failing) now if the image files are
    read-only and the users do not explicitly specify
    read-only mode for the disk images. (Wengier)
  - The default value of config option "autofixwarning"
    (in [dos] section) is now "false", and it is now
    changeable via CONFIG command. (Wengier)
  - The default output for Linux SDL1 builds is changed
    from opengl to surface, unlike Linux SDL2 builds
    whose default output remains opengl. (Wengier)
  - Native Windows menus is supported in Windows SDL2
    builds just like Windows SDL1 builds. It is possible
    to force SDL-drawn menus for both Windows SDL1 and
    SDL2 builds at compile time. (Wengier)
  - Setting "windowposition" to "-" in the configuration
    will leave DOSBox-X window position as is instead of
    a specific position or being centered. (Wengier)
  - For printing, the SarasaGothicFixed TTF font will
    also be searched for DBCS code pages. (Wengier)
  - Added config option "showdbcsnodosv" (in the [dosv]
    section) which when set to true enables rendering of
    Chinese/Japanese/Korean characters for DBCS code
    pages in non-DOS/V, non-PC98, and non-TTF mode.
    Video capturing started from TTF output will enable
    DBCS characters when possible. (Wengier)
  - Changing DBCS code pages is supported for standard
    modes (i.e. non-DOS/V, non-PC98 and non-TTF modes)
    using CHCP command. (Wengier)
  - Fixed issues with certain DBCS characters for the
    DOS/V system. (Wengier)
  - Fixed slow blinking text in TTF output. (Wengier)
  - Fixed copying box drawing characters to clipboard
    not working in non-TTF JEGA mode. (Wengier)
  - Fixed background for the Configuration Tool when
    the TTF output is active. (Wengier)
  - Fixed DBCS characters not showing up when capturing
    screenshots in TTF CJK mode, or they do not show up
    properly in the Configuration Tool when "autodbcs"
    is set to "false" in the configuration. (Wengier)
  - Fixed media keys presses by ignoring these keys in
    Windows SDL1 builds. (maron2000)
  - Fixed IOCTL & ASPI interfaces for mounting physical
    CD drives on the Windows platform. (Wengier)
  - Fixed the issue of loading scalers in the previous
    version. A message box will only show up if you
    append "prompt" to the scaler option. (Wengier)
0.83.21
  - Release notes for this version:
    https://dosbox-x.com/release-0.83.21.html
  - Improved clipboard copying & pasting for different
    code pages including box-drawing characters in DBCS
    code pages. Also, for the J-3100 mode, the selected
    text will now be highlighted when you try to select
    text for copying. (Wengier)
  - Improved IME support for Chinese/Japanese/Korean
    languages on Windows builds. (Wengier)
  - Pausing the emulation will automatically release
    the mouse and prevent mouse capture. (Wengier)
  - For Configuration Tool, a "..." button is added to
    properties which have limited numbers of values so
    that when clicking their possible values will be
    shown in a new dialog and can be selected directly.
    Also, more settings will be applied immediately when
    modified from the Configuration Tool. (Wengier)
  - For Windows SDL1 builds, DOSBox-X will now try to
    prevent the Windows menus from separating into more
    than one lines due to small window width. (Wengier)
  - If a scaler as specified in the config may not work
    as expected and if not forced, DOSBox-X will show a
    a message box asking whether to load it. (Wengier)
  - Config option "pixelshader" now allows a shader file
    name without the .fx extension, or a shader file in
    the current directory. (Wengier)
  - Added support for ENET reliable UDP as an option for
    modem and null-modem emulation. You can enable it
    with "sock:1" option for modems/null-modems that are
    connected with serial ports (COM1-COM9), such as
    "serial1=modem listenport:5000 sock:1" for COM1 to
    listen to port 5000 with reliable ENET UDP instead
    of TCP connection. The feature is ported from DOSBox
    Staging. (sduensin, GranMinigun, kcgen, Wengier)
  - Added new command-line option "-o" for providing
    command-line option(s) if programs(s) are specified
    to start when you launch DOSBox-X. An example:
    dosbox-x program.exe -o "opt1 opt2". (Wengier)
  - Added special properties to CONFIG command including
    "cd", "date", "errorlevel", "random", "time", and
    "lastmount" so that commands like "CONFIG -GET cd"
    and "CONFIG -GET errorlevel" will get current DOS
    directory and ERRORLEVEL value. The returned value
    will also be saved to %CONFIG% variable. (Wengier)
  - Added "Enter Debugger Command" button to "DOSBox-X
    logging output" and "Code overview" windows (from
    "Debug" menu") for users to enter some debugger
    command(s) and see the result. (Wengier)
  - Added debugger commands DATE and TIME to view or
    change DOSBox-X's internal date and time, using the
    same date and time formats as the shell DATE and
    TIME commands, e.g. "TIME 10:11:12". (Wengier)
  - Added config option "badcommandhandler" (in [dos]
    section) which allows to specify a custom error
    handler program before error message "Bad command
    or file name" shows up in the DOS shell. (Wengier)
  - Added config option "stop turbo on key" (in [cpu]
    section) which allows to automatically stop the
    Turbo (fast forward) mode when a keyboard input
    has been detected. (Wengier)
  - Added config option "fat32setversion" (in [dos]
    section) which controls whether DOSBox-X should
    automatically set reported DOS version to 7.0/7.10
    when it's less than 7.0/7.10 and mounting LBA/FAT32
    disk images is requested. It defaults to "ask" so
    that DOSBox-X will ask in this case. (Wengier)
  - Added config option "j3100colorscroll" (in [dosv]
    section) which defaults to "false" and allows the
    J-3100 version of SimCity and VGA version of the
    Toshiba Windows 3.1 to run, whereas CGA/EGA version
    of the latter requires a "true" setting. (nanshiki)
  - Added config options (in "ethernet, slirp" section)
    "tcp_port_forwards" and "udp_port_forwards" for port
    forwarding when using the Slirp backend. (kcgen)
  - Added code pages 737 (Greek) and 775 (Baltic) for
    the guest-to-host code page conversions. (Wengier)
  - Added UTF8 and UTF16 commands to convert UTF-8 and
    UTF-16 text to view in the current code page. For
    example, the command "UTF8 < UTF8TEXT.TXT" will
    output converted text UTF8TEXT.TXT in the current
    code page, and for UTF16 command there are optional
    /BE & /LE options to specify endianness. (Wengier)
  - Added support for DBCS characters located in UNC
    network paths of the form \\COMPUTER\FOLDER\FILE
    on the Windows platform. (Wengier)
  - Added hidden code page 951 for Big5-HKSCS encoding
    or Big5 Unicode-At-On (Big5-UAO) encoding. Config
    option "uao" is added in [ttf] section so that if
    set to "true" code page 951 will use the Big5-UAO
    encoding instead of the Big-HKSCS encoding, the
    latter being the default for CP951. If ChinaSea is
    enabled, ChinaSea characters will be used instead
    of original characters in these encodings. (Wengier)
  - Added -nl option for MOUNT command to automatically
    find the next available drive letter to mount if
    the specified drive is already mounted. This allows
    multiple directories to be mounted when DOSBox-X
    starts with multiple [name] arguments. (Wengier)
  - Added HISTORY command to display or clear command-
    line history for the internal DOS shell. (Wengier)
  - Added ASSOC command to view/change file extension
    associations. You can define a command or program
    to open a file with a specific file extension, e.g.
    "assoc .txt=edit" to open .TXT files with the EDIT
    command when entering the .TXT file name from the
    DOS command line. Wildcards are allowed, such as
    "assoc .*=dir", although in such case exceptions
    including "assoc .com=com", "assoc .exe=exe", and
    "assoc .bat=bat" are probably desired. (Wengier)
  - Commands CHOICE and COUNTRY are external commands
    that appear on the Z drive (Z:/DOS/CHOICE.COM and
    Z:/SYSTEM/COUNTRY.COM respectively) now rather than
    internal shell commands. COUNTRY command now also
    affects thousand and decimal separators. (Wengier)
  - The internal Virtual Drive Z: can now be rescanned
    just like mounted local drives. (Wengier)
  - You can now change most config options in [printer]
    section of the configuration for the virtual printer
    with CONFIG -set commands. (Wengier)
  - Added missing ChinaSea characters in code page 950
    with ChinaSea/Big5-2003 extension enabled. (Wengier)
  - Added support for Bash-shell completion for DOSBox-X
    on non-Windows platforms. (rderooy & FeignInt)
  - Improved DBCS support for DOS commands including
    ATTRIB, ECHO, TYPE, MORE, and TRUENAME. (Wengier)
  - Improved checking of segment limits. (joncampbell123)
  - Mac OS X builds from now on will use an in-tree tool
    to replace dylib references in all executable files.
    XCode install_name_tool is no longer used, it became
    a hypochondriac and is sitting in the corner screaming
    about link edit data that doesn't fill a __LINKEDIT
    segment. It is once again possible to make Mac OS X
    ARM releases and to use dylib files from Brew doing
    so. (joncampbell123)
  - Fix IPL1 partition choice debug message to actually
    show the partition index chosen, not the -partidx
    option variable, which if not given by the user, is
    -1 and was reported as a very large unsigned
    number. (joncampbell123)
  - Fixed command-line options -starttool & -startmapper
    not showing messages from specified language file
    for Configuration Tool and Mapper Editor. (Wengier)
  - Fixed an issue with RENDER_Reset function while
    loading previously saved states. (yetmorecode)
  - Fixed E_Exit "RET from illegal descriptor type 0"
    when running DirectX diagnostic program (dxdiag)
    from a guest Windows 98 system. (Wengier)
  - Fixed "parallel?=file openwith:xxx" not working if
    a file name is not provided. (Wengier)
  - Fixed crash in the following config combination:
    output=ttf, machine=pc98, dosvfunc=true. (Wengier)
  - Fixed Disney sound source connecting to parallel
    port not working in the previous version. (Wengier)
  - Fixed NET command from Windows for Workgroups 3.11
    not working from the internal DOS shell. (Wengier)
  - Fixed MODE command options like "rate" and "delay"
    not working if entered in upper cases. (Wengier)
  - Fixed command-line parameters (when launching
    DOSBox-X) containing Chinese characters in code page
    950 not working in Windows SDL2 builds. (Wengier)
  - Integrated commits from mainline (Allofich)
    - Improve BIOS FDD motor timeout counter, most
    notably for earlier PCs. Fixes a Chinese variant
    of Space Harrier.
0.83.20
  - Release notes for this version:
    https://dosbox-x.com/release-0.83.20.html
  - Implemented support for Pentium II cputype (with
    the setting "cputype=pentium_ii" in [cpu] section),
    and added Pentium II SYSENTER/SYSEXIT instructions
    to normal core and debugger disassembler. The two
    instructions are supported for Pentium II cputype.
    CPUID for Pentium II will now report stepping 3 and
    model 3 which is a minimum requirement for OSes to
    attempt to use SYSENTER/SYSEXIT. Silencing for
    RDMSR/WRMSR and SYSENTER/SYSEXIT debug messages is
    removed while CPU "debug spew" is silenced by
    default. MSRs related to Intel microcode are added
    because both Linux and Windows ME probe those MSRs
    if Pentium II emulation reports stepping 3 model 3.
    The microcode MSRs are silently ignored. Moreover,
    the MSR register 0x0000001B has been added to
    Pentium II emulation. DOSBox-X does not emulate a
    local APIC but Windows ME assumes that MSR is
    present and reads/writes it on startup if DOSBox-X
    reports itself as a Pentium II. (joncampbell123)
  - Added support for DCGA and Toshiba J-3100 emulation
    modes by importing code from DOSVAXJ3 by nanshiki.
    The J-3100 emulation mode can be enabled with the
    option "dosv=jp" along with a non-off setting of
    "j3100" option in [dosv] section. For example, with
    "j3100=on" or "j3100=auto" (and "dosv=jp") J-3100
    system will be enabled and activated at start. With
    "j3100=manual" (and "dosv=jp") J-3100 system will
    be enabled and not activated at start, but there is
    now a DCGA command to enter DCGA (either English or
    J-3100 DCGA, depending on if J-3100 is enabled)
    mode from other video modes. (nanshiki & Wengier)
  - Added support for unit tests based on Google Test
    framework (gTest/gMock) to ensure code stability.
    Unit tests can be started with command-line option
    "-tests" in the debug builds. Some unit tests are
    ported from DOSBox Staging. (Wengier)
  - Added SERIAL and PARALLEL commands to view/change
    the current configuration of serial/parallel ports.
    Type "SERIAL /?" and "PARALLEL /?" for further info
    about the two commands. Commands like "config -set
    serial?=..." and "config -set parallel?=..." will
    also auto-call these commands. (sduensin & Wengier)
  - Added IMGSWAP command to swap disks for drives.
    e.g. "IMGSWAP D" to swap D: drive to the next swap
    position, and "IMGSWAP A 3" to swap A: drive to
    the 3nd swap position. (Wengier)
  - Added DOS commands including COMP, DISKCOPY, EDLIN,
    FC, FILES, PRINT, and SHUTDOWN (most from FreeDOS)
    to the built-in Z: drive. Updated or recompiled
    EDIT and EDLIN commands to support LFNs. (Wengier)
  - The CAPMOUSE command without a parameter now shows
    whether the mouse is captured/released. (Wengier)
  - The command "config -set" is now case-insensitive
    for property names. Also, if an option cannot be
    changed at run-time, DOSBox-X will ask whether to
    restart itself to apply the new setting. (Wengier)
  - Do not read real-mode data areas from mouse event
    handling if running a protected mode guest OS like
    Windows NT, and disable INT 33h functions when DOS
    kernel is shut down to boot into a guest OS. Moving
    mouse while Windows NT is running should no longer
    cause page faults and crashes. (joncampbell123)
  - The setting "mountwarning = false" will now silence
    more warning messages during mounting. (Wengier)
  - The code page setting of "country" option will now
    be ignored for PC-98, JEGA and DOS/V modes. These
    modes will enforce the desired code page. (Wengier)
  - Added support for loading the ASC16/ASCFONT.15/
    ASC24/ASCFONT.24? font files from the UCDOS/ETen
    Chinese DOS systems for the options "fontxsbcs",
    "fontxsbcs16" and "fontxdbcs24" in [dosv] section
    of the config file for DOS/V systems. (Wengier)
  - Improved auto-detection of box-drawing characters
    when using DBCS code pages. (Wengier)
  - Applied UTF-8 conversions to file browse dialog
    boxes for selecting files containing Unicode
    characters (e.g. CJK characters). (Wengier)
  - For screenshot and MIDI/OPL recording, DOSBox-X
    will now display a message box showing the saved
    file name when the recording has been completed.
    The full paths will also be logged. (Wengier)
  - Added confirmation message while trying to load a
    Direct3D pixel shader which may not be needed or
    may have undesired effect. (Wengier)
  - Added warning message if DOS/V or Japanese PC-98/AX
    machine type is selected and a language file with
    an incompatible code page is specified. (Wengier)
  - Added "AMD K6 166 MHz", "AMD K6 200 MHz" and "AMD
    K6-2 300 MHz" menu options within the menu group
    "Emulate CPU speed" (under "CPU"). (Wengier)
  - Added a TrueType font selection page into Windows
    installer, which will show when TrueType font (TTF)
    output is selected for new installations. (Wengier)
  - Added MMX instruction PSHUFW and added typecasts
    to some MMX instructions in case compilers cannot
    properly shift uint64_t by uint8_t otherwise. Most
    Pentium-level MMX instructions (such as MOVD, MOVQ,
    and EMMS) are added to the debugger disassembler
    and support for the disassembler to represent MMX
    registers. (joncampbell123)
  - Added code to normal core to flush paging TLB
    whenever handing a non-recursive guest page fault.
    The guest OS will likely update the page tables
    to resolve the fault. The Linux kernel will
    constantly get "stuck" whenever you run a command
    without this change. (joncampbell123)
  - Added code to make sure DOS kernel drives and drive
    letters have been unmounted and deallocated before
    booting a guest OS or shutting down DOSBox-X
    (joncampbell123).
  - Added ability to change floppy images with drive
    number (0 or 1) only. (Wengier)
  - Added INT 13h AH=16h, detect disk change. This can
    be controlled by config option "int 13 disk change
    detect" (in [dos] section) in case any older OS can
    not handle it. INT 13h AH=15h will report a floppy
    drive with change line support if enabled. MS-DOS
    seems to work just fine with it. (joncampbell123)
  - Added menu item "Enable extended Chinese character
    set" in "Video" => "TTF options" to toggle setting
    for the Simplified Chinese (GBK extension) and
    Traditional Chinese (ChinaSea extension). (Wengier)
  - Added config option "chinasea" (in [ttf] section)
    which when set to "true" allows ChinaSea (中國海字集)
    and Big5-2003 extension of the original Big5-1984
    charset for Traditional Chinese TTF output. This
    requires the use of a TTF/OTF font containing such
    extended characters to correctly render them; the
    included SarasaGothicFixed TTF font is updated to
    support such characters.Certain Traditional Chinese
    DOS software like the Hyper Editor 5.03 (漢書5) makes
    use of ChinaSea characters. Also moved "gbk" config
    option from [dosv] to [ttf] section. (Wengier)
  - Added config option "forcesquarecorner" (in [sdl]
    section) which when set to "true" will force to
    disable rounded corners on Windows 11. (Wengier)
  - Added code to INT 18h emulation (IBM PC mode) to
    jump to ROM BASIC if the user provided an IBM
    ROM BASIC image to load. (joncampbell123)
  - Added config option "ibm rom basic" in [dosbox]
    section which allows users to load a ROM image
    containing IBM PC ROM BASIC, for disk images
    and MS-DOS setups that need it. (joncampbell123)
  - Added stub IBM ROM BASIC points in the BIOS area
    so that when BASIC(A).COM from MS-DOS 1.x and 2.x
    are run, a polite message is displayed instead of
    invalid code and crashes. (joncampbell123)
  - 8086 and 80186 CPU types no longer check segment
    limits. (joncampbell123 & Allofich)
  - Put in undocumented behavior in opcode 0x8e for
    8086 and 80186. (Allofich)
  - Made 8086 treat opcodes C0,C1,C8,C9,F1 as aliases
    of C2,C3,CA,CB,F0, and opcodes 0x60-0x6F as aliases
    of opcodes 0x70-0x7F. (Allofich)
  - Adjusted multiple-prefix bug for 8086/286 to only
    apply when REP or REPZ is used. (Allofich)
  - Fixed 0x0F opcode being valid on 80186 core when
    it should be invalid. (Allofich)
  - Fixed CGA modes to always use a character height
    of 8, rather than reading it from address 485h.
    Fixes corrupt graphics in the PC Booter version
    of Apple Panic. (Allofich)
  - Fixed underflow when INT 13 AH=2 called for
    sector 0. (Allofich)
  - Fixed infinite loop when trying to run a 32-bit
    program with the 8086 CPU type. (Allofich)
  - Fixed INT 13h emulation to no longer call the DOS
    kernel "DriveManager" if the DOS kernel has been
    shutdown. This fixes memory corruption issues in
    the guest OS system run by the BOOT command that
    can occur when the "swap disks" command is used in
    the emulator. (joncampbell123)
  - Fixed DTA memory leak from FAT driver if FAT drive
    was mounted when booting into a guest OS. (joncampbell123)
  - Fixed a crash on unmount that occurs if IMGMOUNT
    is used to mount multiple floppy disk images to
    a drive letter. (joncampbell123)
  - Fixed possible crash with printing. (jamesbond3142)
  - Fixed possible freeze when shutting down Windows 9x
    after changing a CD image from the menu. (Wengier)
  - Fixed the default U.S. keyboard layout for the
    HX-DOS build. (Wengier)
  - Fixed copying full-screen or multi-line text from a
    DBCS codepage in TTF output or PC98 mode. (Wengier)
  - Fixed possible crash at start with getsysfont=true
    when a font may not be obtained on some Chinese
    Windows systems. (Wengier)
  - Fixed TTF color issue with some DOS GUI programs by
    initializing the color scheme when with default
    COLORS= setting in EGA or VGA mode. (Wengier)
  - Fixed some Direct3D pixel shaders not working (such
    as GS2x and CRT-geom-blend). (Wengier & depaljas)
  - Fixed config option windowposition=x,y not working
    in Linux/macOS SDL1 builds. (Wengier)
  - Fixed copying files from the virtual drive Z: not
    working when using the 4DOS shell. (Wengier)
  - Fixed some issues in MORE command. (Wengier)
  - Fixed "DIR>NUL" freeze/crash when only disk or CD
    images are mounted. (nanshiki)
  - Fixed BIOS screen when resetting the machine with a
    non-TTF output and DOS/V mode enabled. (Wengier)
  - Fixed the key `/~ not working when IME is enabled
    on a non-Japanese keyboard. (Wengier)
  - Fixed display glitches in the game "Continuing
    adventures of Cyberbox". (Wengier)
  - Fixed unusable joystick with config options like
    joy1response1 set to certain values. (Baderian)
  - Make memory B0000-B7FFF unmapped for the CGA
    emulation. Fixes "Backgammon 5.0" detecting that
    an MDA is also present when using CGA. (Allofich)
  - Make floppy I/O delay separately configurable from
    hard drive delay, and make it slower than before
    by default. It is adjustable via the "floppy drive
    data rate limit" config option. (Allofich)
  - Always return bit 6 of port 61h as set for PC and as
    clear for PCjr and Tandy. Allows Zaxxon to load in
    PC mode. (Allofich)
  - Video emulation for PC-98 mode (for 400-line modes)
    is now 16:10 instead of 4:3. 480-line PC-98 modes
    are still 4:3. (joncampbell123)
  - PC-98 EGC emulation: Add generic ope_xx handler for
    the remaining block of undefined/undocumented EGC
    ROPs. This fixes "Atomic Punker" which uses EGC ROP
    0xBE for sprite rendering. (joncampbell123)
  - Don't run mouse setup code if there is no emulated
    mouse. (Allofich)
  - Integrated commits from mainline (Allofich)
    - Add proper opl3 handling of the waveform select
    to dbopl.
    - Correct disassembly of some FPU instructions.
0.83.19
  - Reorganized the "List network interfaces" and "List
    printer devices" dialogs (under the "Help" menu) to
    allow the use of scroll bars. (Wengier)
  - Added menu option "Reset TTF color scheme" to reset
    the current color scheme for TTF output. (Wengier)
  - Added config option "righttoleft" in [TTF] section
    which when set to "true" will cause DOSBox-X to
    display text from right to left (instead of left to
    right) for the TTF output. It can also be toggled
    from the menu ("Video" => "TTF options" => "Display
    text from right to left"). (Wengier)
  - Added config option "vga fill active memory" which
    when set to "true" will fill inactive video memory
    regions with RAM rather than mapping them as empty.
    This allows the ETen Chinese DOS system (倚天中文系統)
    3.5/2000 (e.g. ET16V and ET24VA) to run. (Wengier)
  - Added config option "middle_unlock" ([sdl] section)
    to control whether to unlock the mouse with middle
    mouse button click. (Wengier)
  - Added config option "dosvfunc" in [ttf] section to
    support DOS/V applications when country information
    is set to Japan in TTF output. (nanshiki)
  - Added "VTEXT" command to view or change the current
    V-text mode for the DOS/V emulation. Also improved
    the font support for 24-pixel font DOS/V mode, such
    as supporting HZK24? fonts for Simplified Chinese
    DOS/V mode and STDFONT.24 from ETen Chinese system
    for Traditional Chinese DOS/V mode. If a Chinese
    font is specified via "fontxdbcs", "fontxdbcs14" or
    "fontxdbcs24" options, it will be loaded before
    system font even with "getsysfont=true". (Wengier)
  - Commands like 80x25, 80x43, ... now use internal
    function for better compatibility with the TrueType
    font (TTF) output. (Wengier)
  - MODE command without a parameter will now print the
    current lines/columns instead of usage. (Wengier)
  - INTVEC debugger command now correctly outputs
    addresses when in protected mode. (Allofich)
  - Fix horizontal lines in the debugger window being
    rendered as unrelated characters in some code
    pages. (Allofich)
  - INT 21 AX=4B03 now sets AX to 0000 like MS-DOS
    does. Fixes missing music in "聊齋誌異之幽谷傳奇"
    (Liáozhāi zhì yì zhī yōugǔ chuánqí) (Allofich)
  - Use 0x1E to 0x3E for the keyboard buffer of the CGA
    machine, which fixes the controls locking up in the
    PC booter version of Apple Panic. (Allofich)
  - Allowed machine types "pcjr_composite" and
    "pcjr_composite2", similar to "cga_composite" and
    "cga_composite2", instead of having to switch the
    composite type manually. (Wengier)
  - If machine is PCjr, place PC BIOS reset code at
    F000:0043 to match that of the real BIOS.
  - Fix PCjr NMI handler to load DS with segment 0x0040.
    Fixes crashes in SHAMUS. (Allofich)
  - Fix PCjr NMI handler to use 8086-level instructions
    when loading DS with segment 0x0040 so that it
    works properly with cputype=8086.
  - Remove useless check for signed divide quotient
    of 0x80/0x8000/etc. (the result was -0x80/0x8000/etc
    anyway. Add code to check specifically for these
    values after signed divide if cputype=8086 and
    trigger divide overflow exception, to match behavior
    described for the 8086 processor.
  - Modify exception handling so that for cputype=8086
    the return address for an exception handler points
    at instruction after fault location.
  - Fix IDIV instruction incorrectly raising a divide
    error exception for some borderline values. Fixes
    Microsoft Flight Simulator. (Allofich)
  - IBM PC BIOS emulation fixed to place key pieces of
    code and entry points at fixed legacy locations
    required by some older DOS games, instead of
    by dynamic allocation. Added code to BIOS allocation
    to reserve F000:E000 or higher for fixed allocation
    and force dynamic allocation below that address to
    prevent further conflicts should others submit
    pull requests for additional fixed locations. This
    fixes some games like "聊齋誌異之幽谷傳奇" (Liáozhāi
    zhì yì zhī yōugǔ chuánqí) which appear to assume
    some of these fixed BIOS addresses and will
    crash if they are wrong.
  - Added tool EMSMAGIC.COM as alternative EMS manager,
    which can be dynamically installed or uninstalled
    with the setting ems=false. (Wengier)
  - If a program is provided in the command-line when
    launching DOSBox-X, it will now be executed after
    any commands in the [autoexec] section by default.
    A command-line option "-prerun" is added to force
    the program run before any commands in [autoexec]
    section like before. (Wengier)
  - Added auto-detection for single-wide DBCS-encoded
    characters for the TTF output (non-PC98). (Wengier)
  - Improved the menu option "Restart DOSBox-X with
    language file..." (under "Main") for switching
    between DBCS languages. (Wengier)
  - Disabled the Alt+F4 key for closing the DOSBox-X
    window in MinGW SDL2 builds. (Wengier)
  - Fixed program or config file containing Unicode
    characters passed from command-line when launching
    DOSBox-X in Windows SDL2 builds. (Wengier)
  - Fixed issue with DELETE key in PC-98 mode. (Wengier)
  - Fixed COLORS config option (in [ttf] section) not
    working in the previous version. (Wengier)
  - Fixed issues after resetting the virtual machine
    when using DBCS language files. (Wengier)
  - Fixed some issues related to system IME support for
    CJK (Chinese/Japanese/Korean) languages, for both
    Windows SDL1 and SDL2 builds. (nanshiki & Wengier)
  - Fixed bugs in the region memory allocator C++ class
    that claimed the entire free block even if the
    size wanted was smaller. Added field to remember if
    the allocated block was allocated for fixed or
    dynamically allocated memory. Cleaned up allocator
    code and removed redundancy.
  - Fix SELINFO command not showing output correctly
    in the debugger window. (Allofich)
  - Better CMOS register B and C emulation. (Allofich)
  - Integrated commits from mainline (Allofich)
    - Support for DMF floppy disk images.
    - Zero-out DX in EXEC overlay command.
    - Improve stack check for wrap-around cases.
    - Change to misc_output for SVGA_S3Trio.
0.83.18
  - Cleaned up and more accurately worded CMOS-related
    log messages. (Allofich)
  - Fixed the names of virtual files and files on mounted
    FAT drive images being logged as "(null)". (Allofich)
  - Fixed packed structure alignment problem with MSVC
    (Microsoft C++) builds regarding some disk image
    formats. These problems prevented VS2019 builds from
    mounting hard disk images. (Allofich)
  - REP STOSB will correctly move one byte if one byte
    remains to be processed aka CX == 1, this is needed
    for FD98.COM self clearing code to work properly. (nanshiki)
  - Fixed IOCTL support for character device drivers. (nanshiki)
  - Fixed ANSI ESC [6n escape handling to correctly
    report cursor position as 1-based count, not 0-based
    count. (nanshiki)
  - PC-98 INT DCh emulation fixed to better represent the
    function key shortcuts as real DOS does. (nanshiki)
  - Emulator fix for HX-DOS builds. (Wengier)
  - Integrated commits from mainline (Allofich)
    - Fix the return value of register al from INT10 ah=0x0F
    for non EGA/VGA machines.
0.83.17
  - Added FISTTP instruction to experimental cputype (LBi)
  - Updated debugger to support and decode fisttp, fcomi,
    fcomip, fucomi, fucomip (LBi)
  - Added support for Chinese/Japanese/Korean IMEs on
    Windows/Linux SDL2 builds. (nanshiki)
  - Added cputype=experimental, which is the same as the
    highest CPU emulation level but with additional
    instructions from newer processors that do not exist
    in the era emulated by DOSBox-X i.e. FISTTP which is
    an SSE3 Pentium 4 instruction. (joncampbell123)
  - Added support for 286/386 call gates to JMP
    instruction (joncampbell123)
  - Added -bd <n> option to IMGMOUNT to allow mounting
    partitions from a hard disk image mounted as an
    INT 13h hard disk. <n> is the numeric value the
    hard disk image was mounted to. In this way, it
    becomes possible to mount any or all partitions
    in a hard disk image. WARNING: To safely mount
    multiple partitions, use -o partidx=<n> to specify
    each partition you mount by index. (joncampbell123)
  - If a drive has no volume label, and user runs
    LABEL without specifying one, do not ask whether
    or not to delete the volume label because there
    is in fact no volume label to delete. (joncampbell123)
  - Added FreeDOS utilities DEFRAG, FORMAT, FDISK,
    CHKDSK, and SYS to the built-in Z drive. KERNEL.SYS
    is not provided so that the user can provide what
    they consider the best version of the FreeDOS kernel
    to format with if they use FORMAT /S (joncampbell123)
  - INT 29h routes output through ANSI.SYS driver in
    both IBM PC and PC-98 mode, unless ansi.sys=false
    is set in the config setting. (joncampbell123)
  - Integrated commits from mainline (Allofich)
    - Fix regression in r4444: Hercules machine type
    cursor translation.
    - Remove redundant signature for ET4K that is now
    done in video BIOS.
    - Implement mouse driver function 0x27, fixes
    Alive - Behind the Moon.
    - Add log message for unusual cases where an
    executable unsafely places its initial stack outside
    the memory block.
0.83.16
  - Release notes for this version:
    https://dosbox-x.com/release-0.83.16.html
  - Added support for extended MS-DOS partitions that
    reside in extended partitions. These partitions
    can be manually mounted using -o partidx=n where
    n is 4 or larger. To assist in partition indexes,
    the FAT driver will also print the partition
    table to your log file and console when asked to
    print debug information. (joncampbell123)
  - Added dosbox-x.conf options to control VESA BIOS
    window size and window granularity. This allows
    DOS development to test VESA BIOS support against
    SVGA cards that use window sizes and/or window
    granularity other than 64KB including older SVGA
    hardware by Paradise and Cirrus. Note that use
    of these options is intended solely for DOS
    development and will break S3 drivers that do not
    use the VESA BIOS extensions. (joncampbell123)
  - Fixed VESA BIOS S3 modelist to match the VBE 1.2
    standard modelist properly, including the addition
    of modes 0x119-0x11B. (joncampbell123)
  - Added machine=vesa_oldvbe10 to emulate a VESA
    BIOS that follows version 1.0 of the standard.
    Specifically, in version 1.0, mode information
    like XResolution was OPTIONAL and the VESA BIOS
    was allowed not to fill it in since you could
    assume the information from the standard video
    mode number you applied. This setting emulates
    a VESA BIOS that does NOT provide this information,
    for testing purposes. Also, machine=vesa_oldvbe is
    fixed to never report a LFB, since that was not yet
    defined for VBE 1.2. (joncampbell123)
  - Reorganized Windows installation to 2 installers
    installing 32-bit and 64-bit DOSBox-X binaries,
    for WinXP+ (all) and Vista+ 64-bit respectively,
    reducing the sizes of installers significantly
    while adding the SarasaGothicFixed TTF font and
    a language selection page for choosing existing
    language translations (with new language files
    for French and Traditional Chinese). (Wengier)
  - DOSBox-X will now search for more paths (such as
    user config directory and "languages" subfolder)
    for loading language files before failing, and
    on Linux and macOS platforms will also search for
    additional directories such as /Library/Fonts/
    (Linux) or /Library/Fonts/ (macOS) for TrueType
    fonts when using the TTF output. (Wengier)
  - DOSBox-X will try to load the SarasaGothicFixed
    TTF font when no external TTF font is specified
    and a CJK code page detected at start. (Wengier)
  - Added Shift+Tab shortcut in Debugger to switch to
    previous window complimenting existing function of
    Tab switching to the next window. (cimarronm)
  - LH/LOADHIGH command can now load programs into UMB
    memory if it is available. Also added "shellhigh"
    config option to decide whether to load builtin
    command shell to UMB memory (with default setting
    of "auto", it is enabled if reported DOS version
    is at least 7, similar to MS-DOS 7+). (cimarronm)
  - HELP command is now an external command appearing
    on Z drive rather than an internal shell command
    (it is never a DOS internal command). (Wengier)
  - Command-line options -eraseconf and -erasemapper
    will now erase loaded config file and mapper file
    respectively and continue, whereas -resetconf and
    -resetmapper will erase user config file or user
    mapper file and exit as before. (Wengier)
  - Added menu group "3dfx" in "Video" menu to toggle
    the low-level Voodoo card emulation and high-level
    Glide emulation at run-time. (Wengier)
  - Added menu options "Restart DOSBox-X instance" and
    "Restart DOSBox-X with language file" in "Main"
    menu to reboot the current DOSBox-X instance or
    reboot the DOSBox-X instance with the specified
    language file automatically. (Wengier)
  - Added menu options "Show code overview" and "Show
    logging text" in "Debug" menu to show the overview
    of the current code and the output of DOSBox-X's
    current logging text in debug builds. (Wengier)
  - Added config option "customcodepage" in the [dos]
    section to allow a custom code page, in the format
    "customcodepage=nnn,codepagefile" in TrueType font
    (TTF) output. CHCP command also supports additional
    parameter to specify a code page file. Also added
    builtin support for code pages 1250-1258. (Wengier)
  - Added config option "transparency" in [sdl] section
    to change the DOSBox-X window transparency (from 0
    to 90, low to high transparency) on the Linux/macOS
    SDL2 and Windows platforms. (Wengier)
  - Added config option "hidenonpresentable" in [dos]
    section to toggle whether to filter out file names
    on local drives that are non-representative in
    current code page. (Wengier)
  - Added config options "pc-98 try font rom" and
    "pc-98 anex86 font" for the PC-98 emulation to
    customize the font file to load. If former option
    is set to "false", then DOSbox-X will not try to
    load FONT.ROM first for PC-98, and latter option
    specifies an Anex86-compatible font to load for
    PC-98 (before trying FREECG98.BMP). (Wengier)
  - Added support for composite support for PCjr mode
    by porting patch from NewRisingSun. (Wengier)
  - Non-Japanese DOS/V systems will now use 19-pixel
    VGA fonts rather than 16-pixel VGA fonts for SBCS
    characters to look better. (Wengier)
  - You can now also load HZK14/HZK16 font files (for
    14- and 16-pixel height) and STDFONT.15 font file
    via the "fontxdbcs" and "fontxdbcs14" options for
    Simplified Chinese DOS/V (dosv=cn) and Traditional
    Chinese DOS/V (dosv=tw) emulations. (Wengier)
  - Improved the DOS/V font acquisition function on
    the Linux platform (both SDL1 & SDL2), such as
    adding support for 14-pixel height fonts (used by
    Configuration Tool & Mapper Editor), and enhancing
    support for Chinese characters acquisition (e.g.
    WenQuanYi support for the Traditional Chinese). A
    config option "getsysfont" is added which when set
    to "false" will disable the font acquisition on
    Windows and Linux platforms. (Wengier & nanshiki)
  - Implemented support for inputting CJK characters
    on Linux SDL1 builds using Linux system IMEs. Code
    imported from SDL-IM-plus by nanshiki and confirmed
    to work on Linux/X11 platform by him.
  - Added support for inputting Japanese and Korean
    characters using system input method (IME) using
    the default "windib" video driver in Windows SDL1
    build (in addition to "directx" driver). (nanshiki)
  - Fixed CJK characters not showing correctly for the
    SDL-drawn menu with OpenGL outputs if "language"
    config option is used instead of -lang command-line
    option. Thank nanshiki for catching this. (Wengier)
  - Fixed setting "machine=amstrad" cause DOSBox-X to
    crash on non-Windows platforms. (cimarronm)
  - Fixed bug related to DBCS vector table. (nanshiki)
  - Fixed running e.g. built-in DEBUG command from a
    drive other than Z may not work. (cimarronm)
  - Fixed the command "FOR %I ..." not working when
    executed from the command line. (Wengier)
  - For audio/video recording, DOSBox-X will display
    a message box showing the saved file name when the
    recording has been completed. (Wengier)
  - Mapper Editor will try to show the actual mod keys
    for mod1/mod2/mod3 when clicked. (Wengier)
  - Removed the special DOS function at Int21h/AH=2B/
    CX=0x4442h/DX=0x2D58h in favor of the DOSBox-X
    Integration Device at I/O ports 28h-2Bh which works
    for both integrated DOS and guest OS environments.
  - Enabled MT-32 emulation on ARM-based Mac OS X
    builds (joncampbell123)
  - For Configuration Tool, ensure mouse coordinates
    are adjusted accordingly with forced scaler. (aybe)
  - Fixed a bug in the Int21/AH=36h (get disk space)
    function for returning very large CX values, and
    that non-zero values are returned when the free
    space is 0 on mounted local drives. (Wengier)
  - Fixed "FILES" always fixed to 200 as reported by
    the "DOSINFO" tool, in spite of "files" setting in
    [config] section of the config file. (Wengier)
  - Refined the handling of international keyboards and
    fixed some issues in version 0.83.15. (maron2000)
  - Fixed initialization order that prevented Bochs
    port E9h emulation from working. (joncampbell123)
  - Fixed menu options in system menu not working in
    Windows SDL1 builds with "windib" driver. (Wengier)
  - Fixed issue that the mouse cursor not showing in
    the game "Power Dolls". (Wengier)
  - Fixed non-English accents may not show correctly
    with a SBCS code page in TrueType Font (TTF) output
    (introduced in version 0.83.15). (Wengier)
  - Fixed line endings for SBCS language files such as
    English and Spanish translations. (Wengier)
  - Fixed resetting the TTF screen when exiting from
    Configuration Tool or Mapper Editor when TrueType
    font (TTF) output is active. (Wengier)
  - Fixed the option "drive z expand path" not working
    if Virtual Drive Z: has been moved to a different
    drive letter (e.g. Drive Y:). (Wengier)
0.83.15
  - Release notes for this version:
    https://dosbox-x.com/release-0.83.15.html
  - Enhanced the network redirector functions for the
    Windows platform, so that you can for example list,
    open, write, copy, and execute files in UNC network
    paths in the form \\COMPUTER\FOLDER directly when
    network redirector function is enabled and secure
    mode is disabled on Windows systems. (Wengier)
  - MOUNT command followed by a drive letter only will
    show the current status of the drive, or show that
    the drive is not mounted if so. You can make the
    message shorter with the -q option, and filter out
    non-local drives with "-o local" option. (Wengier)
  - Added NE2000.COM (packet driver for NE2000 network
    card) which will appear in Z:\SYSTEM directory when
    NE2000 networking feature is enabled. (Wengier)
  - Added /H option to TRUENAME command to return the
    full filename on the host system for a specified
    file/directory on a mounted local drive. (Wengier)
  - Added option "starttranspath" which if set to true
    will automatically translath all paths in command-
    line to host system paths when starting programs to
    run on the host system. You can also toggle this
    function dynamically from the drop-down menu ("DOS"
    => "Host system applications" => "Translate paths
    to host system paths". (Wengier)
  - Added option "drive z expand path" which when set
    to true (default) will automatically expand %PATH%
    environment variable to include the subdirectories
    on the Z drive when only the Z:\ path is specified
    for compatibility purposes. (Wengier)
  - Added option "turbo" in [cpu] section to enable
    Turbo (Fast Forward) mode at start. You can also
    change it from the command-line via CONFIG command
    (e.g. "config -set turbo=true"). (Wengier)
  - Added value "quiet" to "log console" config option
    to only log DOS console outputs. (Wengier)
  - Added menu command to spawn a new instance of
    DOSBox-X to Mac OS X builds to work around the
    singular app instance model the Finder tends to
    prefer, so that users can run multiple instances
    if they wish. (joncampbell123)
  - MacOS builds will once again have Fluidsynth,
    libslirp, and FFMPEG support from revised .app
    building code. For best results support is enabled
    at compile time only if Brew is installed along
    with Brew builds of those packages. (joncampbell123)
  - MacOS coreaudio MIDI support will continue with
    the default soundfont rather than giving up
    if it cannot select the custom soundfont specified
    in the config file. (joncampbell123)
  - Fixed MacOS bug where coremidi would attempt
    MIDI output even if no MIDI destinations are
    available, which is apparently the case on
    Big Sur. (joncampbell123)
  - The names of advanced config options will now be
    listed in the common config reference file (i.e.
    dosbox-x.reference.conf) too. Several previously
    advanced options are now common options. (Wengier)
  - Command "CONFIG -L" will now list the global config
    file for DOSBox-X (if any). (Wengier)
  - There is now a special DOS function for DOSBox-X at
    Int21h/AH=2B/CX=0x4442h('DB')/DX=0x2D58h('-X'), as
    follows: AL=0h (DOSBox-X installation check), AL=1h
    (SDL version check), AL=2h (platform check), AL=3h
    (machine type check), and AL=4h (DOSBox-X version
    check). For example, you can get installed DOSBox-X
    version by calling the function Int21h/AX=2B04h/CX=
    0x4442h/DX=0x2D58h in your program - AL and AH will
    become 0, and BX will return the DOSBox-X version
    number after "0." (e.g. BH=83, BL=15). (Wengier)
  - It is now possible to translate text for graphical
    Configuration Tool and Mapper Editor interfaces.
    The sizes and/or positions of some buttons in these
    interfaces are adjusted accordingly too. (Wengier)
  - Config option "usescancodes=auto" now implies false
    for PC-98 mode in SDL1 builds. (Wengier)
  - Config option "pc-98 force ibm keyboard layout" now
    defaults to "auto", which implies "true" if a U.S.
    keyboard layout is detected and implies "false"
    otherwise. Also fixed some input keys for the PC-98
    mode. (Wengier & maron2000)
  - For PC-98 mode, if both FONT.ROM and FREECG98.BMP
    are not found in the directory, then DOSBox-X will
    now use internal Japanese font (also used by DOS/V
    and JEGA systems) and the built-in 8x16 SBCS font
    pre-generated from FREECG98.BMP. (Wengier)
  - Added DBCS awareness support for special characters
    "\" and "|" in Chinese/Japanese/Korean code pages
    so that they will be treated properly as trailing
    bytes of double-byte characters. (Wengier)
  - Improved handling of clipboard copy/paste involving
    DBCS characters with TrueType font (TTF) output in
    standard mode. The clipboard copy/paste feature is
    also supported in DOS/V and JEGA modes. (Wengier)
  - The config option ttf.halfwidthkana (now in [ttf]
    section) will enable low ASCII boxing characters
    for the TrueType font (TTF) output too. This option
    is now enabled by default for JP mode, and printing
    these characters is also supported. (Wengier)
  - Added support for showing Chinese/Japanese/Korean
    characters in the SDL-drawn menu (in addition to
    characters in different SBCS code pages) and the
    Configuration Tool interface (so e.g. DOS command
    help will show correctly for these languages). You
    can change the DBCS font used by Configuration Tool
    interface via fontxdbcs14 config option. (Wengier)
  - Added support for inputting DBCS characters using
    system input method (IME) in Windows SDL1 build.
    Chinese (Simplified and Traditional) IMEs may work
    with the default video setting and a Chinese code
    page or Chinese DOS/V mode. Japanese & Korean IMEs
    may require DirectX mode for the SDL1 library (set
    option "videodriver" to "directx" in [sdl] section
    for this). There is a new config option "ime" in
    [dosbox] section to control it. When set to "auto"
    (default), it is enabled for Windows SDL1 builds
    only if DOSBox-X is started with a CJK code page or
    in PC-98, JEGA or DOS/V mode. (Wengier)
  - Added support for Japanese EGA mode (machine=jega)
    by adopting code from DOSVAXJ3. As with DOS/V, you
    can optionally set the SBCS and DBCS fonts with
    fontxsbcs, fontxdbcs (and fontxsbcs19, fontxdbcs24,
    etc) options in [dosv] section of config file, or
    the default fonts will be used for them. (Wengier)
  - Added support for DOS/V (Japanese mode) by adopting
    code from DOSVAXJ3. Also added support for Chinese
    and Korean DOS/V modes. Set option "dosv" to "jp",
    "chs" (or "cn"), "cht" (or "tw"), or "ko" in [dosv]
    section of the config file to enable DOS/V mode for
    different CJK languages. There are now also various
    font-related (and V-text screen mode) options added
    in [dosv] section for the DOS/V support. For the
    Simplified Chinese (code page 936), you can also
    enable GBK extension of the standard GB2312 charset
    with "gbk" option for Simplified Chinese DOS/V and
    the TrueType font (TTF) output. (Wengier)
  - Added support for codepage conversion of file names
    in "drivez" folder (for customization of Virtual
    Drive Z:) so that they will appear properly on this
    drive according to the code page set. (Wengier)
  - Improved support for DBCS (double-byte) characters
    on mounted FAT drives with Chinese/Japanese/Korean
    codepages (932/936/949/950). (Wengier)
  - The "Unexpected control character" error message
    which may appear when executing certain batch files
    is now a debug message (belong to the "misc" type)
    instead of showing to the DOS console output.
  - Added "videodriver" config option in [sdl] section
    to force a video driver (such as windib/windows,
    x11, dummy) for the SDL library to use. The video
    driver "directx" has been enabled for Windows SDL1
    builds (without certain functions). (Wengier)
  - There is a now a [ttf] section in the config file,
    and TTF-related config options are moved/renamed
    from [render] section to this section (previous
    config options "ttf.*" in [render] section become
    * (with "ttf." dropped) in [ttf] section). Windows
    installer will also automatically transfer previous
    TTF options to the new [ttf] section. (Wengier)
  - When setting to "auto", config option "allow lmsw
    to exit protected mode" will be active for Pentium+
    CPUs instead of 486+ CPUs. (Wengier)
  - Fixed a bug which may lead to crash when pasting
    text via the DOS clipboard API (e.g. the 4DOS CLIP:
    device) in non-Windows platforms. (Wengier)
  - Fixed the possible freeze when output was switched
    from TrueType font (TTF) output and you tried to
    reset the virtual machine. (Wengier)
  - Fixed non-representative filenames on local drives
    in current code page causing memory corruption for
    e.g. Windows 3.1 Setup on non-Windows platforms.
    These entries will no longer appear to DOS guest
    system in incompatible code pages. (Wengier)
0.83.14
  - Release notes for this version:
    https://dosbox-x.com/release-0.83.14.html
  - Added support for directories on the Z drive, so
    there is no need to put all files/programs on the
    root directory of Z drive any more. Only one-level
    directories are currently supported. There are now
    six directories on the Z drive by default, namely
    4DOS, BIN, DEBUG, DOS, SYSTEM, TEXTUTIL. Most files
    that previously appeared on the root directory of
    Z drive are now categorized into directories, with
    addition of some files/programs, such as additional
    4DOS files, text utilities in TEXTUTIL directory
    and TITLE command to change window title. Default
    value of the %PATH% environment variable has been
    expanded to include these subdirectories, but if
    you use a custom path then you may want to include
    these directories in your %PATH%. (Wengier)
  - You can now specify a command shell located on a
    mounted local drive via SHELL= command in [config]
    section of config file after the drive is properly
    mounted via INSTALL= command. (Wengier)
  - Extended START command to Linux and macOS systems.
    It's disabled by default just like on Windows host
    systems, but can be enabled by setting "startcmd"
    to "true" or with the -hostrun command-line option
    (replacing -winrun command-line option). (Wengier)
  - CHCP command in the TrueType font (TTF) output now
    allows code page 932, 936, 949, and 950 to display
    Chinese, Japanese and Korean characters and file
    names with DBCS support enabled in non-PC98 mode.
    By default DOSBox-X will enable DBCS characters and
    auto-detection for box-drawing characters in these
    code pages, and these can be disabled by setting
    new options "ttf.autodbcs" and "ttf.autoboxdraw" to
    "false". There is also option "ttf.halfwidthkana"
    to enable half-width Katakana in Japanese non-PC98
    machines. KEYB command (and "keyboardlayout" config
    option) also accept "jp", "ko", "cn", "tw", "hk",
    "zh" as key layout names for code pages. (Wengier)
  - Added support for printing Chinese/Japanese/Korean
    DBCS (double-byte) characters when these code pages
    are active, which by default ("auto") is enabled for
    the TTF output, but can be enable or disabled for
    all outputs by setting option "printdbcs" to "true"
    or "false" in [printer] section. (Wengier)
  - Added ability to toggle between Shift-JIS (or Kanji)
    and graphical modes using Ctrl+F4 key (or ESC )3 and
    ESC )0 escape sequences) in the PC-98 mode. There
    is now also an indication of graphical mode in the
    function row. (nmlgc)
  - Added the "usesystemcursor" config option (in [sdl]
    section) which when set to true will use host system
    mouse cursor instead of drawing a DOS mouse cursor
    when the mouse is not locked. (Wengier)
  - When opening "Save..." or "Save Language File..."
    dialogs in the Configuration Tool, the new dialogs
    will now automatically be in focus. For the language
    file, the name of the current language file will be
    filled and modifiable. Pressing ENTER key saves the
    config or language file, and pressing ESC key will
    close these dialog boxes. (Wengier)
  - Command "CONFIG -wl" will show the name of language
    file being written to (if there is a language file
    loaded then "CONFIG -wl" alone will write to it),
    and command "CONFIG -ln" will show current language
    name (if any), or you can use command "CONFIG -ln
    <lang_name> -wl <lang_file>" to specify a language
    name when writing to a language file. (Wengier)
  - Added special properties to CONFIG command such as
    "hostos", "programdir", "workdir", "configdir", and
    "userconfigdir" so that commands like "CONFIG -GET
    hostos" and "CONFIG -GET workdir" will get the host
    system OS and DOSBox-X working directory. (Wengier)
  - If a config option can only be changed at run-time,
    "CONFIG -set" will now show such a message. You can
    use "CONFIG -setf" to bypass, but the setting won't
    take effect in the current session. (Wengier)
  - SETCOLOR command can now change the text-mode color
    schemes in outputs rather than the TrueType font
    output too (VGA mode only). (Wengier)
  - Added support for new TTF word processor type "FE"
    for FastEdit, a new DOS text editor with functions
    to view and change text styles. (Wengier)
  - Added "ttf.wpfg" config option in [render] section
    which can optionally specify a foreground color
    (0-7) for the TTF output, similar to "ttf.wpbg" for
    the background color in the TTF output. (Wengier)
  - Added "ttf.printfont" config option in [render]
    section which when set to true (default) will force
    to use the current TrueType font (set via ttf.font)
    for printing too when using TTF output. (Wengier)
  - Added additional options to the "mouse_wheel_key"
    config option to allow conversion of mouse wheel
    movements into Ctrl+up/down arrow (option 4), Ctrl+
    left/right arrows (option 5), Ctrl+PgUp/PgDn keys
    (option 6), and Ctrl+W/Z as used by WordStar & EDIT
    (option 7) . More menu options are added to "Mouse
    wheel movements" menu group as well. (Wengier)
  - Added menu option "Print text screen" (under "DOS")
    to print current DOS text screen, if the printer
    feature has been enabled. (Wengier)
  - Added menu options "Display TTF blinking cursor",
    "CJK: Switch DBCS/SBCS mode", "CJK: Auto-detect
    box-drawing characters" and "CJK: Allow half-width
    Japanese Katahana" under "Video" => "TTF options"
    menu group to toggle the TTF options ttf.blinkc,
    ttf.autodbcs, ttf.autoboxdraw and ttf.halfwidthkana
    in [render] section of the config file. (Wengier)
  - Support for UTF-8 encoded language files. Specify
    a DOS code page with "country" option in [config]
    section of the config file. Windows SDL1 menu and
    macOS menu are now also compatible with Unicode
    language files and characters. Also improved code
    page compatibility for text in the SDL drawn menu
    and the Configuration Tool. (Wengier)
  - Cleaned up the welcome banner messages and other
    messages involving boxdrawing characters for easier
    translations into certain languages. (Wengier)
  - Command-line option -silent now implies -nomenu,
    SDL_AUDIODRIVER=dummy and will disable all sound-
    related config option as well. (Wengier)
  - Command-line option -fastlaunch will now suppress
    messages by "automountall=true" option. Also added
    value "quiet" to "automountall" config option to
    auto-mount all Windows drives quietly. (Wengier)
  - Added default value "auto" to "backend" option in
    [ne2000] section of the configuration which will
    automatically select slirp backend if available,
    then pcap backend if available. (Wengier)
  - Improved handling of Ctrl+C/Ctrl+Break for shell-
    based DOS programs. (Wengier)
  - Setting "irq" to "0" in [sblaster] section of the
    config file will use the default IRQ number for the
    sound card type. Also fixed "irq=-1", "dma=-1" and
    "hdma=-1" not working as desired. (Wengier)
  - Option "dpi aware=auto" now defaults to "true" when
    full-screen mode is requested when DOSBox-X starts
    in Windows SDL1 builds. (Wengier)
  - The return value of AL in Int21/AX=0Eh is no longer
    fixed. The game Jurassic Park may run after moving
    Z drive to a different letter (e.g. E:). (Wengier)
  - Added "Change current floppy image..." and "Change
    current CD image..." menu options to change the
    currently active floppy disk image(s) on drive A: &
    B: and ISO/CUE image(s) on CD drives respectively.
    This makes it possible to change the active floppy
    disk and/or CD images while a guest system (e.g.
    Windows 9x) is currently running. (Wengier)
  - Added "Restart DOSBox-X with config file..." menu
    option to start DOSBox-X with the specified config
    file automatically from the menu. (Wengier)
  - Added "Refresh rate..." menu option (under "Video")
    to set the video refresh rate. (Wengier)
  - Added "Enable A20 gate" menu option (under "DOS")
    to enable or disable the A20 gate. (Wengier)
  - Added "maximize" config option in [sdl] section to
    automatically maximize the DOSBox-X window at start
    (SDL2 and Windows SDL1 builds only). (Wengier)
  - Added "allow lmsw to exit protected mode" config
    option in [cpu] section to control whether the LMSW
    instruction allows the guest to clear the PE bit
    (leave protected mode).
  - Added "debuggerrun" config option in [log] section
    to set the run mode when DOSBox-X Debugger starts.
    You can now also switch them from the menu ("Debug"
    => "Debugger option: ..."), including "debugger",
    "normal" and "watch", the later two corresponding
    to debugger commands "RUN" and "RUNWATCH". Also,
    the built-in DEBUGBOX command without a parameter
    will start the DOSBox-X debugger. (Wengier)
  - Debugger interface now accepts the '0' key as a
    command to single-step in case F11 isn't an option.
    If you are using XFCE's Terminal emulator, this is
    helpful because Terminal app takes F11 for itself.
  - "Debug" menu is now a top-level menu for debugging
    builds (for non-debugging builds there is "Logging
    console" menu group under "Help"). Also added more
    debug options including "Generate NMI interrupt"
    and "Hook INT 2Fh calls" under this menu. (Wengier)
  - Fixed /S and /F option (date/time-synchronization
    ON/OFF) of DATE command not working. (Wengier)
  - Fixed aspect=true not working properly for some
    screen modes such as machine=ega. (Wengier)
  - Fixed the mouse not automatically captured when
    DOSBox-X starts with the settings fullscreen=true
    and autolock=true. (Wengier)
  - Fixed inputs in the Configuration Tool when the
    Configuration Tool is scaled. (Wengier)
  - Fixed keys may not work after loading a saved state
    for the game Buck Rogers. (Wengier)
  - Fixed Windows detection for the game "Tex Murphy:
    Under a Killing Moon". (Wengier)
  - Fixed serial ports 5-9 may not be usable with real
    serial ports (directserial). (vkbaf & Wengier)
  - Fixed issues related to screen dimensions in TTF
    output in CGA/EGA modes since 0.83.12. (Wengier)
  - Added alternative Windows installer for administrative
    install mode on Windows Vista or later. (Wengier)
  - Integrated SVN commits (Allofich)
    - r4443: Improve detection of Paradise SVGA in some
    installers with additional signature.
    - r4453: Improve bittest instructions to wrap more
    correctly. 
    - r4454: Enable A20 routines in BIOS.
    - r4456: The numeric keypad can now be used to
    navigate the debugger when Num Lock is off.
0.83.13
  - Release notes for this version:
    https://dosbox-x.com/release-0.83.13.html
  - DOSBox-X can now resolve file paths in its config
    options that include environment variables on non-
    Windows platforms (e.g. ${HOME}..) as well. A new
    config option "resolve config path" (in [dosbox]
    section) is added to control path resolving in the
    config file (e.g. to resolve tildes only by setting
    to "tilde", or disable all path resolving). (Wengier)
  - System menu text in Windows builds now match the text
    in the drop-down menus to be translatable by language
    files and is compatible with Unicode. (Wengier)
  - The error "Access Denied" is returned instead of
    "File not found" for files opened exclusively in
    another program on mounted local drives. (Wengier)
  - S386C928 hardware cursor fixed to divide X coordinate
    by bytes per pixel indicated in the control register
    to match apparent Windows 3.1/95 behavior. Cursor
    now tracks host properly even in highcolor/truecolor
    modes.
  - Added support for the RetroWave OPL3 hardware player.
    Set "oplemu=retrowave_opl3" in [sblaster] section of
    the config file to use it. Config options including
    "retrowave_bus", "retrowave_spi_cs", "retrowave_port"
    are added to adjust its settings. (ClassicOldSong)
  - Added support for S386C928 hardware cursor color
    selection in 256-color mode, which is different
    from later cards.
  - S3 XGA "BYTE SWP" fixed only to byte swap if the
    transfer is 16-bit wide. This fixes the dither
    pattern drawn by Windows 95/98 when you select
    "Shutdown" from the Start menu.
  - IMGMAKE command is now disabled in the secure mode,
    similar to commands like IMGMOUNT. (Wengier)
  - Added config options "working directory option" and
    "working directory default" in [dosbox] section of
    the config file to provide various options for the
    users to control DOSBox-X's working directory. For
    example, DOSBox-X can use the primary config file
    directory or the DOSBox-X program directory as its
    working directory. You can view the DOSBox-X'safe
    working directory with CONFIG -L command. DOSBox-X
    is also able to save the working directory that a
    user selects to global config files. (Wengier)
  - DOSBox-X will now also try to read the config file
    named dosbox-x.conf in the user config directory
    when searching for config files at start.
  - Added new command-line options -promptfolder and
    -nopromptfolder which will cause the folder prompt
    dialogs to show or not to show at startup.
  - Mac OS X builds will prompt the user to select a
    folder at startup if run from the Finder (or from
    the root directory). The folder selected will then
    become the current working directory of DOSBox-X.
    This makes it possible to start DOSBox-X with a
    config file of your choice and to control where
    the capture, save states and other files go.
  - Fixed Tseng ET4000 640x480 256-color SVGA mode
    when using the ET4000.BIN VGA BIOS, or Windows 98.
  - Added segment limit checks in Normal core for
    MOVSB/MOVSW/MOVSD and STOSB/STOSW/STOSD, which is
    needed for DOSBox-X to work with the Windows 3.1
    S3 86C928 display drivers that use segment limit
    exceptions to fake a linear framebuffer.
  - Added S3 XGA "byte swap" emulation, needed for
    correct menu/titlebar display in Windows 3.1 when
    using the S3 86C928 driver.
  - Added YUV (YUY2) overlay to S3 Trio64V+ card
    emulation. Tested with XingMPEG under Windows 3.1
    and ActiveMovie under Windows 98.
  - Added machine types for 5 different variations of
    S3 chipset: Vision864, Vision868, Trio32, Trio64,
    and (experimental) Trio64V+, ViRGE, ViRGE/VX, and
    S3 86C928.
  - Removed second PCI BAR for S3 MMIO register space.
    S3 datasheets do not show a second BAR. Windows 95
    is perfectly happy without it.
  - S3 SVGA XGA emulation BlitRect now supports
    COLOR_CMP. DirectX-based Windows 95 games are now
    able to blit in 256-color mode with a transparent
    color key value.
  - ANSI.SYS emulation now supports the "Device Status
    Report" escape when asked through code 6 (report
    cursor position)
  - Fixed RAM mapping bugs related to MDA/CGA/Hercules
    emulation and the "allow more than 640kb" option,
    that failed to map RAM as expected, and because of
    that, easily triggered a "corrupt MCB chain" error
    message.
  - Worked around the mounting issue for disk or CD
    image files with LaunchBox, by allowing a mounting
    command-line with single quotes like IMGMOUNT D
    'X:\FILES\DOS.IMG' on Windows systems. (Wengier)
  - Restored Pentium MMX emulation code for the dynamic
    x86 core to that of version 0.83.11 for better
    compatibility with some Windows 9x games. (Wengier)
  - Added "compresssaveparts" config option (in the
    [dosbox] section) which when set to false will not
    compress the components in saved states. (Wengier)
  - When the current reported DOS version is less than
    7.x and the user tries to mount a LBA or FAT32 disk
    image, DOSBox-X will now show a message to ask if
    the user wants it to set the required DOS version
    automatically and proceed. (Wengier)
  - DOSBox-X will now show the folder mounted after
    mounting to a drive from the menu. (Wengier)
  - Fixed MOUNT and IMGMOUNT commands unable to mount
    directories or image files that contain non-ASCII
    characters in the code page on Windows. (Wengier)
  - Fixed CapsLock may not work properly in Windows
    SDL1 builds when -fs option is used. (Wengier)
  - Fixed the cycle information on the title bar when
    the Turbo mode is enabled. (Wengier)
  - Fixed that some games using the DOS4GW Extender
    may not work due to swap file issue. (Wengier)
  - Fixed that the clipboard copy and paste may not
    work when the current code page is 808 or 872
    and you are using Windows. (Wengier)
  - Fixed the handling of the "Save & Restart" button
    in Configuration Tool when using Direct3D output
    in Windows SDL2 builds. (Wengier)
  - Fixed incorrect display issue when using TrueType
    font (TTF) output with customized screen dimension
    when fastbioslogo=true is set. (Wengier)
  - Fixed CD audio not looping for individual tracks
    in games like Alien Trilogy. (kcgen)
  - The command "MIXER /LISTMIDI" now lists the ROM
    directory/files and sound fonts for MT32, Synth
    and FluidSynth MIDI device when active. (Wengier)
  - Debugger "DOS XMS" command will only list handles
    that are allocated, or with nonzero address or
    nonzero size, to avoid showing irrelevant
    information. (joncampbell123)
  - Added LOADFIX -EMS option to allocate/free
    EMS (expanded memory). (joncampbell123)
  - LOADFIX -D -XMS will free all XMS blocks
    allocated by LOADFIX -XMS. (joncampbell123)
  - LOADFIX -A will not allocate memory unless there
    is memory below 64KB to fill. (joncampbell123)
  - INT 15h PS/2 mouse functions now clear pending
    PS/2 mouse interrupt as part of the BIOS call.
    This should resolve unresponsive mouse issues
    with Windows 3.1. (joncampbell123)
  - Add config option "mt32.model" in the [midi]
    section to force a MT-32 model to use. (Wengier)
  - Updated the MUNT MT-32 library to the latest
    version 2.5.0. (Wengier)
  - Updated FLAC decoder library to the latest version
    (0.12.29 by David Reid). (Wengier)
  - Integrated SVN commits (Allofich)
    - r4436, r4437: Rewrite store integer instructions
    to check if the result fits.(vogons 78127)
    - r4447: Attribute Controller port alias on EGA
    machine. Fixes EGA display of older Super Pac-Man
    release.
0.83.12
  - Release notes for this version:
    https://dosbox-x.com/release-0.83.12.html
  - Tandy graphics emulation fixed to accept 8 bits
    for vertical total and vertical display CRTC
    registers, which is needed for the tweaked
    graphics mode used by Math Rabbit to display
    correctly.
  - INT 10h will no longer fill in three fields in
    the BIOS data area (video CTL, char height, and
    video switches) unless the machine type is
    EGA or VGA. Those fields do not exist otherwise.
    Certain games like Mindscape's "Road Runner" game
    require those fields to be zero as part of its
    Tandy detection routine.
  - PCjr mode will omit the reserved graphics RAM
    MCB block, and will subtract 16KB from the top
    at the BIOS level, if emulating 128KB system
    memory or less.
  - You can now run PCjr mode with as little as
    128KB of RAM. Removed 256KB minimum check from
    DOS kernel. Certain games (Mickey's Space
    Adventure) require memsizekb=128 and memsize=0
    in PCjr mode or else it will not work correctly
    due to how the game locates video system memory.
  - Fixed Tandy mode to place video memory at the
    top of conventional memory and allow running
    Tandy mode with a memsizekb setting as low as
    64KB, though 256KB or higher is recommended.
  - Added Tandy "real memory size" field in the
    BIOS data area.
  - Tandy emulation updated to subtract 16KB from
    top of conventional memory, which fixes some
    games and follows DOSBox SVN behavior and real
    hardware according to others on the Vogons forums.
  - Fixed bug that limited Tandy mode to 624KB of
    conventional memory. 32KB of video RAM is taken
    from top of memory, losing half of the 32KB
    breaks games that write to the system RAM instead
    of B800:0000 segment and causes half the graphics
    to not render.
  - CD-ROM image emulation now supports ISO images
    that are 2GB or larger, 32-bit integer size limit
    has been lifted.
  - Increased upper limit of "prebuffer" config option
    (in [mixer] section) from 100 to 250. It is still
    recommended to set a value less than 100. (Wengier)
  - Added scrollbar buttons to the Configuration Tool,
    so that the scrollbars better resemble the style of
    the Windows 3.1 scrollbars.
  - The help window for the Configuration Tool will now
    display possible and default values for the config
    options in addition to the descriptions. (Wengier)
  - Updated the MMX patch code by kekko. (Wengier)
  - MIXER command now supports the /GUI option to show
    a popup window to display the mixer information.
    Also improved its /LISTMIDI option which will show
    the name of the current MIDI handler and you can
    optionally specify a MIDI handler name (win32/alsa)
    to show the information for this handler. (Wengier)
  - Improved the compatibility of AUTOTYPE command with
    games like Asterix & Obelix. (Wengier)
  - The config options ttf.wpbg, ttf.bold, ttf.italic,
    ttf.underline, ttf.strikeout, and ttf.char512 can
    now be modified dynamically with CONFIG -SET ...
    commands, e.g. CONFIG -SET ttf.wpbg=2. (Wengier)
  - The minimal value for the ttf.ptsize config option
    has been decreased from 10 to 9. (Wengier)
  - Added menu item "Save logging as..." (under "Help"
    -> "Debugging options") to save the current logging
    content to the specified file. (Wengier)
  - Added slirp backend support for the NE2000 network
    feature (in addition to the existing pcap backend).
    There are config sections named [ethernet, slirp]
    and [ethernet, pcap] now to set the options for the
    slirp and pcap backends respectively. Please refer
    to the networking guide in the DOSBox-X Wiki for
    more information about the backends. (Jookia)
  - FAT driver can now support PC-98 HDI images with
    partitions that start at any physical sector even
    if the start is not a multiple of the ratio of
    logical to physical sector size. This allows the
    HDI image of Dragon Knight 4 to mount.
  - Control character 7 (BEEP) is now allowed while
    executing batch files without warnings. (Wengier)
  - With the setting "core=auto" DOSBox-X now updates
    the menu in the "CPU core" menu group automatically
    between "Normal core" and "Dynamic core" to reflect
    the CPU core which is currently in use. (Wengier)
  - Fixed Windows 95/98 installation failures caused by
    FAT driver and DOS API changes in previous version.
  - Fixed well-intended but erroneous fall through case
    in the INT15 handler that prevented 3rd party mouse
    drivers from detecting the PS/2 mouse.
  - Fixed the color issue with the Configuration Tool
    in the macOS SDL1 build. (ant_222)
  - Fixed switching ttf.cols, ttf.lins, and ttf.font
    options dynamically in full-screen mode. (Wengier)
  - Fixed menu options "Increase TTF font size" and
    "Decrease TTF font size" (both under "Video" =>
    "TTF options") not working (but keyboard shortcuts
    and those in the system menu work). (Wengier)
  - Fixed setting option "ttf.wp=xy3" or "ttf.wp=xy4"
    not working (but "ttf.wp=xy" did work). (Wengier)
  - Fixed preview function in WordStar not working for
    TrueType font output in previous version. (Wengier)
  - Fixed the issue that caused Windows 3.x group file
    corruption on hard disk image files. (SnikoLoft)
  - Integrated SVN commits (Allofich)
    - r4416: Added ability to start and stop avi
    recording, and to start keymapper, from config.
    - r4405: Smarter clearing of the dynrec cache.
0.83.11
  - Release notes for this version:
    https://dosbox-x.com/release-0.83.11.html
  - Added support for the clipboard device (CLIP$) and
    DOS clipboard API on non-Windows systems (they were
    previously only supported on the Windows platform).
    In Linux SDL1 build only read access is supported
    whereas both read and write access are supported in
    all other builds. Also, selecting and copying text
    to the host clipboard using a mouse button or arrow
    key is now supported in macOS SDL1 build. (Wengier)
  - Added "Paste Clipboard" button to the AUTOEXEC.BAT,
    CONFIG.SYS and 4DOS.INI sections in Configuration
    Tool for pasting clipboard contents. (Wengier)
  - Windows SDL2 builds now use same clipboard pasting
    method as Windows SDL1 builds by default instead of
    the BIOS keyboard function. The method is now also
    available for Linux and macOS (both SDL1 and SDL2)
    builds (although it is disabled by default on these
    platforms). A menu option "Use BIOS function for
    keyboard pasting" is added to the "Shared clipboard
    functions" menu group (under "Main") to use BIOS
    function for the clipboard pasting instead of the
    keystroke method. Make sure this option is disabled
    if pasting clipboard text into Windows 3.x/9x apps
    (e.g. Notepad & Write) is desired. This setting can
    be changed with "clip_paste_bios" config option in
    in [sdl] section of the config file too. (Wengier)
  - With the config option "startcmd=true" or command-
    line option -winrun, Windows applications can now
    be launched from within a DOS program or from the
    4DOS shell in addition to built-in shell. (Wengier)
  - Added the "disable graphical splash" config option
    in [dosbox] section which when set will cause a
    text-mode BIOS splash screen to be always displayed
    at startup instead of the graphical one. If the
    TrueType font (TTF) output is enabled the text-
    mode BIOS screen is used automatically. (Wengier)
  - Added a simple BIOS Setup Utility, which will show
    a summary of the current system configuration and
    allow users to change the date and time. Press Del
    key at the BIOS boot screen to enter. (Wengier)
  - Added config option "showbasic" in [sdl] section
    which when set to false will hide DOSBox-X version
    number and running speed in the titlebar. (Wengier)
  - Added experimental option to load a VGA BIOS ROM
    image and execute it, instead of our own INT 10h
    emulation. If enabled, it will load the specific
    ROM file into C000:0000. If not specified, it
    will choose based on machine type. VGA BIOS ROM
    images (e.g. et4000.bin for Tseng ET4000 emulation)
    can be dumped from real hardware or downloaded from
    the PCem ROMs collection. It can be set with config
    option "vga bios rom image" in [video] section.
  - Improved handling for file- and record-locking
    for non-Windows platforms. Portions of the code
    are adopted from DOSEmu. (Wengier)
  - Improved handling for the setting "ansi.sys=false",
    such as fixing the welcome screen messup in this
    case and allowing the use of a custom ANSI TSR
    (such as NNANSI.COM) instead. (Wengier & stu)
  - You can now press Ctrl+C or Ctrl+Break to break
    from long outputs from commands like TYPE, MORE,
    COPY, DIR /S, and ATTRIB /S. (Wengier)
  - Renamed MEM.COM to MEM.EXE to match DOS. (Wengier)
  - Rewrote built-in TREE command instead of the one
    from FreeDOS to support long filenames. (Wengier)
  - DELTREE is now an external command appearing on
    drive Z: as DELTREE.EXE instead of a builtin shell
    command, since it is an external command in a real
    DOS system. (Wengier)
  - Added REPLACE command to replace files, resembling
    the MS-DOS counterpart. This command is compiled
    with long filename support. (Wengier)
  - Added PUSHD and POPD commands so that you can store
    the current directory and changes to the specified
    directory (optionally also the current drive), then
    changes the directory/drive back. PUSHD command
    without arguments show stored path(s). (Wengier)
  - Added COLOR command to change current foreground
    and background colors. It usage is similar to the
    same-named command in the Windows command prompt.
    For example, command "COLOR fc" produces light red
    on bright white; COLOR without an argument restores
    the original color. (Wengier)
  - Added CHCP command to view the current code page,
    or change the current code page for the TrueType
    font (TTF) output. Supported code pages include:
    437, 808, 850, 852, 853, 855, 857, 858, 860, 861,
    862, 863, 864, 865, 866, 869, 872, and 874. You can
    now also set the code page for TTF output via the
    optional second parameter of the "country" option
    in [config] section of the configuration. (Wengier)
  - Added function to automatically save states in the
    specified time interval (in seconds). You can also
    specify a save slot or start and end save slots to
    be used. For example, "autosave=10 11-20" will set
    a 10-second time interval for auto-saving, and the
    save slots used will be between 11 and 20. If no
    save slot is specified, then the current save slot
    will be used for auto-saving. Putting a minus sign
    before time interval causes the auto-saving function
    to not be activated at start. You can optionally
    also specify up to 9 program names for this feature,
    e.g. "autosave=10 11-20 EDIT:21-30 EDITOR:35" will
    cause program "EDIT" to use save slots 21-30, and
    "EDITOR" to use save slot 35, and other programs to
    use save slots 11-20. Added a menu option "Auto-save
    settings..." to manage the auto-saving feature at
    run-time. A menu option "Enable auto-saving state"
    is added to the "Save/load options" menu group under
    "Capture" to toggle auto-saving when the function is
    enabled. Likewise, a menu option "Select last auto-
    saved slot" is added to the "Select save slot" menu
    group (also under "Capture") to switch to the last
    auto-saved slot (if any). (Wengier)
  - The Configuration Tool windows are now scalable, so
    that they will no longer look very small in e.g.
    full-screen or High DPI modes. (ant_222)
  - If the -defaultdir option is the only or the last
    command-line option and no parameter is specified,
    then directory of the primary config file (if any)
    becomes the DOSBox-X default directory. (Wengier)
  - You can now change the current output dynamically
    with CONFIG command, e.g. "CONFIG -set output=ttf"
    and "CONFIG -set output=default". (Wengier)
  - The command "KEYB US" will return the DOS codepage
    to 437 if current codepage is different. (Wengier)
  - The setting "output=default" will enable the OpenGL
    output for Linux systems if possible. (Wengier)
  - Fixed the CGA/MCGA/MDA/Hercules-specific shortcut
    function buttons in Mapper Editor, and the screen
    colors after exiting from Mapper Editor when using
    these machine types in Direct3D output (SDL1 build).
    Also fixed the messages in the welcome banner for
    these machine types to inform users the new default
    shortcuts (Ctrl(+Shift)+[F7/F8]). (Wengier)
  - Fixed DOS Int21/AH=0x5a "Create temporary file"
    function not generating unique files. (Wengier)
  - Fixed that the current drive goes back to Z drive
    when combined unmounts & mounts are used. (Wengier)
  - Fixed PC-98 keyboard handling of CTRL+A through
    CTRL+Z. CTRL+C now works correctly in PC-98 mode.
  - Fixed crash of Free Pascal compiler with dynamic
    core and setting "use dynamic core with paging on =
    auto" introduced in the previous version. (Wengier)
  - Fixed launching Windows programs when the working
    directory has no 8.3 filename entry. (Wengier)
  - Fixed issues with full-screen switch in some cases
    when the TrueType font output is enabled. (Wengier)
  - Fixed an issue in MinGW builds that no data will be
    sent to the OPL3Duo board. (DhrBaksteen)
  - Fixed screen flickering when hovering over the menu
    with Direct3D output in the Windows SDL2 build that
    was introduced in the last version. (Wengier)
  - Fixed mounting disk/CD images with long paths from
    the "Drive" menu may not work properly. (Wengier)
  - Fixed that the "Save" button in Configuration Tool
    did not save config file in last version. (Wengier)
  - Integrated SVN commits (Allofich)
    - r4346: Fix a long-standing crash that occurred
    when disconnecting a second joystick after
    partially mapping it.
    - r4344: Add F8 to toggle printable characters on
    and off in the debugger.
    - r4340: Fix behavior when main memory allocation
    fails.
    - r4336: Correct an oversight of r4186 when floppy
    disks are mounted.
    - r4330: some big endian improvements and drive_fat
    fixes. (jmarsh)
    - r4320: Report Q-Channel track number in BCD,
    meaning it is not converted to binary by the
    CD-ROM device driver. Fixes the CD-Player feature
    of DOS Navigator 1.51 when playing past track 15.
    - r4318: Add LOGC debug command to log cs:ip only.
0.83.10
  - Release notes for this version:
    https://dosbox-x.com/release-0.83.10.html
  - The Windows key(s) in Windows and the Command key(s)
    in macOS will now be displayed as the "Windows" and
    "Command" keys instead of the "super" and the "meta"
    keys in SDL1 builds just like SDL2 builds. (Wengier)
  - Cursor blinking rate for TrueType font (TTF) output
    can now be customized with the ttf.blinkc option.
    Set an integer between 1 (fastest) and 7 (slowest)
    to change TTF cursor blinking rate, or setting it to
    0 for no cursor (or false for non-blinking cursor as
    in previous versions), with the default value being
    6 on PC-98 systems and 4 elsewhere. (Wengier)
  - Fixed parallel port emulation to allow MDA port 3BCh
    to work properly.
  - Enhanced the printer function on Windows platforms
    to allow printer names to be specified in [printer]
    section via the "device" option for direct printing
    to the selected device. If left empty, then Windows
    Print dialog will always be shown, or specifying "-"
    will cause it to show only once (unless the user
    clicks "Cancel"). Under "Help" menu there is now a
    menu option "List Printer Devices" to list printer
    devices on Windows, and the parallel port LPT1 now
    defaults to the printer on all platforms. (Wengier)
  - The dynamic_x86 CPU core can now handle page faults
    non-recursively, so you can now run the dynamic_x86
    core with Windows 9x/ME without crashes, although
    this may slightly decrease the performance, and it
    may be disabled by setting the config option "use
    dynamic core with paging on" in [cpu] section to
    "false"; the default value of this option has been
    changed to "auto" which will enable/disable itself
    based on whether the 386 paging and a guest system
    has been enabled. Also fixed incorrect behavior for
    handling trap flags in the dynamic core and updated
    the MMX code for improved performance. (koolkdev)
  - Added support for Direct3D output on Windows SDL2
    builds just like Windows SDL1 builds to become the
    default output in all Windows builds. (Wengier)
  - DOSBox-X now natively supports the pixel-perfect
    scaling! Set the option "output=openglpp" in [sdl]
    section of the config file to enable this output.
    Alternatively, the output can be selected from the
    menu ("Video" => "Output" => "OpenGL perfect") at
    run-time. It is recommended to set config options
    and "aspect=true" (whenever the emulated display
    has an aspect ratio of 4:3) and "doublescan=false"
    for openglpp output. Also, with high DPI displays
    (e.g. on Windows 7+ with DPI scaling enabled) it
    works better with full-screen mode and the setting
    "dpi aware=true". It was implemented by ant_222
    (patch author) with some code cleanups by Wengier.
  - Updated the Windows installer to add a page for
    new users to select a video system output to use -
    the default output (Direct3D), OpenGL with pixel-
    perfect scaling (openglpp or "OpenGL perfect") for
    improved image quality, and the TrueType font (TTF)
    output for text-mode DOS applications. (Wengier)
  - You can now supply a ZIP/7Z file as a parameter to
    DOSBox-X directly so that it will be mounted as C:
    drive when DOSBox-X starts. (Wengier)
  - Added overlay support for mounting PhysFS drives
    so that you can specify a write location when you
    mounted a ZIP/7Z archive by adopting an old patch.
    For example, command "MOUNT C C:\DIR -T OVERLAY"
    will specify path C:\DIR(\C_DRIVE) as the write
    location after mounting C: drive as a PhysFS drive
    with a command like "MOUNT FILES.ZIP". (Wengier)
  - Added ability to resolve file paths that include
    environment variables on Windows or tildes (~) on
    other platforms for various options in the config
    file, such as language and mapper file paths, MT32
    ROM & FluidSynth soundfont paths, [config] section
    options as well as file outputs for the printing
    and serial/parallel port functions. (Wengier)
  - Added calculator for DOS (EVAL.EXE), which appears
    on Z drive and can calculate both simple (such as
    sin(0) and cos(0)) and many advanced mathematical
    expressions in either command-line mode and or the
    interactive mode. (Wengier)
  - Added support for standard (VGA/EGA/CGA) and mono
    mode dual-screen setup by porting the patch. You
    can now start DOSBox-X with the option -display2
    followed by a color (white, green, amber) to enable
    this feature on debug builds. (Wengier)
  - You can now translate texts in DOSBox-X's drop-down
    menus. The message files as written by the config
    tool (CLI or GUI) will contain the menu texts for
    translations from the English language. (Wengier)
  - Added "file access tries" config option (in [dos]
    section) so that if a positive integer is provided
    (e.g. 1 or 3) DOSBox-X will try to read/write/lock
    files on mounted local drives for the specified
    number of times before failing on Windows builds.
    It is especially useful for networked DOS database
    applications that require record locking. (Wengier)
  - Added "bannercolortheme" config option (in [dosbox]
    section) so that users can change the background
    color theme of the welcome banner from the default
    blue color when DOSBox-X starts. (Wengier)
  - Added "pcaptimeout" config option (in the [ne2000]
    section) to specify a read timeout value for pcap
    in milliseconds, or default value (-1 on Windows
    or 3000 otherwise) will be used. (Wengier & Jookia)
  - Added "Save & Restart" button to the Configuration
    Tool's "Save" option for saving the config file and
    then automatically restarting DOSBox-X with this
    saved configuration. Command-line options -wcboot,
    -wcdboot and -wcpboot are added to CONFIG command
    which resemble -wc, -wcd, and -wcp options but will
    reboot DOSBox-X after writing configfile. Command-
    line option -bc (-bootconf) is also added to reboot
    with specified config file (or the primary loaded
    config file if not specified) directly. (Wengier)
  - The config option ttf.font will now search for TTF
    fonts in the directory as specified by the fontpath
    option in [printer] section too. (Wengier)
  - Added special properties to CONFIG command such as
    "screenwidth", "screenheight", "windowwidth", and
    "windowheight" so that commands like "CONFIG -GET
    screenwidth" and "CONFIG -GET screenheight" will
    get the current screen width and height. (Wengier)
  - BOOT command without a parameter will now try to
    boot the current drive if possible. (Wengier)
  - You can now change properties such as "fullscreen",
    "glshader" and "windowposition" dynamically with
    CONFIG command. For example, command "config -set
    fullscreen=true" and "config -set windowposition="
    will now switch on the full-screen mode and center
    the window position respectively. For TrueType font
    output, you can now also change the TTF font, the
    number of rows and columns on the TTF screen, and
    the word processor for TTF dynamically using CONFIG
    command, e.g. "config -set ttf.font=test", "config
    -set ttf.lins=30", "config -set ttf.cols=100" and
    "config -set ttf.wp=wp". The limits for the options
    ttf.cols and ttf.lins are increased too. (Wengier)
  - Implemented the DOS network redirector functions so
    that the host name can be reported to DOS programs,
    unless the secure mode is enabled. You may need to
    set either the option ipx=true in [ipx] section or
    the option ne2000=true in [ne2000] section. Also
    added config option "network redirector" to [dos]
    section which if set to false disables the network
    redirector even with IPX/NE2000 enabled. (Wengier)
  - Fixed an issue that the DOSBox-X window size may be
    incorrect when restoring from a maximized window in
    the SDL2 builds. (Wengier)
  - Fixed that the menu option "Select OpenGL (GLSL)
    shader.." not working properly sometimes. (Wengier)
  - Fixed Ctrl+C not working in GNU ed. (Wengier)
  - Fixed large ISO images (>2GB) unable to be mounted
    using IMGMOUNT command. (Wengier)
  - Fixed build failure on Gentoo Linux. (fonic)
  - 3dfx games can now work with the Glide passthrough
    feature when a guest system (guest DOS or Windows
    9x) is currently running. The default setting for
    config option "keep private area on boot" in [dos]
    section is changed from "false" to "auto". (Wengier)
  - Improved the speed of the Voodoo hardware emulation
    for running games like Tomb Raider 3dfx. (Wengier)
  - Improved OPL3Duo support, such as adding a buffer
    thread to get rid of slowdowns & breakups in audio
    playback when using the board. (DhrBaksteen)
  - Updated the Tiny File Dialog library to the latest
    version v3.8.5, which fixes issues such as the
    compatibility problem with Windows XP. (Wengier)
  - Updated FLAC, MP3, and WAV CD-DA decoder libraries
    to the latest versions (0.12.28, 0.6.26 and 0.12.18
    respectively; per David Reid). (Wengier)
  - Integrated SVN commits (Allofich & Wengier)
    - r4426: Emulate debug register 6 during trap flag
    emulation (and normal int 1). Fixes 544 (jmarsh)
    - r4401: Improve xchg to handle unwritable memory
    better for core_dyn_x86.
    - r4399: Finish up and add LOOP_NE and LOOP_E for
    core_dyn_x86.
    - r4393: Remove video page check when drawing
    internal mouse pointer, as the BIOS current page
    is not updated in some cases. Fixes QQP games: Lost
    Admiral, Conquered Kingdoms, and Solitaire's
    Journey. Also be a bit smarter about enabling
    autolock, supporting more cases where the mouse
    is used for input without resetting it.
    - r4392: Improve capturing of Zeliard and fix a
    few percussion-related capturing problems as well.
    - r4310: Improve PMAKE on big endian machines and
    fix some bugs. Fixes bug in 16 -> 15 bit color
    conversion.
    - r4309: Copy working directory when mounting an
    overlay.
    - r4307: Refinement of SoundBlaster checks, so no
    IRQ is raised when not in autodma mode.

0.83.9
  - Release notes for this version:
    https://dosbox-x.com/release-0.83.9.html
  - Physical CD drives are now mountable in SDL2 builds
    just like SDL1 builds, so commands like "MOUNT -CD"
    should work in both SDL1 and SDL2 builds. Some code
    is adopted from the SDL2_CDROM library. (Wengier)
  - Implemented file locking support for mounting disk
    image files so that you cannot mount the same disk
    image files in read/write mode at the same time as
    this can cause possible disk corruptions. A config
    option "locking disk image mount" is added to the
    [dosbox] section which when set to false (or if the
    user mounts the image files read-only) will bypass
    the locking of image files. Also improved the DOS
    file locking function, which can be disabled by
    setting "share=false" in [dos] section. (Wengier)
  - Implemented PhysFS support so that you can mount
    archives (e.g. ZIP/7Z) as drives in read-only mode,
    e.g. "MOUNT C TEST.ZIP" or "MOUNT D FILES.7Z". Some
    code is ported from a custom DOSBox fork. The menu
    option "Mount an archive file (ZIP/7Z)" is added to
    Drive menu to mount archives as Drives. (Wengier)
  - INT 13h now obeys the "hard drive data rate limit"
    setting, using the same disk I/O delay code as
    INT 21h file I/O. [Issue #2039]
  - Linux/X11 SDL1 builds: Combine window move/resize
    into one call if possible, and not during window
    manager hints, to avoid resize problems with the
    XFCE 4.14 platform.
  - Added menu option "Create blank disk images..."
    (under "DOS" menu) to create blank floppy or hard
    disk images of a common disk size, including 360KB,
    400KB, 720KB, 1.2MB, 1.44MB and 2.88MB for floppy
    disk images and 250MB, 520MB, 1GB, 2GB, 4GB and 8GB
    for hard disk images. The 1GB option (-t hd_1gig)
    is also added to IMGMAKE command. (Wengier)
  - The Configuration Tool will now be centered within
    the DOSBox-X window for a better looking. (Wengier)
  - Added config option "synchronize time" in [dosbox]
    section which when set to true will allow DOSBox-X
    to automatically synchronize the date and time with
    the host system, unless you manually change date
    and/or time. A menu option "Synchronize host date/
    time" is added to the DOS menu. The function uses
    IRQ0 handler; it will not work in PC-98 mode nor if
    the timer isn't running at the standard 18.2Hz tick
    rate, as any other rate does not make sense and
    will cause only jitter and error. Also fixed two
    Demoscene entries sl_fokus and sl_haloo which use
    BIOS_TIMER with a faster hardware tick rate.
  - Added config option "showdetails" which when set to
    true enables the menu option "Show FPS and RT speed
    in title bar" at start. It is equivalent to -showrt
    and -showcycles command-line options. (Wengier)
  - Improved compatibility with Watcom C++ 2.0 when
    long filename (LFN) support is enabled. (Wengier)
  - Added support for starting DOSBox-X in a specific
    display on a multi-screen setup (Windows builds as
    well as Linux/macOS SDL2 builds). A config option
    "display" is added to the [sdl] section that users
    can specify a display for the DOSBox-X window to
    start. The option can be combined with the existing
    "windowposition" config option to specify the
    position on the specified display/screen. (Wengier)
  - DOSBox-X will now pop up a message box to inform
    the user when a Direct3D pixel shader is loaded
    from the menu on the Windows platform. (Wengier)
  - Extended serial (COM) ports from COM1-COM3 to COM1-
    COM9 in the [serial] section. The config options
    serial4-9 are advanced options. You can optionally
    specify base addresses for any serial ports. When
    the "file" option is used, you can additionally
    specify a program to open the file with "openwith"
    option. If the specified program cannot be executed
    due to some problem, DOSBox-X will try to start a
    program as specified with the "openerror" action,
    or it will show an error. For both serial (COM) and
    parallel (LPT) ports options, the program commands
    can be quoted with double quotes, or with single
    quotes if the "squote" option is added. (Wengier)
  - Extended parallel (LPT) ports from LPT1-LPT3 to
    LPT1-LPT9 in the [parallel] section. Config options
    lpt4-9 are advanced config options. You can also
    optionally specify base addresses and IRQs for
    these ports. The parallel1-9 config options are
    enhanced to allow the generated files to be started
    with the specified action: "openpcl" to start a
    program to open the file if the print output is
    detected to be PCL; "openps" to start a program if
    the print output is detected to be PostScript (PS);
    "openwith" to start a program otherwise. If you'd
    like to specify parameters then be sure to properly
    quote the string(s). Furthermore, if any of the
    specified program(s) cannot be executed, DOSBox-X
    will try to start a program as specified with the
    "openerror" action, or show an error. (Wengier)
  - Added "openwith" and "openerror" config options to
    [printer] section to start the specified program to
    open the printer output file. The [printer] section
    also accepts "fontdir" option where you can change
    the path ("FONTS" by default) where the printer TTF
    fonts (including courier.ttf, ocra.ttf, roman.ttf,
    sansserif.ttf, script.ttf) are located. If no TTF
    font can be found (either from the custom path or
    system path) for printing, the internal TTF font
    for the TTF output will be used. (Wengier)
  - Added read-only options to the Drive menu to mount
    host folders/drives or image files to the specified
    drive letter in read-only mode. (Wengier)
  - You can now use a single mapper file for both SDL1
    and SDL2 versions of DOSBox-X! The new mapper file
    will be divided to sections [SDL1] and [SDL2] for
    both versions. The mapper file can be specified
    with the mapperfile config option, or you can set
    the mapperfile_sdl1 and mapperfile_sdl2 config
    options to override mapperfile option. (Wengier)
  - Added -defaultmapper command-line option which will
    use default key bindings for the mapper. (Wengier)
  - The menu functions "Load mapper file", "Quick edit
    mode", "Stop clipboard pasting" and "Display state
    information" have been added to the key mapper so
    that you can now define your own shortcut keys to
    activate these functions. (Wengier)
  - The default shortcuts for the "Copy to clipboard",
    "Paste from clipboard", and the "Reset window size"
    functions are now Ctrl+F5, Ctrl+F6 and Host(F11/F12)
    +BackSpace respectively. (Wengier)
  - Added ttf.fontbold, ttf.fontital, and ttf.fontboit
    config options so that you can specify actual bold
    italic, and bold-italic TrueType fonts for use with
    the TTF output that will render the bold, italic,
    and bold-italic text styles using the actual TTF
    fonts (e.g. consolab, consolai, consolaz instead of
    consola) instead of making the original TTF font
    bold, italic, bold-italic automatically. (Wengier)
  - DOSBox-X now supports the use of arrow keys (left,
    right, up, down, home, end) to select and copy text
    to the host clipboard in addition to a mouse button
    (subject to the specified key modifier, or use the
    QuickEdit function). The arrow keys will move the
    selections; press Home key to start the actual text
    selection and End key to end text selection and to
    copy to the clipboard; press ESC key to cancel text
    selection. Set config option "clip_mouse_button" to
    "arrows" to enable it, or select it from "Shared
    clipboard functions" menu group. (Wengier)
  - You can now press the key combination Ctrl+Tab in
    the shell to see a list of files/directories that
    can be completed by the Tab completion. (Wengier)
  - Added SETCOLOR command to view or change the text-
    mode color scheme settings. Also fixed the color
    palette for the TTF output. (Wengier)
  - Separated "TTF options" menu group that contains
    TrueType font (TTF) related menu options from the
    "Text-mode" menu group in "Video" menu. (Wengier)
  - The "Show menu bar" option now appears in system
    menu of the Windows SDL2 build too. (Wengier)
  - If a language file fails to load, DOSBox-X will now
    show a warning dialog instead of exiting. (Wengier)
  - The option "clip_key_modifier" now accepts values
    like "ctrlalt", "ctrlshift", "altshift". (Wengier)
  - Fixed 2D texture not showing for 3dfx games in the
    Glide passthrough mode. (Wengier)
  - Fixed the mouse sensitivity menu option (under the
    "DOS" menu) not working. (Wengier)
  - Fixed the color palette problem when switching to
    graphic mode from mono mode. (Wengier)
  - Fixed full-screen TTF output may not fully cover
    the background screen in Linux. (Wengier)
  - Fixed that lines starting with "%" in [autoexec]
    section are being ignored. (Wengier)
  - Fixed issues with building the code with original
    MinGW using the ./build-mingw script. (Wengier)
  - Fixed option "output=ttf" not working properly with
    -startui/startmapper command-line option. (Wengier)
  - When the mouse is captured, the title bar will show
    the shortcut to release the mouse. (Wengier)
  - IMGMOUNT now assumes the ISO type for .GOG/.INS
    files (which are equivalent to .CUE/.INS files)
    if no type is specified by the user. (Wengier)
  - Improved the dynamic core including the way its
    cache is allocated and to support dual mapping.
  - The FREECG98.BMP file (for PC-98 mode) is now
    rendered based on a unifont_jp TTF font instead
    of UnifontFullMediumMono.ttf. (roytam1)
  - Added support for automatic switching from TTF
    output to another output in PC-98 mode, allowing
    Windows 3.1 to run in this mode. (Wengier)
  - Added OPL3Duo support, which passes OPL3 output
    to an OPL3Duo Arduino board with a specific
    configuration if desired. Set the config option
    "oplemu=opl3duoboard" to use it. (josephillips85)
0.83.8
  - Release notes for this version:
    https://dosbox-x.com/release-0.83.8.html
  - Added support for scalable TrueType font (TTF)
    output for text-mode programs. Set "output=ttf"
    and optionally a monospaced TTF font (such as
    consola) with config option "ttf.font" to use it.
    Lines and columns can be specified with config
    options "ttf.lins" and "ttf.cols", and the cursor
    can be made blinking with the option "ttf.blinkc".
    The config options "ttf.ptsize" and "ttf.winperc"
    can be used to set the TTF font size and window
    percentage respectively. If you specify a TTF font
    size with "ttf.ptsize" then "ttf.winperc" will be
    ignored. You can also specify a word processor
    (WP=WordPerfect, WS=WordStar, XY=XyWrite) for the
    on-screen text-style and 512-character font (WP)
    features. When using the TTF output DOSBox-X will
    temporarily switch to a different output when a
    graphical mode is requested (or when trying to take
    a screenshot); the TTF output will be auto-switched
    back later), which can be customized via config
    option "ttf.outputswitch" (which defaults to auto).
    Menu items in the "Text-mode" menu group (under
    "Video" menu) have been expanded to support TTF
    options such as increasing/decreasing the TTF font
    sizes and on-screen text style toggling (including
    bold, italics, underline and strikeout). You can
    also select a TTF font to use at run-time with the
    "Select TrueType font (TTF)" menu option. (Wengier)
  - Added the "Load mapper file..." menu option (under
    "Main") to select and load a DOSBox-X mapper file
    at run-time. Be sure to select a SDL1 mapper file
    for SDL1 builds, and similar for SDL2. (Wengier)
  - You can now select a host key from the menu (under
    "Main") including Ctrl+Alt, Ctrl+Shift, Alt+Shift,
    or use the mapper-defined host key as in previous
    versions (which default to F11 on Windows and F12
    otherwise). A config option "hostkey" is added so
    that you can specify it from config file. (Wengier)
  - Pasting text from the clipboard on macOS SDL1 build
    is now supported like Linux SDL1 build. (Wengier)
  - Added support for ARM-based Apple M1 MacBook. The
    dynamic core now works on ARM-based macOS systems.
    SDL1 builds updated to use newer audio APIs on the
    macOS platform so that the audio works once again
    when compiled and run on macOS 11 (Big Sur). Prior
    to the change, ancient versions of the API dating
    back to the mid 2000s were used which no longer
    work on Big Sur.
  - DOSBox-X will now look for the config file (i.e.
    dosbox-x.conf/dosbox.conf) and the mapper file in
    the directory containing the DOSBox-X executable
    too if the config or mapper file cannot be found
    in the DOSBox-X working directory. (Wengier)
  - The system menu in Windows SDL1 builds is now also
    available for Windows SDL2 builds, and menu items
    "Reset font size", "Increase TTF font size" and
    "Decrease TTF font size" are added. (Wengier)
  - Enhanced the mapper editor interface to allow more
    keyboard shortcuts to be added, shown in multiple
    pages in the mapper, navigable with the "Previous
    Page" and "Next Page" buttons. The text in the
    grids are now longer and clearer too. The default
    shortcuts for a few items are changed to use the
    Host key style (e.g. Host+S and Host+L for saving
    and loading states respectively). (Wengier)
  - Added menu item "List network interfaces" under
    "Help" menu to list network interfaces in the host
    system for the NE2000 feature. (Wengier)
  - Added menu group "DOS commands" under "Help" menu
    to display the help content for the selected DOS
    shell command (DIR, CD, etc). (Wengier)
  - Configuration Tool now provides the option to save
    to the primary or user config files. (Wengier)
  - Certain config options (e.g. doublescan) that were
    marked as advanced options are now general config
    options and will appear in dosbox-x.reference.conf
    apart from dosbox-x.reference.full.conf. (Wengier)
  - Added config options "saveremark" (default: true)
    and "forceloadstate" (default: false) in [dosbox]
    section which can be used to control if DOSBox-X
    should ask users to enter remarks when saving a
    state or show warnings when loading a saved state
    if there is a mismatch found. (Wengier)
  - The config option "pixelshader" is moved from the
    section [gui] to [render] so that it will be in the
    same section as the option "glshader". (Wengier)
  - Added menu item "Select OpenGL (GLSL) shader..." to
    allow OpenGL shader switch from the menu, just like
    the function for Direct3D pixel shaders. (Wengier)
  - Added menu item "Show IDE disk or CD status" under
    "DOS" menu to show the current assignments (disk or
    CD image) of the IDE controllers. (Wengier)
  - Fixed IDE CD assignment may not be reset when soft
    reboots are activated from guest systems. (Wengier)
  - The program 80x43.COM is added into the ZIP package
    TEXTUTIL.ZIP on the Z drive. You can also change
    current text screen to the 80x43 mode from the menu
    group "Text-mode" under "Video" menu. (Wengier)
  - Enhanced MODE command so that you can change the
    number of columns and lines in the screen with the
    syntax "MODE CON COLS=c LINES=n" (c=80 or 132, and
    n=25, 43, 50, or 60). The command "MODE CON" will
    show the current number of columns and lines in the
    screen as in a real DOS system. (Wengier)
  - Added FLAGSAVE command for the save state feature
    to flag (mark) one or more files to be saved and
    loaded. Type "FLAGSAVE /?" for more information on
    this command. (PogoMan361 and Wengier)
  - Enhanced A20GATE command to show the current status
    of the A20 gate when no parameter is given, along
    with other small improvements. (Wengier)
  - INT 21h DOS=HMA emulation, to enable the A20 gate,
    and autoa20fix, to disable the A20 gate, now checks
    whether the CPU is running in virtual 8086 mode.
    If vm86 detected, the code will control the A20
    gate by calling the XMS interface instead of direct
    reading/writing via port 92h. This consideration
    is required for autoa20fix to cooperate with
    Microsoft Windows 3.1. Note that Windows 3.1 does
    not virtualize port 92h. If it did, this workaround
    would not be necessary.
  - Added -a option to LOADFIX command which will auto
    allocate enough memory to fill lowest 64KB memory
    instead of using exactly 64KB memory. (Wengier)
  - Added autofixwarning option (true by default) which
    allows user to silence the messages when DOSBox-X
    tries to auto-fix "Packed file is corrupt" error
    when running a program with this issue. (Wengier)
  - Added autoa20fix option (enabled by default). This
    option when enabled attempts to resolve EXEPACK
    "Packed file is corrupt" errors by temporarily
    disabling the A20 gate and running the program
    again. This may provide better support for affected
    DOS applications than the LOADFIX option. If both
    autoa20fix and autoloadfix are set, then autoa20fix
    will be tried first, and if it did not work then
    autoloadfix will be tried next.
  - The autoloadfix config option changed to allocate
    only enough memory to keep the executable above the
    64KB boundary, instead of blindly allocating 64KB.
  - Fixed menu items "Rescan drive" and "Swap disk" in
    "Drive" menu being reversed. (Wengier)
  - Fixed CD audio issue with the game "The Secret of
    Monkey Island" when talking to the pirate in Scumm
    Bar by adapting the patch that fixes it. Thanks
    kcgen for the fix logic. (Wengier)
  - Added support for MAME CHD CD images. You can now
    mount CHD images with IMGMOUNT command, or from the
    Drive menu. Based on libchdr library and the work
    of the user whocares010. (Wengier)
  - Updated FLAC/MP3/WAV CD-DA decoder libraries to the
    latest versions (versions 0.12.22, 0.6.19, 0.12.14
    respectively). Thanks to mackron & kcgen. (Wengier)
0.83.7
  - Release notes for this version:
    https://dosbox-x.com/release-0.83.7.html
  - The primary DOSBox-X Wiki is now located at the
    URL: https://dosbox-x.com/wiki (Wengier)
  - Implemented the x86 dynamic core for both 32-bit
    and 64-bit systems by re-porting the code from SVN.
    Dynamic core now supports either the dynamic_x86
    or the dynamic_rec core. The dynamic_x86 core will
    be used by default for x86 and x86_64 platforms and
    if "core=dynamic" is set, and Windows 9x can be run
    in this dynamic core (although at this time may
    encounter some issue with the S3 driver). You can
    also explicit specify setting "core=dynamic_x86" or
    "core=dynamic_rec" for either the dynamic_x86 core
    or the dynamic_rec core. Also thank joncampbell123
    for the 64-bit fix. (Wengier)
  - You can now use your own save file (in addition to
    save slots! There are now a "Use save file" toggle
    item and "Browse save file..." for browsing save
    files on your computer. A config option "savefile"
    (in [dosbox] section) is added to specify a save
    file to use at start. (Wengier)
  - Save state feature now allows users to optionally
    enter remarks when saving a state. A submenu group
    "Save/load option" is added (under "Capture") where
    you can toggle menu items "No remark when saving
    state" (for disabling input of remarks when saving)
    and "force load state mode". A menu item "Display
    state information" is added as well to display the
    information of the saved state. (Wengier)
  - DOSBox-X will now use native dialog box to display
    quit warnings and save state errors. (Wengier)
  - Changed some DOS error messages (such as "Illegal
    command" which now reads "Bad command or filename")
    similar to real DOS systems. (Wengier)
  - ADDKEY and INT2FDBG commands now appear as programs
    on Z: drive instead of shell commands. (Wengier)
  - Improved the -z (move virtual drive Z:) function of
    MOUNT command. You can move the virtual drive as
    many times as you want, and save/load states will
    work even after you move the Z: drive. (Wengier)
  - Enhanced the config option "freesizecap" to allow
    the setting "fixed" which is the same as "false",
    and a new setting "relative" is added, which will
    be similar to the setting "fixed" but the reported
    free disk size will also change relative to the
    change of the free disk size ever since. (Wengier)
  - Added support for Opus CD-DA tracks by porting and
    cleaning up the source code from other projects.
    Many thanks to Marty Shepard and kcgen. (Wengier)
  - Support for FluidSynth MIDI Synthesizer is now
    included in the MinGW builds by default just like
    Visual Studio builds. Set "mididevice=fluidsynth"
    and a soundfont file to use it. (Wengier)
  - Enabled xBRZ scaler for Visual Studio SDL2 builds
    just like Visual Studio SDL1 builds. (Wengier)
  - Added menu item "Show Sound Blaster configuration"
    under "Sound" menu to show the current information
    about Sound Blaster, and also menu item "Show MIDI
    device configuration" (also under "Sound" menu)
    to show information about the current MIDI device
    such as the soundfont file in use. (Wengier)
  - Added "Mount multiple disk/CD images" option to the
    mounting options of the Drive menu to allow users
    to mount more than one disk/CD images to a drive,
    swappable from the menu. Also added separators to
    the Drive submenu to make it look better. (Wengier)
  - Added new CPU types to the "Emulate CPU speed" menu
    group namely 286-25MHz, 386DX-25MHz, 486DX4-100MHz,
    486DX5-133MHz, Pentium-60MHz, Pentium-75MHz, and
    Pentium-90MHz. Thanks again for the data provided
    by the user maximus105. (Wengier)
  - You can now select a special key (e.g. Alt+Tab,
    Ctrl+Break, Ctrl+Alt+Del, etc) to be sent from the
    key defined in the mapper editor. The key can be
    selected (Ctrl+Alt+Del by default) from the "Send
    special key" menu group in "Main" menu. (Wengier)
  - Added full Ctrl+Break emulation at the BIOS and
    DOS level, updated console emulation to match.
    The "Pause" mapper shortcut is now moved to
    HOST[F11/F12]+Pause instead of Ctrl+Pause so that
    Ctrl+Break can work properly for users, and the
    function to send the Ctrl+Break key from the menu
    ("Send special key" under "Main") is added. Also,
    the PC-98 STOP key now functions the same as the
    Ctrl+C and Ctrl+Break keys in IBM PC mode.
  - Added functions "CopyToClipboard" and "QuickRun" to
    the mapper editor so that you can use shortcuts to
    activate them (default shortcuts: HOST(F11/F12)+A
    and HOST(F11/F12)+Q respectively), and a default
    shortcut HOST(F11/F12)+V is added to the clipboard
    paste function. Meanwhile, FullCore and SimpleCore
    shortcuts are removed from the mapper. (Wengier)
  - Added two new menu items in the "Shared clipboard
    functions" menu group under "Main", including "Copy
    all text on the DOS screen" which will copy all
    screen text to the clipboard, and "Stop clipboard
    pasting" which allows user to stop pasting in the
    middle of pasting long clipboard content. (Wengier)
  - The mouse copy/paste feature is now available for
    non-Windows systems on SDL2 builds. Also, pasting
    from the clipboard with a mapped shortcut is also
    available for Linux/X11 on SDL1 builds. (Wengier)
  - Added "Use US keyboard layout" toggle menu item in
    the "PC-98" menu group under "Video" to select
    whether to force the default US keyboard layout in
    PC-98 mode, same as the "pc-98 force ibm keyboard
    layout" config option in [pc98] section. Also moved
    the "PC-98 PIT master clock" options from the "DOS"
    menu to this menu group. (Wengier)
  - The full dosbox-x.reference.conf file is renamed to
    dosbox-x.reference.full.conf. The original file
    dosbox-x.reference.conf now contains common config
    options instead of all config options. (Wengier)
  - The CONFIG command and Configuration Tool will now
    save common and modified config options by default.
    The -all command-line option (or "Save all options
    to the configuration file" checkbox) will force to
    save all config options. A new -mod command-line
    option is added to CONFIG command to save modified
    config options only, and a new -norem command-line
    option is added to not write remarks. (Wengier)
  - Updated the Windows installer to default to the
    "typical" installation. For the full installation
    start menu items will be added for DOSBox-X builds
    copied to subdirectories. A new checkbox "Write
    common config options (instead of all) to the
    configuration file" is added which when checked
    will only write common and modified advanced config
    options to the config file. Furthermore, for both
    "typical" and "full" installations the Windows
    installer will now also copies the DLL files
    inpout32.dll (32-bit) and inpoutx64.dll (64-bit) to
    the DOSBox-X install directory for use with the
    direct parallel port passthrough feature. (Wengier)
  - Improved Flatpak support for Linux. (rderooy)
  - Improved message for the -help command-line option,
    adding for example -silent and -socket command-line
    options in the help messages. (Wengier)
  - Added -silent command-line option to run DOSBox-X
    silently (without showing the DOSBox-X window) and
    then exit after executing AUTOEXEC.BAT. (Wengier)
  - Fixed command-line option -socket not working for
    the null-modem feature. (Wengier)
  - Fixed issue that aspect ratio not being respected
    in full-screen mode when a GLSL shader is enabled
    with an OpenGL output. (Wengier)
  - Fixed toggle in the "Frameskip" menu group did not
    change when selecting a different option. (Wengier)
  - Fixed shelling from programs may not work when the
    shell config option is set. (Wengier)
  - The default country setting ("country" option in
    [config] section]) now defaults to auto-detection
    if possible, or 81 (Japan) in PC-98 mode. (Wengier)
  - Increased the default maximum DOS files (adjustable
    from [config] section) from 127 to 200. (Wengier)
  - Improved resetting with LOADLIN program. (Wengier)
  - Improved Gravis Ultrasound (GUS) implementation to
    make it more accurately represent the GUS DMA state
    as expected by the running DOS software.
  - The archive attribute will no longer automatically
    be applied to directories on non-Windows systems.
    This fixed issue with PLAYMIDI.EXE from Gravis
    Ultrasound when listing directories. (Wengier)
  - Applied hack to allow the low DMA channel detection
    in the SB16 DIAGNOSE program to work. (Wengier)
  - The default setting of the clip_paste_speed option
    has been changed from 20 to 30, which will help
    prevent lost keystrokes when pasting from the host
    clipboard for some programs. (Wengier)
  - With Pentium CPU setting (cputype=pentium) DOSBox-X
    no longer reports FDIV bug by default. An advanced
    config option "report fdiv bug" is added to report
    such CPU bug when set to true. (rderooy & Wengier)
  - Added support for the XDG_DATA_HOME environment
    variable for config directory in Linux. (rderooy)
  - Added support for compiling with pcap for Windows
    MinGW builds. (Jookia)
  - Added config option "windowposition" (in [sdl]
    section) to set the window position at startup in
    the positionX,positionY format. (tomba4)
  - Added config option "raw_mouse_input" (in [sdl]
    section; SDL2 builds only) to bypass the operating
    system's mouse acceleration & sensitivity settings.
    Implemented by NicknineTheEagle.
  - Added config option "startquiet" (in [dos] section)
    which when set to true will silence the information
    messages before launching Windows programs to run
    on the Windows host. A toggle menu item "Quiet mode
    (no start messages)" is added to the "Windows host
    applications" menu group in "DOS" menu. (Wengier)
  - The menu "Show details" (under "Main") is renamed
    to "Show FPS and RT speed in title bar". (Wengier)
  - Add menu group "Text-mode" under "Video" menu to
    change some text-mode related video settings, such
    as changing the number of rows and columns. A zip
    package named TEXTUTIL.ZIP is added to the Z drive
    that contains various utilities (such as CGA.COM,
    EGA.COM, 132X25.COM, 132X43.COM) to change current
    video setting from the command line. Also added a
    config option "high intensity blinking" which when
    set will display high intensity background colors
    instead of blinking foreground text. The menu item
    "Allow 9-pixel wide fonts" is moved from the menu
    group "Compatibility" to here. (Wengier)
  - Added "Debugging" menu group under "Help" menu, and
    moved items from the "Video" Debug and "DOS" Debug
    menus and the debugger here (debug builds only).
    Also allowed to hide/show the console or debugger
    window in Windows debug builds. With the menu item
    "Console wait on error" checked the Windows console
    window will wait for the ENTER key before closing
    itself after an E_EXIT occurs. (Wengier)
  - Updated MPXPLAY to latest version 1.65. (Wengier)
  - Integrated SVN commits (Allofich)
    - r4386: Correct MPU-401 clock-to-host function to
    operate independently of playing. Fixes hang at
    exit when playing Roland music in demos by The
    Phoney Coders. Clamp tempo to valid range.
    - r4384: ICW1 on the PIC clears the Interrupt Mask
    Register. Fixes Antagony and quite a few demos that
    expect IRQs to be unmasked.
    - r4382: Refine adlib timers a bit more and make
    reading the Adlib take a bit more time.
    - r4378: Prevent some possible deadlocks with sti
    in dynrec core.
    - r4375: Improve compatibility with older Intel
    chipsets
    - r4374: Add a bit of hack so cycles=max/auto 90%
    keeps on working inside batch files after r3925.
    - r4371: Fix regression in Clue: Master Detective.
    - r4370: As an adjunct to r4369, make the reference
      counts of standard device handles equivalent to
      those of real DOS.
    - r4369: Compatible side-effect behavior of DOS in
      the file close function.
    - r4368: Improve error codes for some DOS file functions.
    - r4367: Change FPU_FBST to only write 18 decimals
      instead of the wrongly 19, this makes it possible
      to switch 64 integers which in turn fixes some
      rounding issues. (jmarsh)
    - r4282,r4283: Switch to a different way to calculate
      DBOPL table offsets.
    - r4280: Prevent GenerateDMASound from running with
      input of 0.
    - r4279: Remove DMA_TRANSFEREND and replace with
      DMA_MASKED.
    - r4277: Remove cases not needed after r4276
    - r4276: Remove defunct code related to the initial
      display mode of the system BIOS during video mode
      changes.
    - r4274: fix externals.
    - r4273: Make frameskip an integer.
    - r4269: Use fabsf when return value is a float.
      Small warning fix.
    - r4265: Some more cleanups and memleak fixes.
    - r4264: Pick some lowhanging fruit. (some memory
      leaks and unused variables)
    - r4262: missed one
    - r4261: These actually use float as input.
    - r4258: Rename bios tester to biostest and make it
      debug only to avoid people trying to load real
      bioses.
    - r4257: Add simple program that allows you to boot
      into a bios image for running cpu tester bios.
0.83.6
  - Release notes for this version:
    https://dosbox-x.com/release-0.83.6.html
  - Improved internal Voodoo card hardware emulation,
    such as fixing the font issue with the 3dfx version
    of Tomb Raider when using non-Glide mode. Portions
    of the code are ported from DOSBox ECE. (Wengier)
  - Added OpenGL shader support by porting the feature
    from DOSBox SVN. GLSL shaders are now supported in
    both SDL1 and SDL2 builds, and this also allows
    pixel-perfect scaling to be enabled for the OpenGL
    outputs. The config option "glshader" (in [render]
    section) can be used to specify a GLSL shader file
    or a built-in shader when the output is set to
    "opengl" or "openglnb". For example, you can use
    the setting "glshader=sharp" (built-in shader) or
    "glshader=pixel_perfect" (with GLSL shader file)
    for the pixel-perfect scaling mode. The Windows
    installer will also copy several GLSL shader files
    to the "glshaders" subdirectory of the DOSBox-X
    install directory to be used directly. (Wengier)
  - Support for FluidSynth MIDI Synthesizer is now
    included in the Windows Visual Studio builds by
    default. Set "mididevice=fluidsynth" and a sound
    font (e.g. GeneralUser_GS.sf2) to use it. (Wengier)
  - Updated the MUNT MT32 emulation library to its
    latest version 2.4.0. A few new MT32 config options
    (starting with "mt32.") are added to [midi] section
    of the DOSBox-X configuration. (Wengier)
  - The DOSMID and MPXPLAY programs have been built
    into DOSBox-X, both can be found on the Z drive and
    feature full-screen user interfaces with support
    for command-line usages (use /? option for help).
    DOSMID can play MIDI/RMI/MUS audio files, whereas
    MPXPLAY is a powerful and flexible audio player
    with support for a variety of formats including
    AAC/AC3/APE/FLAC/MP2/MP3/MPC/OGG/WAV and more with
    playlist support. (Wengier)
  - The mounting options "Mount as Hard Disk", "Mount
    as CD-ROM", "Mount as Floppy", "Mount disk image"
    and "Boot from disk image" (previously only for
    Windows) in the "Drive" menu and the "Quick launch
    program..." in the "DOS" menu are now available
    for non-Windows platforms as well. (Wengier)
  - Added "Shared Windows clipboard functions" menu
    group under "Main", which allows you to enable
    or disable the different ways for DOSBox-X to
    communicate with the Windows clipboard. (Wengier)
  - Added config option "dos clipboard api" in [dos]
    section to control whether to enable the DOS APIs
    for communications with the Windows clipboard for
    DOS applications. (Wengier)
  - Added config option "clip_mouse_button" to select
    a mouse button (middle, right, or none; with right
    mouse button being the default) for copying to and
    pasting from the Windows clipboard. (Wengier)
  - The mouse wheel movements will be automatically
    converted into up/down arrows by default for the
    integrated DOS now. You can also enable it for
    the guest system from the "Main" menu ("mouse wheel
    movements" -> "Enable for guest systems also") or
    from the config file. (Wengier)
  - Added "Emulate CPU speed" menu group (under "CPU")
    to emulate the speed of a specific CPU class. The
    cycles to emulate are approximations of the actual
    CPU hardware, and they are available thanks to data
    provided by the user maximus105. Also added config
    option "cycle emulation percentage adjust" in [cpu]
    section for users who would like to make relative
    percentage adjustments (between -25% and 25%) in
    case it is necessary. (Wengier)
  - Added SORT command from FreeDOS. It can be used to
    sort input, e.g. "TYPE FILE.TXT | SORT". (Wengier)
  - Added DELTREE command to delete a directory and all
    the subdirectories and files in it as in a real DOS
    system. Please use it with caution. (Wengier)
  - The command for starting the Configuration Tool has
    been renamed from "SHOWGUI" to "CFGTOOL". A new
    command-line option -gui is added to CONFIG command
    to start the Configuration Tool as well. (Wengier)
  - DOSBox-X now includes ZIP.EXE and UNZIP.EXE from
    InfoZip for zipping and unzipping files in DOS.
    Both programs will appear on the Z drive. (Wengier)
  - The powerful DOS CD player called SJGPLAY has been
    built into DOSBox-X. You can now find the program
    CDPLAY.EXE in the Z drive for playing Audio CDs in
    DOS, which supports both graphical and command-line
    usage, and you will also find a text file named
    CDPLAY.TXT in the Z drive for a quick usage guide.
    A zip package including full documentation and some
    extras will additionally appear as SJGPLAY.ZIP in
    the Z drive. This freeware program was written by
    Steve Gray and is now included in DOSBox-X with
    explicit permission of the author. (Wengier)
  - DOSBox-X will now by default show a quit warning
    if a DOS program or game, or a guest system is
    running. The previous behavior can be set with
    "quit warning=autofile". (Wengier)
  - The welcome banner when DOSBox-X starts has been
    improved for a better looking and should provide
    more helpful instructions for users. (Wengier)
  - Add new "Help" menu which includes menu items
    "Introduction", "DOSBox-X homepage", "DOSBox-X Wiki
    guide", "DOSBox-X support" and "About". (Wengier)
  - Improved the message when automatically re-running
    the executable which failed with the "Packed file
    is corrupt" error. Also added the "autoloadfix"
    config option which when set to "false" will not
    automatically re-run such programs. (Wengier)
  - The display for several section names in DOSBox-X's
    graphical configuration tool has been capitalized
    or modified otherwise to look better. A default
    shortcut key HOST(F11/F12)+C is added for starting
    the graphical configuration tool. (Wengier)
  - Added the "Show advanced options" checkbox in the
    main screen of the Configuration GUI to toggle
    whether to display all config options for the
    sections. If unchecked (default), it will show
    common config options instead of all of them. A
    new config option "show advanced options" is added
    which when set to "true" will make the checkbox
    checked by default. (Wengier)
  - Added code to cap the scan line length given to
    the VESA BIOS given the video mode. This prevents
    VBETEST.EXE from doing test patterns smaller than
    the actual display, which can happen with 32bpp
    320x200 modes and 1MB or less video RAM.
  - VESA BIOS Set Scan Line Length fixed to properly
    report and handle scan line length for 16-color
    SVGA planar modes. VBETEST 16-color modes now
    display correctly.
  - Added option to control whether VESA BIOS panning
    (the original VBE call) waits for vsync.
  - Moved video related config options from [dosbox]
    section to its own [video] section. These options
    in existing config files will be automatically
    redirected to the [video] section from the [dosbox]
    section when DOSBox-X starts. Windows installer can
    also move such config options from existing config
    files automatically. (Wengier)
  - Cleared modem phone book before parsing it. Thank
    NicknineTheEagle for the improvement.
  - Improved the help message of MOUNT command. Also
    added option -examples to show its usage examples,
    similar to IMGMOUNT and IMGMAKE commands. (Wengier)
  - Fixed freeze when trying to reboot the internal
    DOS when using a different code page and it is in
    CGA or EGA emulation modes. (Wengier)
  - DOSBox-X will now try to use the internal DOS date
    and time (instead of always using the host date and
    date) for file modification timestamps. (Wengier)
  - Added menu item "Expanded memory (EMS)" under "DOS"
    menu to dynamically enable or disable EMS memory
    at run-time. You can now also modify EMS memory
    with CONFIG command from command-line. (Wengier)
  - Added config option "drive z hide files" (in [dos]
    section) to hide or remove files listed (separated
    by spaces) from the Z drive. If a file has a "/"
    prefix (e.g. "/INTRO.COM"), then the specified file
    will have the hidden attribute ("DIR /A" will list
    all such files) instead of completely disappearing
    from the Z drive. (Wengier)
  - You can now add your own programs or files to the
    Z drive! Put your programs or files in the drivez
    directory located in the DOSBox-X program folder
    or the DOSBox-X configuration directory, and they
    will automatically appear on the Z drive. If any of
    the files have the same names as the built-in ones,
    they will replace the built-in files. For example,
    you can replace the built-in EDIT.COM and XCOPY.EXE
    programs (from FreeDOS) with MS-DOS counterparts.
    Windows installer will now automatically create a
    drivez directory with a README.TXT file in it too.
    For subdirectories support please use MOUNT command
    to mount local directory instead. (Wengier).
0.83.5
  - Release notes for this version:
    https://dosbox-x.com/release-0.83.5.html
  - Windows installer now offers the option to upgrade
    the DOSBox-X config file (dosbox-x.conf) to the
    latest version format automatically while keeping
    users' current settings. It can also add a context
    menu for executables (.exe, .com, .bat), config
    files (.conf) and folders in the Windows Explorer
    so that you could quickly run or open them with
    DOSBox-X from the Windows Explorer. More icons
    are added to the DOSBox-X program group within the
    Start menu as well. (Wengier)
  - Added config option "startbanner" in [dosbox]
    section which if set to "false" would skip the
    welcome banner when DOSBox-X starts. Also added
    config option "fastbioslogo" which if set to "true"
    will skip the BIOS logo (replacing the command-line
    option -fastbootlogo). A new command-line option
    "-fastlaunch" is added to enable fast launch mode
    by skipping both the logo and the banner. (Wengier)
  - Added config option "ega per scanline hpel" in
    [dosbox] section to control whether EGA emulation
    latches hpel at display start (as VGA emulation
    does) or allows hpel to change per scanline.
    Setting the option to false is needed for some
    games like Commander Keen.
  - Support for mounting CD images with a sector size
    of 2448, used by for example the MDF image of the
    game Grand Theft Auto. (Wengier)
  - Allowed Sound Blaster to be enabled by the games
    "Desert Strike" and "Jungle Strike". (Wengier)
  - Sound Blaster Pro emulation now maps DSP commands
    0x41 to 0x47 as aliases of 0x40 (set time constant)
    to support broken demoscene code that uses 0x41
    in that way. Yes, such code would obviously break
    on clone cards and the SB16. Added a config option
    "dsp command aliases" in [sblaster] section to turn
    it off for debugging. Alias is documented on Vogons
    forums where someone made a SB Pro clone card.
  - Fixed the issue with CD audio play by porting the
    audio code from DOSBox ECE. (Wengier)
  - COPY command now assumes /Y automatically when
    running in the batch file or with CALL command
    (or COMMAND /C) as in real DOS. (Wengier)
  - DOSBox-X will allow control characters 8 (BS),
    9 (TAB), 26 (SUB), and 27 (ESC) when executing GOTO
    command in batch files without warnings. (Wengier)
  - Normal core: REP MOVSD now checks segment limits
    for ES:(E)DI and throws a GP fault if exceeded.
    Demoscene productions marked as using VESA BIOS
    modes and scribbling on the VGA BIOS are relying
    on segment limits and GP faults to fake a linear
    framebuffer.
  - Added config option "vesa bank switching window
    range check" to allow disabling the VESA BIOS
    window number range check when called on to
    bank switch. Needed for "Pill" by Opiate in the
    end credits, which for some reason requires a
    call for window number 0xFFFF to succeed in order
    to draw credits without glitching.
  - Added config option "vesa bank switching window
    mirroring" for instructing VESA BIOS to ignore
    bank switching window parameter when asked to
    get/set bank switching window setting. Needed for
    some old demoscene and game applications that
    assume Window B is available, and will not render
    SVGA properly without it.
  - Added config option "quit warning" to indicate if
    DOSBox-X should warn show a warning message when
    you try to close the DOSBox-X window. If set to
    "auto" (default), DOSBox-X will warn only if at
    least one file handle is still open, or you are
    currently running a guest system. (Wengier)
  - Added command-line option "-defaultconf" to use the
    default config settings. (Wengier)
  - Added command-line option "-defaultdir" to specify
    a directory (instead of the current directory) as
    the working directory. DOSBox-X will look for the
    dosbox-x.conf file in this directory. (Wengier)
  - The -winrun command-line option will also enable
    LFN support with "lfn=auto" on Windows. (Wengier)
  - VER /R now shows DOSBox-X's Git commit SHA1, in
    addition to the build date and other version
    information shown by the VER command. (Wengier)
  - Fixed that joystick may not work with the setting
    "usescancodes=auto" when a non-US keyboard layout
    is activated on the SDL1 build. (Wengier)
  - DOSBox-X will now search for system fonts if the
    fonts required for the printing feature cannot be
    found in the FONTS directory. (Wengier)
  - Added menu item "Send form-feed" under the DOS menu
    for manually ejecting new pages to print. (Wengier)
  - Added "Quick launch program..." menu (under "DOS")
    to quickly run the specified program as selected
    by the Windows file browser in DOSBox-X. (Wengier)
  - Added "Drive information" menu item under "Drive"
    menu to show information for the specified drive,
    and added "Show mounted drive numbers" menu item
    under "DOS" menu to show details for all mounted
    drive numbers (0-5). (Wengier)
  - The command "Swap CD" now swaps only CD drives (as
    the name), not all non-floppy drives. Also added
    "Swap disk" menu item under the "Drive" menu for
    swapping individual mounted drives. (Wengier)
  - IMGMAKE now tries to resolve home directory (~)
    on Linux and macOS platforms. Also improved the
    help message for this command. (Wengier)
  - Fixed unmounting swap disks when unmounting drives
    with MOUNT or IMGMOUNT command. (Wengier)
  - Fixed possible failure when mounting .VHD images,
    and the issue that leading colon (:) or read-only
    marker may not work for such images. (Wengier)
  - IMGMOUNT command without parameters now shows the
    disk position and number of swap disks, as well as
    IDE controller (if applicable). Also added option
    -examples to show its usage examples. (Wengier)
  - Add "-ro" option for IMGMOUNT command to mark all
    disk images as read-only at once. You could also
    mark read-only disk images individually using the
    leading colon as in previous versions. (Wengier)
  - The default value for "output" (in "sdl" section)
    is now "default", which will default to the value
    according to your platform. (Wengier)
  - The -Q (quiet) option of MOUNT, BOOT and RESCAN
    commands now silences virtually all outputs (error
    and normal messages) of these commands. (Wengier)
  - Worked around the mounting issue with LaunchBox,
    by allowing a mounting command-line with single
    quotes like MOUNT C 'X:\DOS' on Windows. (Wengier)
  - Unmounting ISO drives will auto-unmount associated
    El Torito floppy drives (if any) too. (Wengier)
  - Updated xxHash library by Yann Collet from 0.7.4
    to the stable version 0.8.0. (Wengier)
  - Added support for the OPL2 audio board by setting
    the config option "oplemu=opl2board".
  - The save state feature now tries to save and then
    restore the mounted drives of all types (if the
    paths or image files still exist on host system).
    This fixes the "save state corrupted" error while
    trying to load saved states but the drives are not
    yet mounted in DOSBox-X. (Wengier)
  - The save state feature now verifies the emulated
    machine type (VGA, PC98, etc) too when loading a
    saved state. All confirm and error dialog boxes
    for saving or loading states appear in a cross-
    platform manner now, instead of only on Windows
    systems. Also added the option to remove the saved
    state in the selected save slot. (Wengier)
  - Increased the number of save slots from 10 to 100.
    Each page in the save slot menu (under "Capture")
    still shows 10 slots as before, but you can now go
    to the previous or next page (up to 10 pages) for
    more save slots (100 in total). (Wengier).
  - The [pci] section is now the [voodoo] section, and
    the config option "voodoo" (the only option of that
    section) is now named "voodoo_card" within the
    [voodoo] section to make clear it is for emulating
    the Voodoo card hardware. Also added config option
    "voodoo_maxmem" (default: true) to specify whether
    to use the maximum memory size (12MB instead of the
    standard 4MB) for the Vooodoo card. (Wengier)
  - Added support for Glide wrapper. It can be enabled
    with the new config option "glide" set to "true"
    in [voodoo] section. The library file glide2x.dll
    (Windows)/libglide2x.so (Linux)/libglide2x.dylib
    (macOS) is required for Glide to work. Be sure to
    use 32-bit dll for 32-bit DOSBox-X binary, and
    64-bit dll for 64-bit DOSBox-X binary. (Wengier)
0.83.4
  - Fixed loading saved states in fullscreen mode with
    the "aspect=true" setting. (Wengier)
  - Added config option "saveslot" to select default
    save slot (1-10). The timestamps for the saved
    states will also be shown in the menu. (Wengier)
  - Added key mapper for sending the Ctrl+Alt+Del key,
    with HOST(F11/F12)+Del by default. (Wengier)
  - Added dosbox-x.conf setting to ignore the EGA/VGA
    "extended memory" bit. It was originally defined
    back when stock EGA/VGA cards could ship with 64KB
    of memory. The option is needed for DOS games that
    accidentally clear the bit when using unchained
    256-color modes (Mr. Blobby).
  - Added new default value "auto" for the setting
    "usescancodesauto" (in [sdl] section of the config
    file) to work around issues with non-US keyboard
    layouts on SDL1 builds. (Wengier)
  - Added code pages 808, 850, 852, 853, 855, 857,
    858, 869, 872 for host to guest codepage mapping
    on mounted local or overlay drives. (Wengier)
  - The mapper options "Increase recording volume" and
    "Decrease recording volume" as well as function
    "Show sound levels" (from MIXER command) appear
    now as menu items (under "Sound") too. (Wengier)
  - Fixed inputting of ASCII character 224 and 240
    in Windows SDL2 or MinGW builds. (Wengier)
  - Fixed possible DPMI error when running Windows
    98 installation from the DOSBox-X shell without
    using a batch file. (Wengier)
  - Fixed a bug in the FAT driver that can cause
    a byte to get lost if writing up to the end of
    a cluster, which seems to be behind the
    corruption with program group files when running
    Windows for Workgroups 3.11 from DOSBox-X shell.
    [https://github.com/joncampbell123/dosbox-x/issues/1758#issuecomment-665193066]
  - Unknown INT 2Fh calls are now debug output, not
    an error.
  - Added VESA BIOS mode 68h alias as indicated on
    the Vogons forum.
  - Fixed handling of config commands with spaces
    when the "shell configuration as commands"
    setting is enabled (quotes are needed in such
    cases). Also added "Config options as commands"
    toggle menu (under "DOS") to enable/disable the
    feature from menu. It is disabled by default to
    avoid name clash with other programs. (Wengier)
  - Added "Enable quick reboot" toggle menu (under
    "DOS") so that when enabled, DOS restart calls
    will reboot the emulated DOS (integrated or
    guest DOS) instead of the virtual machine in
    DOSBox-X. Also, you could change the default
    setting for this by setting the new "quick
    reboot" config option in "dos" section (Wengier)
  - Added new "Reboot guest system" menu item (under
    "Main") to reboot the kernel of the integrated
    DOS or the guest DOS directly. The previous menu
    item "Reset guest system" has been renamed to
    "Reset virtual machine" which will restart the
    virtual machine in DOSBox-X instead. (Wengier)
  - Added "Reported DOS version" sub-menu (under
    "DOS") to dynamically change the reported DOS
    version (3.3, 5.0, 6.22, 7.1, or custom). This
    may enable/disable long filename (LFN) support
    with the default "lfn=auto" setting. (Wengier)
  - LS is now an external command appearing on drive
    Z: as LS.COM instead of a builtin shell command.
    This avoids name clash with game "Links LS 97"
    which has the main executable named LS.EXE. Also
    fixed minor issues in this command. (Wengier)
  - Fixed the game "Disney's Duck Tales: the Quest
    for Gold" not able to start. (Wengier)
  - Improved Configuration GUI's handling of "4dos"
    and "config" sections. Also added the "Save..."
    button just before the "Close" button. (Wengier)
  - Added "euro" config option (in [render] section)
    to display Euro symbol instead of the specified
    ASCII character in any code page. (Wengier)
  - PC-98 CG MMIO writes fixed to limit writes only
    to the user-defined areas, same as the IO writes.
    This fixes "Niko Niko" that appears to write a
    few too many 0xE1 bytes when filling text
    attribute RAM and into the CG MMIO region.
  - With -winrun command-line option or the setting
    "startcmd=true" (Windows only), you can now
    directly launch Windows programs on mounted local
    or overlay drives to run on the host. The option
    "startwait=false" can be used to disable waiting
    for Windows programs after started. This can also
    be toggled from the "DOS" menu. (Wengier)
  - Added START command to run commands on Windows
    host system. The /MAX, /MIN, /HID options can
    be used to run the specified program maximized,
    minimized, or hidden (they can be shortened to
    +, -, _ respectively). This command is disabled
    by default, but can be enabled by either the
    "startcmd" config option (in [dos] section) or
    the -winrun command-line option (which will also
    enable the CLIP$ device for Windows clipboard
    support). START will run commands listed in the
    "startincon" config option (separated by space)
    in the Windows Command Prompt and wait for a key
    press before exiting. (Wengier)
  - Added SHELL= option to the [config] section in
    dosbox-x.conf to specify an alternative shell,
    e.g. "SHELL=4DOS.COM". (Wengier)
  - Added built-in 4DOS 8.00 shell for 4DOS features
    and capabilities. There is now a [4dos] section
    in the dosbox-x.conf file to act as the 4DOS.INI
    config file if you use this shell. (Wengier)
  - Added "Mouse wheel movements" menu (under "Main")
    to enable or disable the mouse wheel movements
    to arrow (up/down etc) feature. (Wengier)
  - Added "Quick right mouse button copy/paste" menu
    item toggle to allow quick Windows clipboard copy
    and paste via the right mouse button without any
    key modifier that may have been specified by the
    config option "clip_key_modifier". (Wengier)
  - Fixed mounting a directory with command-line like
    "dosbox-x .", and fixed mounting disk images with
    spaces via the "Drive" menu on Windows. (Wengier)
  - Added "mountwarning" config setting so you could
    optionally disable the warning when attempting to
    mount C:\ in Windows or / otherwise. (Wengier)
  - IMGMOUNT now assumes "-fs none" automatically if
    a drive number is specified instead of a drive
    letter. Moreover, it will assume the image file
    name "IMGMAKE.IMG" if no filename is specified by
    the user. Also improved the command's handling of
    El Torito floppy drives, e.g. you can use option
    "-bootcd d" instead of "-el-torito d". (Wengier)
  - IMGMAKE warning replaced to indicate a general
    incompatibility between MS-DOS/SCANDISK and
    cluster sizes 64KB or larger.
  - IMGMAKE command will now use the image file name
    "IMGMAKE.IMG" if no file name is specified (either
    in the mounted local directory or in the DOSBox-X
    program directory if the current directory is not
    a local directory). The command now also supports
    a -force option to force overwrite the image file
    if it already exists. Furthermore, IMGMAKE will
    delete the generated image file if an error occurs
    during the image file creation. (Wengier)
    
0.83.3
  - IMGMAKE can now generate FAT12, FAT16, and FAT32
    filesystems. New option "-fat" is added to select
    the filesystem for the disk image.
  - Fixed command-line like "./dosbox-x /dir/app.bat"
    not able to launch the specified program (Wengier)
  - Fixed bug in DIR command's /P option which might
    cause it to not work properly. (Wengier)
  - The default key modifier for the Windows clipboard
    copy & paste via the right mouse button feature is
    now "shift" instead of "disabled". (Wengier)
  - Single-stepping in the debugger with the 286 and
    8086 normal cores now works correctly when stepping
    over instructions with a segment prefix.
  - Pentium MMX instructions now only available for
    Pentium MMX or higher. Fixed the bug that allowed
    MMX instructions for Pentium and lower if programs
    ignored the CPUID feature bits. Also fixed Pentium
    MMX instructions so that they work in both 16-bit
    real mode and 32-bit protected mode to match how
    they work in real hardware (joncampbell123)
  - Updated DOSBox-X's implementation for Pentium MMX
    instructions to latest version by kekko (Wengier)
  - DOSBox-X will try to automatically run the program
    with LOADFIX if the error message "Packed file is
    corrupt" is detected. (Wengier)
  - MOUNT command can now mount a drive to the UNC
    root path in the form \\ComputerName\SharedFolder
    on Windows systems. (Wengier)
  - Improved the HX-DOS build package to make it fully
    automated: all required HX DOS Extender files will
    be included in the package, and dosbox-x.exe can
    now be run directly in a real DOS system without
    external requirements. (Wengier)
  - Fixed incorrect frame rate reported by 3Dfx Voodoo
    emulation (rderooy, backported from DOSBox SVN).
  - Added the "Boot from disk image" menu item (A:, C:,
    and D: drives only) in the "Drive" menu to boot the
    specified disk image directly in Windows. (Wengier)
  - Support for converting mouse wheel movements into
    keyboard presses like arrow keys, configurable by
    the option "mouse_wheel_key" (default is 0 which
    disables this feature). When set to 1, mouse wheel
    movements are converted to up/down arrows. Setting
    it to 2 or 3 converts such movements to left/right
    arrows or PageUp/PageDn keys respectively. (Wengier)
  - Support for reloading the keyboard mapper file with
    the config -set command. (Wengier)
  - IMGMOUNT command without parameters will show disk
    names for drive-number only mounts. (Wengier)
  - IMGMOUNT can now autodetect DOS <= 3.21 harddisk
    geometry with MFM sector images (rderooy & Wengier)
  - IMGMOUNT -fs none fixed to use same geometry detect
    function that FAT filesystem mounting uses.
  - Added suppprt for mounting overlay drives using MOUNT
    command with "-t overlay" option. Backported from
    DOSBox SVN and adopted for DOSBox-X with additional
    features such as long filename and PC-98 support, it
    allows the users to redirect new and changed file(s)
    to a different location transparently. (Wengier)
  - Cleaned up the DPI awareness auto-detection code to
    allow Visual Studio builds to again run on Windows 7.
    Meanwhile, MinGW builds (either SDL1 or SDL2 version)
    are still required for Windows XP systems. (Wengier)
  - Updated Nuked OPL3 to latest version 1.8 for accurate
    OPL3 emulation (Wengier)
  - Added AUTOTYPE command to perform scripted keyboard
    entry into a running DOS program or game. Ported from
    DOSBox-staging, it can be used to reliably skip intro,
    provide input to answer initial startup or config
    questions, or conduct a simple demo. (Wengier)
  - Added code page 866 (Cyrillic Russian) to support
    host to guest code page mapping (tuffnatty)
  - Mouse buttons (left, middle, right) can now be mapped
    to keys in the keyboard mapper. (Wengier)
  - Support for mounting .cue files with MP3/OGG/WAV/FLAC
    compressed audio tracks. (Wengier) 
  - Rewrote the Windows installer for DOSBox-X, as well as
    the building script for the installer. All required
    build tools including the Inno Setup Compiler are now
    provided in the repository and will be automatically
    called by the building script. (Wengier)
  - Added config option "mapperfile_sdl2" for SDL2 builds.
    SDL1 and SDL2 builds of DOSBox-X can not use the same
    mapper file, or they will likely malfunction. Adding
    this option allows SDL1 and SDL2 builds of DOSBox-X
    to work with the same dosbox-x.conf file. (Wengier)
  - Added GUI menu option under "DOS" to change the long
    filename setting (enable, disable, or auto). (Wengier)
  - Improvements and fixes to the save/load state feature:
    It now supports Sound Blaster Goldplay mode;
    It now saves PC-98 FM interrupt state so that reloading
    state does not cause hung music;
    It is also fixed not to crash when used within a guest
    operating system (when the DOS kernel has been shut down
    using the BOOT command);
    It now supports memory size up to 1GB;
    It will save and verify the DOSBox-X version and build.
    States saved by DOSBox-X in one platform (e.g. 64-bit
    Windows) may not work in another (e.g. 32-bit Linux).
    The GUI menu will show if the save slot is empty, and if
    not the program name of save state will be displayed.
  - Re-ported and improved the save state feature for saving
    and loading states with support for up to 10 save slots.
    They can be selected from the "Capture" menu. (Wengier)
  - Added COUNTRY command to set country code for country-
    specific date and time formats. For example, the command
    "COUNTRY 61" sets the country code to 61 (International
    English) which uses the DD-MM-YYYY date format instead
    of the default (U.S.) MM-DD-YYYY date format. (Wengier)
  - DOS 440Dh IOCTL function 67h (get access flag) added to
    allow FDISK.EXE to determine FAT filesystem type. Also
    implemented function 40h (set device parameters) and
    function 46h (set volume serial number). (Wengier)
  - Unknown DOS 440Dh IOCTLs warnings now indicate whether
    triggered by call or query.
  - S3 VESA BIOS mode number for 1024x768 32bpp changed to
    avoid conflict with Windows 95 S3 driver and 800x600
    16bpp mode.
  - FAT driver no longer mounts FAT32 volumes unless the
    DOS version is 7.1 or higher, and it no longer mounts
    FAT16B LBA volumes unless the DOS version is 7.0 or
    higher. These are to mimic the MS-DOS behavior.
  - Fixed FAT driver not to attempt to mount partitions that
    have nothing to do with the FAT filesystem (such as
    type 0Dh and extended LBA partition tables). Also fixed
    the FAT driver to not assume partition start sector 63
    if it cannot identify a partition to use.
  - Added code to FAT driver to identify telltale pattern
    left by Microsoft FDISK when a partition is created (but
    not yet formatted) and reject.
0.83.2
  - Added help messages for some supported commands. (Wengier)
  - Added phone book support for the emulated modem. There is
    a new phonebookfile= option in the [serial] section. The
    phone book file entries need to be in the format of:
    "<dummy number> <hostname/ip:port>" e.g.
    5551234 cavebbs.homeip.net:23
    Thank NicknineTheEagle for implementing this feature.
  - Implemented the missing EMS subfunctions 52h and 59h by
    porting the patch that adds them (Wengier)
  - Fixed issues with the "config -wcd -all" command and other
    updates to the CONFIG command (Wengier)
  - Added [config] section in dosbox-x.conf to resemble DOS's
    CONFIG.SYS file. It currently supports REM, BREAK, NUMLOCK,
    FCBS, FILES, DOS, DEVICE/DEVICEHIGH, INSTALL/INSTALLHIGH,
    SET and LASTDRIVE commands. The file CONFIG.SYS will appear
    on the Z: drive, similar to AUTOEXEC.BAT file. The [config]
    section can be bypassed with the -noconfig command-line
    option or with the secure mode enabled (Wengier)
  - Moved PC-98 related config options (starting with "pc-98 ")
    from [dosbox] and [dos] sections to its own [pc98] section.
    These options in existing dosbox-x.conf/dosbox.conf files
    will be automatically redirected to the [pc98] section from
    the other sections when DOSBox-X starts (Wengier)
  - The user directory DOSBox-X uses has been changed to use the
    DOSBox-X directory (e.g. from ~/.dosbox to ~/.config/dosbox-x
    on Linux platform). It will be read *after* the dosbox-x.conf
    file in the current directory (Wengier)
  - Config option "dpi aware" now supports the "auto" setting
    to auto-decide on the best setting for the platform. This
    fixes very small window issue on high DPI devices such as
    Microsoft Surface tablets. (Wengier)
  - Added DTASEG, DTAOFF, and PSPSEG as hex value constants to
    the debugger interface to aid in debugging DOS programs.
  - New command-line option -helpdebug added to list debug-
    related command-line options. The standard -? / -h / -help
    command-line option will no longer list them (Wengier)
  - Implemented LFN support for FAT driver, so that it is now
    possible to view directory list, create or open files and
    directories etc with long filenames on FAT12/16/32 drives
    just like on mounted local drives.
  - FAT driver cleaned up and fixed to avoid edge cases that
    can corrupt directory entries and leave lost clusters
    on the disk, also fixed to always report root directory
    as a directory through the GetFileAttribute INT 21h call,
    needed by MOVE.EXE and XCOPY.EXE to work properly.
  - IMGMOUNT auto geometry detection will assume LBA disk
    and fake C/H/S geometry if the disk is 4GB or larger,
    the MBR lacks executable code, or the first partition
    is Windows 98-style LBA FAT16 or FAT32.
  - IMGMOUNT now assumes ISO type by default if the image file
    extension is .iso/.cue/.bin/.mdf. No need for "-t iso" in
    this case; but (if applicable) it can be overridden by for
    example "-t hdd". (Wengier)
